{  ColorPicked(canvas.brush.color);}
{*************************************************************
AffectsForm ...Grafree Delphi 5 2001 Ivan Lee Herring
combined from many of the gfx_..Ctrl files and JansFX

Unit gfx_FilterCtrl.PAS v1.0
    (c) by Andreas Moser, amoser@amoser.de,
    Delphi version : Delphi 4
    gfx_Filterctrl is part of the gfx_library collection
    You may use this sourcecode for your freewareproducts.
    You may modify this source-code for your own use.
    You may recompile this source-code for your own use.
    All functions, procedures and classes may NOT be used in commercial
    products without the permission of the author. For parts of this library
    which are not written by me, you have to ask for permission by their
    respective authors.
    Disclaimer of warranty: "This software is supplied as is. The author
    disclaims all warranties, expressed or implied, including, without
    limitation, the warranties of merchantability and of fitness for any
    purpose. The author assumes no liability for damages, direct or
    consequential, which may result from the use of this software."
    All brand and product names are marks or registered marks of their
    respective companies.
    Please report bugs to:
    Andreas Moser  amoser@amoser.de
********************************************************************************}
unit AffectsFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Menus,Math,
  Graphics, Controls, Forms, Dialogs, Buttons,
  ExtCtrls, StdCtrls, Mask, ExtDlgs, ComCtrls, Spin,
  AgfxEffects, AgfxRotresize, AgfxCrypt,
  AgfxBasedef, AgfxMasks, AgfxEffectex, AgfxTool,
  AjanFX2K, jvAirBrush;
{'grafxgb.txt' needed in program directory}
type
  TAffectsForm = class(TForm)
    PageControl1: TPageControl;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SolarizeTS: TTabSheet;
    SolEdit: TEdit;
    SolTrackBar: TTrackBar;
    Label13: TLabel;
    ColorTS: TTabSheet;
    SolRG: TRadioGroup;
    EffectRG: TRadioGroup;
    EffectEdit: TEdit;
    Label14: TLabel;
    EffectTrackBar: TTrackBar;
    EffectPanel: TPanel;
    PageControl2: TPageControl;
    HSLSheet: TTabSheet;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    HSLHueSE: TSpinEdit;
    HSLSatSE: TSpinEdit;
    HSLLitSE: TSpinEdit;
    RGBSheet: TTabSheet;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    BlueSpin: TSpinEdit;
    GreenSpin: TSpinEdit;
    RedSpin: TSpinEdit;
    GammaSheet: TTabSheet;
    Shape1: TShape;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Image1: TImage;
    Label41: TLabel;
    GammaEdit: TEdit;
    ContrastSheet: TTabSheet;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    BCLightSE: TSpinEdit;
    BCConSE: TSpinEdit;
    RotateTS: TTabSheet;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    RotatePreviewBtn: TButton;
    RotateColor: TButton;
    Label48: TLabel;
    RotYEdit: TEdit;
    RotXEdit: TEdit;
    Label49: TLabel;
    EnlCanv: TCheckBox;
    ValueGroup: TRadioGroup;
    DegreeEdit: TEdit;
    Label50: TLabel;
    ColorDialog1: TColorDialog;
    ScrollBox1: TScrollBox;
    PreviewImage: TImage;
    InitializeRotateBtn: TButton;
    ColorApplyBtn: TButton;
    RedTrack: TTrackBar;
    GreenTrack: TTrackBar;
    BlueTrack: TTrackBar;
    BCLight: TTrackBar;
    BCCon: TTrackBar;
    GammaTrack: TTrackBar;
    HSLHue: TTrackBar;
    HSLSat: TTrackBar;
    HSLLit: TTrackBar;
    SwapPlanesRG: TRadioGroup;
    RotateApply: TButton;
    Button1: TButton;
    SolCancel: TButton;
    EffectCancel: TButton;
    SolOK: TButton;
    EffectOK: TButton;
    RotateTrackBar: TTrackBar;
    TabSheet1: TTabSheet;
    FilterTS: TTabSheet;
    PageControl3: TPageControl;
    LinearTS: TTabSheet;
    UserSheet: TTabSheet;
    TwoPassSheet: TTabSheet;
    Label10: TLabel;
    PreviewBtn: TButton;
    ApplyBtn: TButton;
    CancelBtn: TButton;
    ListBox1: TListBox;
    Label11: TLabel;
    NewLin: TButton;
    DelLinear: TButton;
    ListBox2: TListBox;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    cbIntensity: TCheckBox;
    LinearCSRG: TRadioGroup;
    Shape2: TShape;
    Label12: TLabel;
    SpeedButton8: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton5: TSpeedButton;
    UserRG: TRadioGroup;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    MaskEdit1: TEdit;
    MAskEdit2: TEdit;
    MirrorTopBotCB: TCheckBox;
    MirrorLefRigCB: TCheckBox;
    UserOpenBtn: TButton;
    UserSaveBtn: TButton;
    UserPreBtn: TButton;
    UserApplyBtn: TButton;
    TwoPass: TListBox;
    MultNrPass: TRadioGroup;
    FilterCombo1: TComboBox;
    Funct1: TComboBox;
    FilterCombo2: TComboBox;
    Funct2: TComboBox;
    FilterCombo3: TComboBox;
    Funct3: TComboBox;
    FilterCombo4: TComboBox;
    Label6: TLabel;
    Label9: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label3: TLabel;
    MultOpenBtn: TButton;
    MultSaveBtn: TButton;
    MultPreBtn: TButton;
    MultApplyBtn: TButton;
    WandaTS: TTabSheet;
    MagicWand2: TCheckBox;
    WandTrackBar: TTrackBar;
    WandColorBtn: TBitBtn;
    WandCoB: TComboBox;
    MagicWandCB: TCheckBox;
    RefreshBtn: TButton;
    AboutBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    cybar: TScrollBar;
    cybarLabel: TLabel;
    cxbarLabel: TLabel;
    cxbar: TScrollBar;
    extrabar: TScrollBar;
    extrabarLabel: TLabel;
    EBar: TScrollBar;
    ETree: TTreeView;
    SmoreRefresh: TButton;
    SmoreApply: TButton;
    TabSheet2: TTabSheet;
    FlippantChoicesRG: TRadioGroup;
    Button5: TButton;
    Flipper: TButton;
    Button3: TButton;
    Button6: TButton;
    Button4: TButton;
    Button7: TButton;
    Button11: TButton;
    FlippantPreview: TButton;
    FlippantApply: TButton;
    LightWandCB: TCheckBox;
    Button2: TButton;
    WandPainterRG: TRadioGroup;
    WandSrcRG: TRadioGroup;
    AirPanel: TPanel;
    StarsEdit: TEdit;
    StarsUpDown: TUpDown;
    AirTenEdit: TEdit;
    AirTenUpDown: TUpDown;
    AirSizeEdit: TEdit;
    AirSizeUpDown: TUpDown;
    cboShapes: TComboBox;
    cbopw: TComboBox;
    jvAirBrush: TjvAirBrush;
    PopupMenu1: TPopupMenu;
    Airbrush1: TMenuItem;
    Gadget1: TMenuItem;
    N1: TMenuItem;
    Refresh1: TMenuItem;
    Apply1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    N2: TMenuItem;
    BlenderTrackBar: TTrackBar;
    EncryptBtn: TButton;
    DecryptBtn: TButton;
    CryptKeeper: TEdit;
    StarPointsEdit: TEdit;
    StarPointsUpDown: TUpDown;
    BlocksEdit: TEdit;
    BlocksUpDown: TUpDown;
    SpiralsEdit: TEdit;
    SpiralsUpDown: TUpDown;
    ACPanel: TPanel;
    AirShape: TShape;
    TabSheet3: TTabSheet;
    redradio: TRadioButton;
    greenradio: TRadioButton;
    blueradio: TRadioButton;
    qbpresets: TComboBox;
    Bevel1: TBevel;
    QBList: TListBox;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    trkred: TScrollBar;
    trkgreen: TScrollBar;
    trkblue: TScrollBar;
    trkfactor: TScrollBar;
    presetspop: TPopupMenu;
    AddBackdrop1: TMenuItem;
    DeleteBackdrop1: TMenuItem;
    UpdateBackdrop1: TMenuItem;
    N3: TMenuItem;
    Apply2: TMenuItem;
    Exit1: TMenuItem;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    procedure MakeEditFields(Filter:TGraphicFilter);
    procedure EditChanged(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UserRGClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure PreviewBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
    procedure LinearCSRGClick(Sender: TObject);
    procedure FilterCombo2Change(Sender: TObject);
    procedure Funct1Change(Sender: TObject);
    procedure MultNrPassClick(Sender: TObject);
    procedure NewLinClick(Sender: TObject);
    procedure UserSaveBtnClick(Sender: TObject);
    procedure RotateMatrix(Steps:Integer);
    procedure MirrorTopBotCBClick(Sender: TObject);
    procedure UserOpenBtnClick(Sender: TObject);
    procedure SolTrackBarChange(Sender: TObject);
    procedure SolEditKeyPress(Sender: TObject; var Key: Char);
    procedure SolOKClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure EffectRGClick(Sender: TObject);
    procedure EffectEditKeyPress(Sender: TObject; var Key: Char);
    procedure EffectTrackBarChange(Sender: TObject);
    procedure EffectOKClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure GammaTrackChange(Sender: TObject);
    procedure GammaEditKeyPress(Sender: TObject; var Key: Char);
    procedure RedTrackChange(Sender: TObject);
    procedure RedSpinChange(Sender: TObject);
    procedure HSLHueSEChange(Sender: TObject);
    procedure ValueGroupClick(Sender: TObject);
    procedure EnlCanvClick(Sender: TObject);
    procedure RotateColorClick(Sender: TObject);
    procedure RotatePreviewBtnClick(Sender: TObject);
    procedure InitializeRotateBtnClick(Sender: TObject);
procedure CenterEditChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DegreeEditChange(Sender: TObject);
    procedure BCLightChange(Sender: TObject);
    procedure BCConSEChange(Sender: TObject);
    procedure HSLHueChange(Sender: TObject);
    procedure SwapPlanesRGClick(Sender: TObject);
    procedure RotateApplyClick(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure DelLinearClick(Sender: TObject);
    procedure RotateTrackBarChange(Sender: TObject);
    procedure FlipperClick(Sender: TObject);
    procedure EncryptBtnClick(Sender: TObject);
    procedure DecryptBtnClick(Sender: TObject);
    procedure WandColorBtnClick(Sender: TObject);
    procedure RefreshBtnClick(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure ETreeClick(Sender: TObject);
    procedure EBarChange(Sender: TObject);
    procedure MagicWand2Click(Sender: TObject);
    procedure MagicWandCBClick(Sender: TObject);
    procedure FlippantPreviewClick(Sender: TObject);
    procedure FlippantApplyClick(Sender: TObject);
    procedure SmoreApplyClick(Sender: TObject);
    procedure LightWandCBClick(Sender: TObject);
    procedure AirTenUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure AirSizeUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure cboShapesClick(Sender: TObject);
    procedure cbopwClick(Sender: TObject);
    procedure Airbrush1Click(Sender: TObject);
procedure selectShape(Ashape:string);
    procedure Gadget1Click(Sender: TObject);

procedure mypaintESC(x,y:integer;shift:tshiftstate);
    procedure PreviewImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PreviewImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PreviewImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StarsUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure StarPointsUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure BlocksUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure SpiralsUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure PageControl1Change(Sender: TObject);
    procedure ACPanelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AirShapeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
      {QB}
    procedure QBListClick(Sender: TObject);
    procedure qbpresetsDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure qbpresetsClick(Sender: TObject);
    procedure AddBackdrop1Click(Sender: TObject);
    procedure DeleteBackdrop1Click(Sender: TObject);
    procedure trkredChange(Sender: TObject);
    procedure trkgreenChange(Sender: TObject);
    procedure trkblueChange(Sender: TObject);
    procedure trkfactorChange(Sender: TObject);
    procedure UpdateBackdrop1Click(Sender: TObject);
    procedure redradioClick(Sender: TObject);
    procedure greenradioClick(Sender: TObject);
    procedure blueradioClick(Sender: TObject);
procedure setQBFuncs;
procedure setlabels;
procedure QuickBack;
    procedure Exit1Click(Sender: TObject);
  private
    {ImgTemp,myclip in Globals instead}
    {myClip:TBitmap; }
    SwapMode:TSwapPlanes;
    procedure RGBClick;
    procedure LigCont;
    procedure bar(max, min, pos: integer);
  public
    { Published declarations }
{    property Shapes:TStringlist read FShapes;
    property Shape:String read myshape write SetShape;
    property polygonchecked:boolean read Fpolygonchecked write Setpolygonchecked;
    property onColorPicked:TColorPicked read FonColorPicked write SetonColorPicked;}

    ResultBitmap:TBitmap;
    Gamma:Double;
    WandingOn, Processing:Boolean;
    { Public declarations }
    function strtoquickback(s:string):boolean;
{    procedure setDrawImage(aDrawImage:TjandrawImage);}
  end;

var
  AffectsForm: TAffectsForm;
  EditArray:Array [0..48] of TEdit;{Filter 7x7 #s}
  ActFilter:TGraphicFilter;
  BckMatrix:TEffectMatrix;
  ActTwoPassFilter:TMultiPassGraphicFilter;
  r,g,b:Boolean;
  eMode:TColorSpace;
  QBFile:string;
  QBDRed,QBDBlue,QBDGreen:byte;

Const TwoPassFilters: Array [1..cnt_predefined_multipass] of record
     Filter:^TMultiPassGraphicFilter;
     end =(
     (Filter:@nmxLaplacianInvert),
     (Filter:@nmxChurchPattern));

Const LinearFilters: Array [1..cnt_predefined_linflt] of record
     Filter:^TGraphicFilter;
     end =(
     (Filter:@mxAverage),
     (Filter:@mxEdgesStrong),
     (Filter:@mxEdgesWeak),
     (Filter:@mxEdgeEnhance),
     (Filter:@mxEmbossColor),
     (Filter:@mxEmbossLight),
     (Filter:@mxEmbossMedium),
     (Filter:@mxEmbossDark),
     (Filter:@mxEtch),
     (Filter:@mxBlur),
     (Filter:@mxBlurSoftly),
     (Filter:@mxBlurMore),
     (Filter:@mxBlurBartlett),
     (Filter:@mxBlurGaussian),
     (Filter:@mxGlow),
     (Filter:@mxLaplacianHV),
     (Filter:@mxLaplacianOmni),
     (Filter:@mxMaximum),
     (Filter:@mxMinimum),
     (Filter:@mxMedian),
     (Filter:@mxNegative),
     (Filter:@mxPrewitt),
     (Filter:@mxSharpen),
     (Filter:@mxSharpenMore),
     (Filter:@mxSharpenLess),     
     (Filter:@mxSharpenDirectional),
     (Filter:@mxSobelPass),
     (Filter:@mxUnSHarpMask),
     (Filter:@mxTraceContour),
     (Filter:@mxWaggle),
     (Filter:@mxPattern),
     (Filter:@mxZero));

const Functions:Array[0..10] of string =
      ('None',
       'Add',
       'Substract',
       'Multiply',
       'Divide',
       'Darkest',
       'Lightest',
       'Difference',
       'Binary Or',
       'Binary And',
       'Average');

implementation

uses TongGlobals, Afillunit, TongsFrm;
{$R *.DFM}

type
TColorProc= function (outloop,inloop:integer):integer;

var
  RedBack,GreenBack,BlueBack:TcolorProc;
  QBFuncs:array [0..50] of TcolorProc;
  ImgDrawFactor: byte;
  QBRedfn,QBGreenfn,QBBluefn:integer;
  {appldir:string;}

procedure TAffectsForm.FormDestroy(Sender: TObject);
begin
{  SrcBitmap.free;
  DestBitmap.Free;}
  myClip.Free;
  ResultBitmap.Free;
end;
procedure TAffectsForm.Exit1Click(Sender: TObject);
begin
  close;
end;
procedure TAffectsForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DegreeEdit.OnChange:=nil;
  RotXEdit.OnChange:=nil;
  RotYEdit.OnChange:=nil;
  AffectsFormX := AffectsForm.left;
  AffectsFormY:= AffectsForm.top;
{  ModalResult:=mrCancel;}
end;

procedure TAffectsForm.FormShow(Sender: TObject);
begin
  left := AffectsFormX;
  top := AffectsFormY;
AirPanel.Align:=alNone;
PageControl1.Align:=alNone;
ScrollBox1.Align:=alNone;
If   AirPanel.Visible then   AirPanel.Align:=alTop;
If  PageControl1.Visible then   PageControl1.Align:=alLeft;
ScrollBox1.Align:=alClient;
{AffectsForm 516W     402H
AirPanel  508W   25H          alTop
PageControl1     249W 349H    alLeft
ScrollBox1 259W 349H          alClient   }
setlabels;{QB}
end;

procedure TAffectsForm.Airbrush1Click(Sender: TObject);
begin
  Airbrush1.Checked:= (not Airbrush1.Checked);
  AirPanel.Visible:= Airbrush1.Checked;
AirPanel.Align:=alNone;
PageControl1.Align:=alNone;
ScrollBox1.Align:=alNone;
If   AirPanel.Visible then   AirPanel.Align:=alTop;
If  PageControl1.Visible then   PageControl1.Align:=alLeft;
ScrollBox1.Align:=alClient;
end;

procedure TAffectsForm.Gadget1Click(Sender: TObject);
begin
  Gadget1.Checked:= (not Gadget1.Checked);
  PageControl1.Visible:= Gadget1.Checked;
AirPanel.Align:=alNone;
PageControl1.Align:=alNone;
ScrollBox1.Align:=alNone;
If   AirPanel.Visible then   AirPanel.Align:=alTop;
If  PageControl1.Visible then   PageControl1.Align:=alLeft;
ScrollBox1.Align:=alClient;
end;

procedure TAffectsForm.FormActivate(Sender: TObject);
begin
  SolTrackBarChange(self);
  jvAirBrush.Color := ACPanel.Color;
  PreviewImage.Picture.Bitmap.canvas.Pen.Color :=
      AirShape.Pen.Color;
  PreviewImage.Picture.Bitmap.canvas.brush.Color :=
      AirShape.brush.Color;
end;

procedure TAffectsForm.AboutBtnClick(Sender: TObject);
begin
showmessage('Goat Clusters Delivered Locally'+#13#10+
            'See Help for Closest Address'); 
end;

procedure TAffectsForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(14000);
end;
(******************************************************)
(******************************************************)
procedure TAffectsForm.FormCreate(Sender: TObject);
var k,i:Integer;
begin
  Processing:=False;
  myClip:=TBitmap.Create;
  myClip.PixelFormat:=MyPixelFormat;
  RotXEdit.Text:=IntToStr(TongsForm.Image1.Picture.Bitmap.Width div 2);
  RotYEdit.Text:=IntToStr(TongsForm.Image1.Picture.Bitmap.Height div 2);
  DegreeEdit.Text:='45';
{  RotateTrackBar.Position:=45;}
{Color stuff}
  DecimalSeparator:='.';
  HSLHueSE.Value:=HSLHue.Position;
  HSLSatSE.Value:=HSLSat.Position;
  HSLLitSE.Value:=HSLLit.Position;
  Gamma:=1;
  SwapMode:=swapNone;{Commented out.. no changes}
  {Gamma chart}
  Image1.Picture.Bitmap.Width:=Image1.Width;
  Image1.Picture.Bitmap.Height:=Image1.Height;
  Image1.Picture.Bitmap.Canvas.MoveTo(0,Image1.Height-1);
  Image1.Picture.Bitmap.Canvas.Brush.Color:=clWhite;
  Image1.Picture.Bitmap.Canvas.FillRect(Image1.ClientRect);
  for i:=1 to 255 do
  begin
    k:=IntGamma(Gamma,i);
    Image1.Picture.Bitmap.Canvas.LineTo(i div 2,Image1.Height-( k div 2)-1);
  end;
  Image1.Repaint;
  GammaEdit.Text:=FloatToStr(Gamma);

{Filter stuff}
  ResultBitmap:=tBitmap.Create;
  r:=true;
  g:=true;
  b:=true;
  Panel1.Caption:='';
  Panel1.Width:=230;{290}
  Panel1.Height:=245;
  for i:=0 to 48 do
  begin
   EditArray[i]:=TEdit.Create(Panel1);
   EditArray[i].Parent:=Panel1;
   EditArray[i].Width:=30;
   EditArray[i].Height:=21;
   EditArray[i].Left:=((i div 7) * 30)+5;
   EditArray[i].Top:=((i mod 7) * 20)+5;
    //  EditArray[i].OnChange:=EditChanged;
   EditArray[i].Visible:=false;
  end;
  for i:=0 to 48 do ActFilter.Matrix[i div 7,i mod 7]:=0;
  ActFilter.MatrixSize:=mx3;
  ActFilter.Divisor:=1;
  ActFilter.Bias:=0;
  MakeEditFields(ActFilter);

  for i:=1 to 4 do ActTwoPassFilter.Filters[i]:=nil;
  ListBox1.Items.Clear;
  TwoPass.Items.Clear;

  For i:=1 to cnt_predefined_linflt do begin
    ListBox1.Items.AddObject(LinearFilters[i].Filter^.FilterName,@LinearFilters[i].Filter);
    FilterCombo1.Items.Add(LinearFilters[i].Filter^.FilterName);
    FilterCombo2.Items.Add(LinearFilters[i].Filter^.FilterName);
    FilterCombo3.Items.Add(LinearFilters[i].Filter^.FilterName);
    FilterCombo4.Items.Add(LinearFilters[i].Filter^.FilterName);
  end;
  For i:=0 to 10 do begin
    Funct1.Items.Add(Functions[i]);
    Funct2.Items.Add(Functions[i]);
    Funct3.Items.Add(Functions[i]);
  end;
{    ListBox1.Items.Add('Null');
    FilterCombo1.Items.Add('Null');
    FilterCombo2.Items.Add('Null');
    FilterCombo3.Items.Add('Null');
    FilterCombo4.Items.Add('Null'); }
  For i:=1 to cnt_predefined_multipass do
  TwoPass.Items.Add(TwoPassFilters[i].Filter^.FilterName);
WandingOn:=False;

  TargetPoint:=point(0,0);
  NSpiro:=40;
  RangeTransColor:=clwhite;
  zoomrect:=rect(0,0,50,50);
  mycliprect:=rect(0,0,256,256);
stars:=3;
starpoints:=6;
blocks:=24;
spirals:=3;
spiralfactor:=0.99;
  spiraldir:=1;
  // tolerance for straight line drawing
  myslinetol:=5;
    mypenstyle:=pssolid;
// rounding of roundrect
  myround:=10;
    TraceB:=$00;
freepolycount:=0;
myshape:='line';
mydraw:=False;
polygonchecked:=False;
bezierfix1:=False;
bezierfix2:=False;
fillgonio;
fillSinPixs;
{QB Stuff}
ImgDrawFactor:=255;
QBDRed:=0;
QBDBlue:=0;
QBDGreen:=0;
QBRedfn:=0;
QBGreenfn:=0;
QBBluefn:=0;
SetQBFuncs;

QBFile:=ExtractFilePath(ParamStr(0))+'grafxgb.txt';
if fileexists(QBFile) then
 qbpresets.Items.LoadFromFile(QBfile)
 else
 begin
 qbpresets.Items.Add('Angles=38,38,38,176,209,34,16');
 qbpresets.Items.Add('Blinds 2=9,6,9,229,183,0,50');
 qbpresets.Items.Add('Blinds Red=0,6,35,63,39,255,30');
 qbpresets.Items.Add('Blinds=9,6,9,62,0,209,77');
 qbpresets.Items.Add('Blue diagonal=1,22,19,0,0,0,255');
 qbpresets.Items.Add('Blue Grid=0,6,29,255,0,0,19');
 qbpresets.Items.Add('Blue Shading=19,21,23,255,0,0,16');
 qbpresets.Items.Add('Border Worlds=17,2,18,0,0,0,255');
 qbpresets.Items.Add('Caleidos=29,29,29,53,183,169,106');
 qbpresets.Items.Add('CheckerBoard=0,6,29,0,0,240,33');
 qbpresets.Items.Add('Columns Red=1,22,19,5,0,0,255');
 qbpresets.Items.Add('Columns=9,6,9,27,99,38,77');
 qbpresets.Items.Add('Construction=10,4,27,0,25,102,16');
 qbpresets.Items.Add('Day and Night=17,2,2,0,0,0,91');
 qbpresets.Items.Add('Escher=17,29,36,255,240,255,45');
 qbpresets.Items.Add('Evening=17,1,18,0,0,0,255');
 qbpresets.Items.Add('First Light=29,29,29,7,255,255,164');
 qbpresets.Items.Add('Flyer=30,31,32,53,123,74,184');
 qbpresets.Items.Add('Gold Field=0,29,29,48,139,219,16');
 qbpresets.Items.Add('Gold of Green=9,37,9,31,46,51,16');
 qbpresets.Items.Add('Gold=29,29,29,53,183,224,32');
 qbpresets.Items.Add('Golden Temple=29,37,29,53,0,169,45');
 qbpresets.Items.Add('Gray Horizontal=17,17,17,0,0,0,255');
 qbpresets.Items.Add('Gray Shading 2=19,21,23,255,255,255,16');
 qbpresets.Items.Add('Gray shading=20,22,24,255,255,255,16');
 qbpresets.Items.Add('Gray Vertical=18,18,18,0,0,0,255');
 qbpresets.Items.Add('Green Diagonal=24,1,19,0,0,0,255');
 qbpresets.Items.Add('Green Field=0,3,29,0,62,0,16');
 qbpresets.Items.Add('Green Shading=19,21,23,0,255,0,16');
 qbpresets.Items.Add('Grid 2=28,28,28,79,58,62,27');
 qbpresets.Items.Add('Grid Green Triangles=17,32,36,255,246,255,16');
 qbpresets.Items.Add('Grid Red Dots=17,7,34,0,0,252,16');
 qbpresets.Items.Add('Grid=28,28,28,39,255,0,16');
 qbpresets.Items.Add('Honey=16,3,28,0,127,92,16');
 qbpresets.Items.Add('Kings 2=17,4,13,0,121,76,69');
 qbpresets.Items.Add('Kings Curtain=17,4,13,87,121,177,151');
 qbpresets.Items.Add('Kings=17,4,18,0,108,76,69');
 qbpresets.Items.Add('Lace Squares=39,33,39,139,190,44,59');
 qbpresets.Items.Add('Lace Triangles=39,30,39,34,115,128,82');
 qbpresets.Items.Add('Lace=39,39,39,0,0,0,96');
 qbpresets.Items.Add('Maderna=20,35,31,0,0,0,16');
 qbpresets.Items.Add('Matras Diagonal=9,2,18,152,110,0,16');
 qbpresets.Items.Add('Matras Grid=0,2,29,255,197,31,16');
 qbpresets.Items.Add('Matras=17,31,36,255,159,255,45');
 qbpresets.Items.Add('Maze Gold=28,29,29,72,156,187,45');
 qbpresets.Items.Add('Mist Blue=20,22,27,255,255,0,16');
 qbpresets.Items.Add('Moir=17,0,18,0,0,0,255');
 qbpresets.Items.Add('Moir2=17,11,18,0,0,0,255');
 qbpresets.Items.Add('Morning=1,5,18,0,0,0,255');
 qbpresets.Items.Add('Mosaic=10,4,27,229,190,0,16');
 qbpresets.Items.Add('Neon=10,7,9,46,110,57,38');
 qbpresets.Items.Add('Out of Dark=17,4,18,0,0,0,255');
 qbpresets.Items.Add('Pyramid=16,25,26,154,121,97,16');
 qbpresets.Items.Add('Red Cells=10,7,28,0,0,238,16');
 qbpresets.Items.Add('Red Diagonal=23,22,1,0,0,0,255');
 qbpresets.Items.Add('Red Grid=0,6,29,255,0,240,19');
 qbpresets.Items.Add('Red Grid=16,23,28,0,0,0,16');
 qbpresets.Items.Add('Red Shading=19,21,23,0,0,255,16');
 qbpresets.Items.Add('Sea View 2=17,9,17,0,161,87,118');
 qbpresets.Items.Add('Sea View=17,16,17,0,161,44,118');
 qbpresets.Items.Add('Space=12,13,12,92,38,100,22');
 qbpresets.Items.Add('Squares 2=9,8,3,221,0,248,16');
 qbpresets.Items.Add('Squares=9,8,3,0,0,248,16');
 qbpresets.Items.Add('Stage=30,30,30,0,44,60,200');
 qbpresets.Items.Add('Stairs=9,26,33,84,0,248,64');
 qbpresets.Items.Add('Tapistrie 2=17,3,18,0,0,0,203');
 qbpresets.Items.Add('Tapistrie 3=3,3,2,4,0,80,118');
 qbpresets.Items.Add('Tapistrie 4=3,3,2,4,53,80,172');
 qbpresets.Items.Add('Tapistrie 5=3,3,2,4,53,80,226');
 qbpresets.Items.Add('Tapistrie=17,3,18,0,0,0,255');
 qbpresets.Items.Add('Tartan=12,13,12,108,43,255,22');
 qbpresets.Items.Add('Tonal=17,9,25,199,139,156,255');
 qbpresets.Items.Add('Transition 4-color=19,8,16,255,0,0,255');
 qbpresets.Items.Add('Transition Blue-Green=19,22,23,255,255,0,16');
 qbpresets.Items.Add('Transition Blue-red=19,21,24,255,0,255,16');
 qbpresets.Items.Add('Transition Gold-Blue=20,21,23,255,255,255,16');
 qbpresets.Items.Add('Transition Yellow-Red-Green=20,21,24,0,255,255,16');
 qbpresets.Items.Add('Triangles=31,31,31,255,9,128,103');
 qbpresets.Items.SaveToFile(QBFile);
 {DoMessages( 30006);}
 end;

 {QB}
{setDrawImage(self);
procedure TjanDrawImage.Backgrounds;
begin
  PainterQBF.show;
  PainterQBF.BringToFront ;
end;}
end;

procedure TAffectsForm.MakeEditFields(Filter:TGraphicFilter);
var i:Integer;
begin
  for i:=0 to 48 do
  begin
     case Filter.MatrixSize of
     mx3: if ((i div 7) in [2..4]) and ((i mod 7) in [2..4])
           then EditArray[i].Visible:=true else EditArray[i].Visible:=false;
     mx5:if ((i div 7) in [1..5]) and ((i mod 7) in [1..5])
           then EditArray[i].Visible:=true else EditArray[i].Visible:=false;
     mx7:if ((i div 7) in [0..6]) and ((i mod 7) in [0..6])
           then EditArray[i].Visible:=true else EditArray[i].Visible:=false;
     end;
     if MirrorTopBotCB.Checked and MirrorLefRigCB.Checked then
     begin
       if ((i Div 7) in [4..6])or ((i mod 7) in [4..6]) then
       begin
         EditArray[i].Enabled:=false;
         if ((i Div 7) in [4..6]) then Filter.Matrix[i div 7,i mod 7]:=Filter.Matrix[i div 7-(((i div 7)-3)*2),i mod 7];
         if ((i mod 7) in [4..6]) then Filter.Matrix[i div 7,i mod 7]:=Filter.Matrix[i div 7,i mod 7-(((i mod 7)-3)*2) ];
       end
       else EditArray[i].Enabled:=true;
     end
     else
     if MirrorTopBotCB.Checked then
     begin
       if ((i mod 7) in [4..6])  then begin
          EditArray[i].Enabled:=false;
          Filter.Matrix[i div 7,i mod 7]:=Filter.Matrix[i div 7,i mod 7-(((i mod 7)-3)*2) ];
       end
       else EditArray[i].Enabled:=true;
     end
     else
     if MirrorLefRigCB.Checked then
     begin
       if ((i div 7) in [4..6])  then begin
         EditArray[i].Enabled:=false;
         Filter.Matrix[i div 7,i mod 7]:=Filter.Matrix[i div 7-(((i div 7)-3)*2),i mod 7];
       end
       else EditArray[i].Enabled:=true;
     end
     else EditArray[i].Enabled:=true;
     EditArray[i].Text:=IntToStr(Filter.Matrix[i div 7,i mod 7]);
  end;
     MaskEdit1.Text:=IntToStr(Filter.Divisor);
     MaskEdit2.Text:=IntToStr(Filter.Bias);
     UserRG.ItemIndex:=Integer(Filter.MatrixSize)-1;
end;



procedure TAffectsForm.EditChanged(Sender: TObject);
var i:Integer;
begin
  ActFilter.Divisor:=StrToInt(MaskEdit1.Text);
  ActFilter.Bias:=StrToInt(MaskEdit2.Text);
  for i:=0 to 48 do
     ActFilter.Matrix[i div 7,i mod 7]:=StrToInt(EditArray[i].Text);
end;


procedure TAffectsForm.UserRGClick(Sender: TObject);
begin
  case UserRG.ItemIndex of
  0:  ActFilter.MatrixSize:=mx3;
  1:  ActFilter.MatrixSize:=mx5;
  2:  ActFilter.MatrixSize:=mx7;
  end;
  MakeEditFields(ActFilter);
end;

procedure TAffectsForm.ListBox1Click(Sender: TObject);
var i,j:Integer;
begin
{  Case ListBox1.ItemIndex of
  0: ActFilter:=mxEmbossColor;
  1: ActFilter:=mxEmbossLight;
  2: ActFilter:=mxEmbossMedium;
  3: ActFilter:=mxEmbossDark;
  4: ActFilter:=mxEdgeEnhance;
  5: ActFilter:=mxBlurBartlett;
  6: ActFilter:=mxNegative;
  7: ActFilter:=mxBlur;
  8: ActFilter:=mxBlurSoftly;
  9: ActFilter:=mxBlurMore;
  10:ActFilter:=mxPrewitt;
  11:ActFilter:=mxTraceContour;
 }
  r:=CheckBox1.Checked;
  g:=CheckBox2.Checked;
  b:=CheckBox3.Checked;
  if TwoPass.ItemIndex > -1 then
     ActTwoPassFilter:= TwoPassFilters[TwoPass.ItemIndex+1].Filter^;
  if ListBox1.ItemIndex > -1 then
     ActFilter:= LinearFilters[ListBox1.ItemIndex+1].Filter^;
  case ActFilter.FilterType of
  ftStatic:begin
             Panel1.Visible:=false;
           end;
  ftLinear:begin
             Panel1.Visible:=true;
           end;
  end;
  UserRG.ItemIndex:=Integer(ActFilter.MatrixSize)-1;
  for i:=0 to 6 do
   for j:=0 to 6 do
     BckMatrix[i,j]:=ActFilter.Matrix[i,j];
  PreviewBtnClick(self);
end;
procedure TAffectsForm.PageControl1Change(Sender: TObject);
begin
 if PageControl1.ActivePage<>WandaTS then
    WandingOn:=False;
end;

procedure TAffectsForm.PreviewBtnClick(Sender: TObject);
//var sz:TMatrixSize;
begin
    if PageControl1.ActivePage=ColorTS then
    begin
    if PageControl2.ActivePage=HSLSheet then
    begin
      EffectColorize(TongsForm.Image1.Picture.Bitmap,
                    ResultBitmap,
                    HSLHue.Position,
                    HSLSat.Position,
                    HSLLit.Position,nil);
      PreviewImage.Picture.Bitmap.Assign(ResultBitmap);
    end;
    end else
    if PageControl1.ActivePage=FilterTS then
    begin
  if PageControl3.ActivePage=TwoPassSheet then
  begin
    if Assigned(ActTwoPassFilter.Filters[1]) then
    FilterCombo1.Text:=ActTwoPassFilter.Filters[1].FilterName else FilterCombo1.Text:='';

    if Assigned(ActTwoPassFilter.Filters[2]) then
    FilterCombo2.Text:=ActTwoPassFilter.Filters[2].FilterName  else FilterCombo2.Text:='';

    if Assigned(ActTwoPassFilter.Filters[3]) then
    FilterCombo3.Text:=ActTwoPassFilter.Filters[3].FilterName  else FilterCombo3.Text:='';

    if Assigned(ActTwoPassFilter.Filters[4]) then
       FilterCombo4.Text:=ActTwoPassFilter.Filters[4].FilterName
       else FilterCombo4.Text:='';

    EffectMultiPass(TongsForm.Image1.Picture.Bitmap,
                    PreviewImage.Picture.Bitmap,
                    ActTwoPassFilter,
                    MultNrPass.ItemIndex+2,eMode,r,g,b,nil);
  end else
  begin
    if PageControl3.ActivePage=UserSheet then
    begin
      EditChanged(self);
      ActFilter.FilterType:=ftLinear;
    end;
    MakeEditFields(ActFilter);
{    case RadioGroup1.ItemIndex of
    0:sz:=mx3;
    1:sz:=mx5;
    2:sz:=mx7;
    end; }
      EffectFilter(TongsForm.Image1.Picture.Bitmap,
      PreviewImage.Picture.Bitmap,
      ActFilter,ActFilter.MatrixSize,eMode,r,g,b,nil);
  end;
  end;
  PreviewImage.Repaint;
end;



procedure TAffectsForm.ApplyBtnClick(Sender: TObject);
var tb:TBitmap;
begin
  Screen.Cursor:=crHourGlass;
  CreateXPanel(Self,200,100);
  XPanel.Caption:='Applying Affect...';
  try
   {if not PreviewPanel1.SourceBitmap.Empty then  }
    if PageControl1.ActivePage=ColorTS then
    begin
    if PageControl2.ActivePage=HSLSheet then
    begin
      EffectColorize(TongsForm.Image1.Picture.Bitmap,
                    ResultBitmap,
                    HSLHue.Position,
                    HSLSat.Position,
                    HSLLit.Position,nil);
      PreviewImage.Picture.Bitmap.Assign(ResultBitmap);
    end
    else if PageControl2.ActivePage=RGBSheet then
    begin
      if SwapMode<>swapnone then
      begin
        tb:=TBitmap.Create;
        try
          EffectSwapChannels(TongsForm.Image1.Picture.Bitmap,tb,SwapMode,nil);
          EffectIncDecRGB(tb,ResultBitmap,RedTrack.Position,GreenTrack.Position,BlueTrack.Position,nil);
        finally
          tb.Free;
        end;
      end else
      EffectIncDecRGB(TongsForm.Image1.Picture.Bitmap,
                      ResultBitmap,
                      RedTrack.Position,
                      GreenTrack.Position,
                      BlueTrack.Position,nil);
      PreviewImage.Picture.Bitmap.Assign(ResultBitmap);
   end
    else if PageControl2.ActivePage=GammaSheet then
    begin
       EffectGamma(TongsForm.Image1.Picture.Bitmap,
                   ResultBitmap,Gamma,nil);
       PreviewImage.Picture.Bitmap.Assign(ResultBitmap);
    end
    else if PageControl2.ActivePage= ContrastSheet then
    begin
      tb:=TBitmap.Create;
      try
        EffectContrast(TongsForm.Image1.Picture.Bitmap,ResultBitmap,
                       BCCon.Position,true,true,true,nil);
        tb.Assign(ResultBitmap);
        EffectLightness(tb,ResultBitmap,
                        BCLight.Position,true,true,true,nil);
      finally
        tb.free;
      end;
      PreviewImage.Picture.Bitmap.Assign(ResultBitmap);
    end;
    end else {Check Color sheets}

    if PageControl1.ActivePage<>TwoPassSheet then
       EffectFilter(TongsForm.Image1.Picture.Bitmap,
                    ResultBitmap,
                    ActFilter,
                    ActFilter.MatrixSize,
                    eMode,r,g,b,XProgress)
    else
    EffectMultiPass(TongsForm.Image1.Picture.Bitmap,
                    ResultBitmap,
                    ActTwoPassFilter,
                    MultNrPass.ItemIndex+2,eMode,r,g,b,XProgress)
  finally
  Screen.Cursor:=crDefault;
  ReleaseXPanel;
  end;
end;


procedure TAffectsForm.LinearCSRGClick(Sender: TObject);
begin
  case LinearCSRG.ItemIndex of
  0:begin
     CheckBox1.Caption:='Red';
     CheckBox2.Caption:='Green';
     CheckBox3.Caption:='Blue';
     eMode:=csRGB;
    end;
  1:begin
     CheckBox1.Caption:='Hue';
     CheckBox2.Caption:='Saturation';
     CheckBox3.Caption:='Value';
     eMode:=csHSV;
    end;
 2:begin
     CheckBox1.Caption:='Hue';
     CheckBox2.Caption:='Saturation';
     CheckBox3.Caption:='Luminance';
     eMode:=csHSL;
    end;
 end;
 PreviewBtnClick(Sender{nil});
end;



procedure TAffectsForm.FilterCombo2Change(Sender: TObject);
begin
  if (Sender as TComboBox).Text='Null' then
      pGraphicFilter(ActTwoPassFilter.Filters[TComboBox(Sender).Tag]):=@mxZero
  else
      pGraphicFilter(ActTwoPassFilter.Filters[TComboBox(Sender).Tag]):=
       pGraphicFilter(LinearFilters[TComboBox(Sender).ItemIndex].Filter);
  PreviewBtnClick(self);
end;

procedure TAffectsForm.Funct1Change(Sender: TObject);
begin
  if (Sender as TComboBox).Text='Null' then
     ActTwoPassFilter.Functions[TComboBox(Sender).Tag]:=gaNone
  else
     ActTwoPassFilter.Functions[TComboBox(Sender).Tag]:=
          TGraphicArithmetic(TComboBox(Sender).ItemIndex);
  PreviewBtnClick(self);
end;

procedure TAffectsForm.MultNrPassClick(Sender: TObject);
begin
  Case MultNrPass.ItemIndex of
  0:begin
     FilterCombo4.Enabled:=false;
     FilterCombo3.Enabled:=false;
     Funct2.Enabled:=false;
     Funct3.Enabled:=false;
    end;
  1:begin
     Funct3.Enabled:=false;
     Funct2.Enabled:=true;
     FilterCombo3.Enabled:=true;
     FilterCombo4.Enabled:=false;
    end;
  2:begin
     FilterCombo4.Enabled:=true;
     FilterCombo3.Enabled:=true;
     Funct2.Enabled:=True;
     Funct3.Enabled:=True;
    end;
  end;
end;

procedure TAffectsForm.NewLinClick(Sender: TObject);
begin
   PageControl1.ActivePage:=UserSheet;
end;

procedure TAffectsForm.DelLinearClick(Sender: TObject);
begin
  ListBox2.Clear;
end;

procedure TAffectsForm.UserSaveBtnClick(Sender: TObject);
begin
If Processing then exit;
Processing:=True;
   if SaveDialog1.Execute then
   begin
     EditChanged(Self);
     if (ExtractFileExt(SaveDialog1.FileName)='.flf')
     then
        SaveLinearFilterToFile(PCHar(SaveDialog1.FileName),ActFilter)
     else
     if ExtractFileExt(SaveDialog1.FileName)='.fmf'
     then
        SaveMultiPassFilterToFile(PCHar(SaveDialog1.FileName),ActTwoPassFilter)
     else
     raise EGraphicEffects.Create('Illegal filter file');
     MakeEditFields(ActFilter);
   end;
Processing:=False;
end;

procedure TAffectsForm.SpeedButton9Click(Sender: TObject);
begin  {Filter Directional Arrows}
If Processing then exit;
Processing:=True;
  RotateMatrix((Sender as TSpeedButton).Tag);
  PreviewBtnClick(self);
Processing:=False;
end;

procedure TAffectsForm.RotateMatrix(Steps:Integer);
var hm:TEffectMatrix;
    k,i,j:Integer;

procedure ActualizeMatrix;
var i,j:Integer;
begin
   for i:=0 to 6 do for j:=0 to 6 do
   ActFilter.Matrix[i,j]:=hm[i,j];
end;

procedure Rotate3x3;
  begin
   with ActFilter do begin
    hm[3,3]:=Matrix[3,3];
    hm[2,2]:=Matrix[3,2];
    hm[3,2]:=Matrix[4,2];
    hm[4,2]:=Matrix[4,3];
    hm[4,3]:=Matrix[4,4];
    hm[4,4]:=Matrix[3,4];
    hm[3,4]:=Matrix[2,4];
    hm[2,4]:=Matrix[2,3];
    hm[2,3]:=Matrix[2,2];
   end;
   ActualizeMatrix;
end;

procedure Rotate5x5;
var  i,j:Integer;
  begin
  with ActFilter do begin
    for i:=1 to 3 do hm[i,1]:=Matrix[i+2,1];
    hm[4,1]:=Matrix[5,2];
    for j:=1 to 3 do hm[5,j]:=MAtrix[5,j+2];
    hm[5,4]:=Matrix[4,5];
    for i:=5 downto 3 do hm[i,5]:=Matrix[i-2,5];
    hm[2,5]:=Matrix[1,4];
    for j:=5 downto 3 do hm[1,j]:=MAtrix[1,j-2];
    hm[1,2]:=Matrix[2,1];
    end;
   ActualizeMatrix;
end;

procedure Rotate7x7;
var  i,j:Integer;
  begin
  with ActFilter do begin
    for i:=0 to 3 do hm[i,0]:=Matrix[i+3,0];
    hm[4,0]:=Matrix[6,1];
    hm[5,0]:=Matrix[6,2];
    for j:=0 to 3 do hm[6,j]:=MAtrix[6,j+3];
    hm[6,4]:=Matrix[5,6];
    hm[6,5]:=Matrix[4,6];

    for i:=6 downto 3 do hm[i,6]:=Matrix[i-3,6];
    hm[2,6]:=Matrix[0,5];
    hm[1,6]:=Matrix[0,4];
    for j:=6 downto 3 do hm[0,j]:=MAtrix[0,j-3];
    hm[0,2]:=Matrix[1,0];
    hm[0,1]:=Matrix[2,0];
    end;
   ActualizeMatrix;
  end;

begin{MAIN Matrix}
 for i:=0 to 6 do for j:=0 to 6 do ActFilter.Matrix[i,j]:=BckMatrix[i,j];
 for i:=0 to 6 do for j:=0 to 6 do hm[i,j]:=BckMatrix[i,j];

if Steps=0 then  ActualizeMatrix else
for k:=0 to Steps-1 do with ActFilter do
 begin
 Rotate3x3;
 case MatrixSize of
 mx5:Rotate5x5;
 mx7:Begin
     Rotate5x5;
     Rotate7x7;
     end;
 end;
 end;
 MakeEditFields(ActFilter);
end;


procedure TAffectsForm.MirrorTopBotCBClick(Sender: TObject);
begin
  EditChanged(self);
  MakeEditFields(ActFilter);
end;

procedure TAffectsForm.UserOpenBtnClick(Sender: TObject);
begin
If Processing then exit;
Processing:=True;
   if OpenDialog1.Execute then
   begin
    if ExtractFileExt(OpenDialog1.FileName)='.flf' then
     LoadLinearFilterFromFile(PCHar(OpenDialog1.FileName),ActFilter) else
    if ExtractFileExt(OpenDialog1.FileName)='.fmf' then
     LoadMultiPassFilterFromFile(PCHar(OpenDialog1.FileName),ActTwoPassFilter) else
     raise EGraphicEffects.Create('Illegal filter file');
     MakeEditFields(ActFilter);
     PreviewBtnClick(self);
   end;
Processing:=False;
end;
//-----------------------------------------------------
//-----------------------------------------------------


//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.SolTrackBarChange(Sender: TObject);
begin
If Processing then exit;
Processing:=True;
  SolEdit.Text:=IntToStr(SolTrackBar.Position);
  if SolRG.Itemindex=0 {Caption='Solarize'} then
  EffectSolarize(TongsForm.Image1.Picture.Bitmap,
                 PreviewImage.Picture.Bitmap,
                 SolTrackBar.Position,nil)
  else
  if  SolRG.Itemindex=2{Caption='Circle around'} then
  EffectCircleAround(TongsForm.Image1.Picture.Bitmap,
                     PreviewImage.Picture.Bitmap,
                     SolTrackBar.Position,nil) else
  if  SolRG.Itemindex=1{Caption='FishEye'} then
  EffectFishEye(TongsForm.Image1.Picture.Bitmap,
                PreviewImage.Picture.Bitmap,
                (SolTrackBar.Position+10)/ 10,nil);
  PreviewImage.Repaint;
Processing:=False;
end;

procedure TAffectsForm.SolEditKeyPress(Sender: TObject; var Key: Char);
begin
If Processing then exit;
Processing:=True;
  if Key=#13 then begin
     SolTrackBar.Position:=StrToInt(SolEdit.Text);
  if  SolRG.Itemindex=0{Caption='Solarize' }then
     EffectSolarize(TongsForm.Image1.Picture.Bitmap,
                    PreviewImage.Picture.Bitmap,
                    SolTrackBar.Position,nil)
  else
  if  SolRG.Itemindex=2{Caption='Circle around'} then
      EffectCircleAround(TongsForm.Image1.Picture.Bitmap,
                         PreviewImage.Picture.Bitmap,
                         SolTrackBar.Position,nil) else
  if  SolRG.Itemindex=1{Caption='FishEye' }then
      EffectFishEye(TongsForm.Image1.Picture.Bitmap,
                    PreviewImage.Picture.Bitmap,
                    (SolTrackBar.Position+10)/ 10,nil);
  PreviewImage.Repaint;
  end;
Processing:=False;
end;

procedure TAffectsForm.SolOKClick(Sender: TObject);
begin
If Processing then exit;
Processing:=True;
  Screen.Cursor:=crHourGlass;
  try
{    if not PreviewPanel1.SourceBitmap.Empty then     }
    begin
      if  SolRG.Itemindex=0{Caption='Solarize'} then
      EffectSolarize(TongsForm.Image1.Picture.Bitmap,
                     ResultBitmap,SolTrackBar.Position,nil) else
      if  SolRG.Itemindex=2{Caption='Circle around'} then
      EffectCircleAround(TongsForm.Image1.Picture.Bitmap,
                         ResultBitmap,SolTrackBar.Position,nil) else
      if  SolRG.Itemindex=1{Caption='FishEye'} then
      EffectFishEye(TongsForm.Image1.Picture.Bitmap,
                    ResultBitmap,(SolTrackBar.Position+10) / 10,nil)
    end;
  finally
  Screen.Cursor:=crDefault;
  end;
Processing:=False;
end;
//-----------------------------------------------------
//-----------------------------------------------------



//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.TrackBar1Change(Sender: TObject);
begin
If Processing then exit;
Processing:=True;
    EffectSinus(TongsForm.Image1.Picture.Bitmap,
                PreviewImage.Picture.Bitmap,
                TrackBar1.Position,TrackBar2.Position,
                TrackBar4.Position,TrackBar5.Position,
                TrackBar3.Position,TrackBar6.Position,true,nil);
    PreviewImage.Repaint;
Processing:=False;
end;

procedure TAffectsForm.EffectRGClick(Sender: TObject);
begin
  case EffectRG.ItemIndex of
  0:EffectPanel.Visible:=false;
  1:EffectPanel.Visible:=false;
  2:EffectPanel.Visible:=true;
  end;
end;

procedure TAffectsForm.EffectEditKeyPress(Sender: TObject;
  var Key: Char);
begin
If Processing then exit;
Processing:=True;
  if Key=#13 then
  begin
    EffectTrackBar.Position:=StrToInt(EffectEdit.Text);
  case EffectRG.ItemIndex of
  0:EffectSpray(TongsForm.Image1.Picture.Bitmap,
                PreviewImage.Picture.Bitmap,
                EffectTrackBar.Position,nil);
  1:EffectAddNoise(TongsForm.Image1.Picture.Bitmap,
                   PreviewImage.Picture.Bitmap,
                   EffectTrackBar.Position,true,nil);
  end;
  PreviewImage.Repaint;
  end;
Processing:=False;
end;

procedure TAffectsForm.EffectTrackBarChange(Sender: TObject);
begin
If Processing then exit;
Processing:=True;
  EffectEdit.Text:=IntToStr(EffectTrackBar.Position);
  case EffectRG.ItemIndex of
  0:EffectSpray(TongsForm.Image1.Picture.Bitmap,
                PreviewImage.Picture.Bitmap,
                EffectTrackBar.Position,nil);
  1:EffectAddNoise(TongsForm.Image1.Picture.Bitmap,
                   PreviewImage.Picture.Bitmap,
                   EffectTrackBar.Position,true,nil);
  2:EffectSinus(TongsForm.Image1.Picture.Bitmap,
                PreviewImage.Picture.Bitmap,
                TrackBar1.Position,TrackBar2.Position,
                TrackBar4.Position,TrackBar5.Position,
                TrackBar3.Position,TrackBar6.Position,true,nil);
  end;
  PreviewImage.Repaint;
Processing:=False;
end;

procedure TAffectsForm.EffectOKClick(Sender: TObject);
begin
If Processing then exit;
Processing:=True;
  Screen.Cursor:=crHourGlass;
  try
{    if not PreviewPanel1.SourceBitmap.Empty then }
    case EffectRG.ItemIndex of
    0:EffectSpray(TongsForm.Image1.Picture.Bitmap,
                  ResultBitmap,EffectTrackBar.Position,nil);
    1:EffectAddNoise(TongsForm.Image1.Picture.Bitmap,
                     ResultBitmap,EffectTrackBar.Position,true,nil);
    2:EffectSinus(TongsForm.Image1.Picture.Bitmap,ResultBitmap,
                  TrackBar1.Position,TrackBar2.Position,
                  TrackBar4.Position,TrackBar5.Position,
                  TrackBar3.Position,TrackBar6.Position,true,nil);
    end;
  finally
  Screen.Cursor:=crDefault;
  end;
Processing:=False;
end;
//-----------------------------------------------------
//-----------------------------------------------------


//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.BCLightChange(Sender: TObject);
begin
  BCLightSE.Value:=BCLight.Position;
  BCConSE.Value:=BCCon.Position;
end;

procedure TAffectsForm.BCConSEChange(Sender: TObject);
begin
  if (Sender as TSpinEdit).Text=''
      then (Sender as TSpinEdit).Text:='0';
  BCLight.Position:=BCLightSE.Value;
  BCCon.Position:=BCConSE.Value;
  LigCont;
end;

procedure TAffectsForm.LigCont;
var TempBitmap:TBitmap;
begin
If Processing then exit;
Processing:=True;
 TempBitmap:=TBitmap.Create;
 try
  EffectContrast(TongsForm.Image1.Picture.Bitmap,
                 ResultBitmap,
                 BCCon.Position,true,true,true,nil);
  TempBitmap.Assign(ResultBitmap);
  EffectLightness(TempBitmap,PreviewImage.Picture.Bitmap,
                  BCLight.Position,true,true,true,nil);
  PreviewImage.Repaint;
 finally
   TempBitmap.Free;
 end;
Processing:=False;
end;
//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.GammaTrackChange(Sender: TObject);
var x:Extended;
    i,k:Integer;
begin
If Processing then exit;
Processing:=True;
  x:=GammaTrack.Position /100 ;
  GammaEdit.Text:= FloatToStr(x);
  Gamma := x;
  EffectGamma(TongsForm.Image1.Picture.Bitmap,
              PreviewImage.Picture.Bitmap,
               x,nil);
  PreviewImage.Repaint;
  Image1.Picture.Bitmap.Width:=Image1.Width;
  Image1.Picture.Bitmap.Height:=Image1.Height;
  Image1.Picture.Bitmap.Canvas.MoveTo(0,Image1.Height-1);
  Image1.Picture.Bitmap.Canvas.Brush.Color:=clWhite;
  Image1.Picture.Bitmap.Canvas.FillRect(Image1.ClientRect);
  for i:=1 to 255 do
  begin
    k:=IntGamma(Gamma,i);
    Image1.Picture.Bitmap.Canvas.LineTo(i div 2,Image1.Height-( k div 2)-1);
  end;
  Image1.Repaint;
Processing:=False;    
end;


procedure TAffectsForm.GammaEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key =#13 then
  begin
    GammaTrack.Position:=Round(StrToFloat(GammaEdit.Text) * 100);
    GammaTrackChange(self);
  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.RedTrackChange(Sender: TObject);
begin
   RedSpin.Value:=RedTrack.Position;
   GreenSpin.Value:=GreenTrack.Position;
   BlueSpin.Value:=BlueTrack.Position;
end;

procedure TAffectsForm.RedSpinChange(Sender: TObject);
begin
  if (Sender as TSpinEdit).Text=''
     then (Sender as TSpinEdit).Text:='0';
  RedTrack.Position:=RedSpin.Value;
  GreenTrack.Position:=GreenSpin.Value;
  BlueTrack.Position:=BlueSpin.Value;
  RGBClick;
end;

procedure TAffectsForm.RGBClick;
var tb:TBitmap;
begin
If Processing then exit;
Processing:=True;
  if SwapMode=swapNone then
  EffectIncDecRGB(TongsForm.Image1.Picture.Bitmap,
                  PreviewImage.Picture.Bitmap,
                  RedTrack.Position,
                  GreenTrack.Position,
                  BlueTrack.Position,nil)
  else
  begin
    tb:=TBitmap.Create;
    try
      EffectSwapChannels(TongsForm.Image1.Picture.Bitmap,
      tb,SwapMode,nil);
      EffectIncDecRGB(tb,TongsForm.Image1.Picture.Bitmap,
      RedTrack.Position,GreenTrack.Position,BlueTrack.Position,nil);
    finally
      tb.Free;
    end;
  end;
  PreviewImage.Repaint;
Processing:=False;
end;

{SwapPlanesRG commented out... crashes}
procedure TAffectsForm.SwapPlanesRGClick(Sender: TObject);
begin
  case SwapPlanesRG.Itemindex of
  0:SwapMode:=swapNone;
  1:SwapMode:=swapRedGreen;
  2:SwapMode:=swapRedBlue;
  3:SwapMode:=swapBlueGreen;
  end;
  RedTrackChange(Self);
  RGBClick;
end;
//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.HSLHueChange(Sender: TObject);
begin
   HSLHueSE.Value:=HSLHue.Position;
   HSLSatSE.Value:=HSLSat.Position;
   HSLLitSe.Value:=HSLLit.Position;
end;

procedure TAffectsForm.HSLHueSEChange(Sender: TObject);
begin
  if (Sender as TSpinEdit).Text=''
      then (Sender as TSpinEdit).Text:='0';
  HSLHue.Position:=HSLHueSE.Value;
  HSLSat.Position:=HSLSatSE.Value;
  HSLLit.Position:=HSLLitSE.Value;
  PreviewBtnClick(self);
end;

//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.RotateTrackBarChange(Sender: TObject);
begin
DegreeEdit.Text:=Inttostr(RotateTrackBar.Position);
end;
procedure TAffectsForm.ValueGroupClick(Sender: TObject);
begin
case ValueGroup.ItemIndex of
 0:RotateTrackBar.Position:=0;{DegreeEdit.Text:='0';}
 1:RotateTrackBar.Position:=90;{DegreeEdit.Text:='90';}
 2:RotateTrackBar.Position:=180;{DegreeEdit.Text:='180';}
 3:RotateTrackBar.Position:=270;{DegreeEdit.Text:='270';}
end;
  RotatePreviewBtnClick(nil);
end;

procedure TAffectsForm.EnlCanvClick(Sender: TObject);
begin
  RotatePreviewBtnClick(nil);
end;

procedure TAffectsForm.RotateColorClick(Sender: TObject);
begin
If Processing then exit;
Processing:=True;
  ColorDialog1.Execute;
  RotatePreviewBtnClick(nil);
Processing:=False;
end;

procedure TAffectsForm.CenterEditChange(Sender: TObject);
begin
  if (Sender as TEdit).Text<>'' then RotatePreviewBtnClick(nil);
end;

procedure TAffectsForm.DegreeEditChange(Sender: TObject);
begin
  RotatePreviewBtnClick(nil);
end;

procedure TAffectsForm.InitializeRotateBtnClick(Sender: TObject);
begin
If Processing then exit;
Processing:=True;
  if not TongsForm.Image1.Picture.Bitmap.Empty then
  begin
    myClip.Assign(TongsForm.Image1.Picture.Bitmap);
//   PreviewPanel1.SourceBitmap.Assign(SrcPicture.Bitmap);
{   StretchResize(SrcBitmap,ImgTemp,100,100,false,clNone,true);}
   PreviewImage.Picture.Assign(myClip);
   Application.ProcessMessages;
  DegreeEdit.SetFocus;
  DegreeEdit.OnChange:=DegreeEditChange;
  RotXEdit.OnChange:=CenterEditChange;
  RotYEdit.OnChange:=CenterEditChange;
  end;
Processing:=False;
end;

procedure TAffectsForm.RotatePreviewBtnClick(Sender: TObject);
var ImgTmp2:TBitmap;
begin
If Processing then exit;
Processing:=True;
  if not myClip.Empty then
  begin
  ImgTmp2:=TBitmap.Create;
  ImgTmp2.PixelFormat:=MyPixelFormat;
  try
  RotateBitmap(myClip,ImgTmp2,RotateTrackBar.Position,
  Round(StrToInt(RotXEdit.Text)* (myClip.Width/TongsForm.Image1.Picture.Bitmap.Width)),
  Round(StrToInt(RotYEdit.Text)* (myClip.Height/TongsForm.Image1.Picture.Bitmap.Height)),
  EnlCanv.Checked,
  ColorDialog1.Color,nil);
  if GetDeviceCaps(GetDC(0),BITSPIXEL)=8 then
  begin
//   ApplyPaletteToGraphic( ,PreviewImage.Picture.Bitmap,true,pf8Bit);
   PreviewImage.Picture.Bitmap.Canvas.CopyRect(
   Rect(0,0,Imgtmp2.Width,Imgtmp2.Height),
   Imgtmp2.Canvas,PreviewImage.ClientRect);
   //Rect(0+fPosX,0+fPosY,fOriginalBitmap.Width+fPosX,fOriginalBitmap.Height+fPosY));
  end else PreviewImage.Picture.Assign(ImgTmp2);
  PreviewImage.Repaint;
  finally
  ImgTmp2.Free;
  end;
 end;
Processing:=False;
end;

procedure TAffectsForm.RotateApplyClick(Sender: TObject);
begin
  If Processing then exit;
  Processing:=True;
  RotatePreviewBtnClick(nil);
  ResultBitmap.Assign(PreviewImage.Picture.Bitmap);
  Processing:=False;
end;
//-----------------------------------------------------
//-----------------------------------------------------


//-----------------------------------------------------
{procedure TgfxForm.MiscClick(Sender: TObject);}
    {flip 1}
   { Mirror tag 2}
{Negative2 tag 3}
{Grayscale tag 4}
{Flip 1/2 tag 5}
{Mirror 1/2 tag 6}
{Old look tag 7}
//-----------------------------------------------------
procedure TAffectsForm.FlipperClick(Sender: TObject);
var TempBmp,TargetIn:TBitmap;
begin
If Processing then exit;
Processing:=True;
   TempBMP:=TBitmap.Create;
   TargetIn:=TBitmap.Create;
   try
      case (Sender as TButton).Tag of
      1:begin
            FlipBitmap(PreviewImage.Picture.Bitmap,TempBmp,nil);
            PreviewImage.Picture.Bitmap.Assign(TempBMP);
        end;
      2:begin
             MirrorBitmap(PreviewImage.Picture.Bitmap,TempBmp,nil);
             PreviewImage.Picture.Bitmap.Assign(TempBMP);
        end;
      3:
        begin
            EffectNegative(PreviewImage.Picture.Bitmap,TempBMP,nil);
            PreviewImage.Picture.Bitmap.Assign(TempBMP);
        end;
      4:begin
            EffectGreyScale(PreviewImage.Picture.Bitmap,TempBmp,nil);
            PreviewImage.Picture.Bitmap.Assign(TempBMP);
        end;
      5:begin
          FlipBitmap(PreviewImage.Picture.Bitmap,
          PreviewImage.Picture.Bitmap,nil);
       end;
      6:begin
          MirrorBitmap(PreviewImage.Picture.Bitmap,
          PreviewImage.Picture.Bitmap,nil);
       end;
      7:begin
{          EffectNegative(PreviewImage.Picture.Bitmap,
          PreviewImage.Picture.Bitmap,nil);}
{          TargetIn := TBitmap.Create;}
          TargetIn.PixelFormat := MyPixelFormat;
          TargetIn.Width := TongsForm.Image1.Picture.Width;
          TargetIn.Height := TongsForm.Image1.Picture.Height;
          TargetIn.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
          TempBMP.PixelFormat := MyPixelFormat;
          TempBMP.Width := TongsForm.Image1.Picture.Width;
          TempBMP.Height := TongsForm.Image1.Picture.Height;
          TempBMP.Canvas.Draw(0, 0, PreviewImage.Picture.Graphic);
        Blend(TargetIn,TempBMP,PreviewImage.Picture.Bitmap,
           (BlenderTrackBar.Position/100));
       end;
      8:begin

       end;
      end;
   finally
      TempBmp.Free;
      TargetIn.Free;
      PreviewImage.RePaint;
  end;
Processing:=False;
end;
//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.EncryptBtnClick(Sender: TObject);
var EncryptVal:Integer;
  TempBitmap:TBitmap;
begin
If Processing then exit;
Processing:=True;
    TempBitmap:=TBitmap.Create;
          TempBitmap.PixelFormat := MyPixelFormat;
          TempBitmap.Width := TongsForm.Image1.Picture.Width;
          TempBitmap.Height := TongsForm.Image1.Picture.Height;
     EncryptVal:=StrToInt(CryptKeeper.Text);
     EncryptBMP(PreviewImage.Picture.Bitmap,TempBitmap,EncryptVal);
     PreviewImage.Picture.Bitmap.Canvas.Draw(0,0,TempBitmap);
     PreviewImage.Repaint;
     DecryptBtn.Enabled:=True;
     TempBitmap.Free;
Processing:=False;
end;

procedure TAffectsForm.DecryptBtnClick(Sender: TObject);
var DecryptVal:Integer;
  TempBitmap:TBitmap;
begin
If Processing then exit;
Processing:=True;
          TempBitmap := TBitmap.Create;
          TempBitmap.PixelFormat := MyPixelFormat;
          TempBitmap.Width := TongsForm.Image1.Picture.Width;
          TempBitmap.Height := TongsForm.Image1.Picture.Height;
     DecryptVal:= StrToInt(CryptKeeper.Text);
     DecryptBMP(TempBitmap,PreviewImage.Picture.Bitmap,DecryptVal);
     PreviewImage.Repaint;
     TempBitmap.Free;
Processing:=False;
end;

//-----------------------------------------------------
//-----------------------------------------------------

procedure TAffectsForm.MagicWand2Click(Sender: TObject);
begin
If MagicWand2.Checked then
   begin
   MagicWandCB.Checked :=False;
   LightWandCB.Checked :=False;
   WandingOn:=True;
   end else WandingOn:=False;
end;

procedure TAffectsForm.MagicWandCBClick(Sender: TObject);
begin
If MagicWandCB.Checked then
   begin
   MagicWand2.Checked :=False;
   LightWandCB.Checked :=False;
   WandingOn:=True;
   end else WandingOn:=False;
end;
procedure TAffectsForm.LightWandCBClick(Sender: TObject);
begin
If LightWandCB.Checked then
   begin
   MagicWand2.Checked :=False;
   MagicWandCB.Checked :=False;
   WandingOn:=True;
   end else WandingOn:=False;
end;
procedure TAffectsForm.WandColorBtnClick(Sender: TObject);
begin
If Processing then exit;
  if colordialog1.execute then
     WandColorBtn.Font.Color:=colordialog1.Color;
end;

procedure TAffectsForm.RefreshBtnClick(Sender: TObject);
var  Target:TBitmap;
begin
          Target := TBitmap.Create;
          Target.PixelFormat := MyPixelFormat;
          Target.Width := TongsForm.Image1.Picture.Width;
          Target.Height := TongsForm.Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
          PreviewImage.Picture.Graphic := Target;
          Target.Free;
  PreviewImage.picture.bitmap.pixelformat:=MyPixelFormat;
  PreviewImage.Picture.Bitmap.Canvas.brush.color:=clyellow;
Processing:=False;
end;
//-----------------------------------------------------
//-----------------------------------------------------


//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.ETreeClick(Sender: TObject);
var index:integer;
begin
If Processing then exit;
  if ETree.Selected =nil then exit;
  EBar.Visible:=True;
  extrabar.Visible:=False; {1..300}
  extrabarLabel.Visible:=False;
  cxbar.Visible:=False;{1..100}
  cxbarLabel.Visible:=False;
  cybar.Visible:=False; {1..100}
  cybarLabel.Visible:=False;
       cxbarLabel.Caption:='rotate x';
       cybarLabel.Caption:='rotate y';
  index:=ETree.Selected.ImageIndex;
  if index<0 then exit;
case index of
 0: bar(100,0,0);//contrast
 1: bar(255,0,0);//saturation
 2: bar(100,0,0);//brightness
 3: bar(20,0,0);//gaussian blur
 4: bar(30,0,0);//split blur
 5: bar(200,0,0);//color noise
 6: bar(200,0,0);//mono noise
 7: bar(20,0,0);//smooth
 8: bar(15,3,5);//seamless
 9: bar(30,2,15);//mosaic
 10: bar(50,1,10);//twist
 11:{ bar(100,55,60)};//fisheye
 12..14:
 begin
   bar((PreviewImage.Picture.Bitmap.height div 2),1,15);
   // wave  0
   // 13: bar(200,1,15);//wave extra   1
   // 14: bar(10,1,1);//wave inference  2
   If index=14 then
   begin
   extrabar.min:=1;
   extrabar.max:=10;
   extrabar.position:=1;
     extrabar.Visible:=True; {1..300}
     extrabarLabel.Visible:=True;
   end;
 end;
 15: begin
       bar(360,0,0);//smooth rotate
       cxbar.max:=(PreviewImage.Picture.Bitmap.width div 2)-2;
       cxbar.Visible:=True;{1..100}
       cxbarLabel.Visible:=True;
       cybar.max:=(PreviewImage.Picture.Bitmap.height div 2)-2;
       cybar.Visible:=True; {1..100}
       cybarLabel.Visible:=True;
     end;
 16: bar(10,1,1);//split light
 17..24:
   begin
     bar(400,1,1);
     extrabar.min:=1;
     extrabar.max:=300;
     extrabar.position:=1;
     extrabar.Visible:=True; {1..300}
     extrabarLabel.Visible:=True;
   {17: bar(400,1,1);//wings
    18: bar(400,1,1);//wings down
    19: bar(400,1,1);//wings up
    20: bar(400,1,1);//wings fold
    21: bar(400,1,1);//wings touche
    22: bar(400,1,1);//wings flyer
    23: bar(400,1,1);//wings flipover
    24: bar(400,1,1);//wings wavy}
   end;
 25: begin
       EBar.Visible:=False;
       bar(100,0,0);//emboss
     end;
 26..31:
     begin
       EBar.Visible:=False;
       cxbar.max:=255;
       cxbar.min:=0;
       cxbar.position:=0;
       cxbar.Visible:=True;{1..100}
       cxbarLabel.Caption:='Max';
       cxbarLabel.Visible:=True;
       cybarLabel.Caption:='Min';
       cybar.max:=255;
       cybar.min:=0;
       cybar.position:=128;
       cybar.Visible:=True; {1..100}
       cybarLabel.Visible:=True;
        {26: bar(255,0,128);//filter red
         27: bar(255,0,128);//filter green
         28: bar(255,0,128);//filter blue
         29: bar(255,0,128);//filter Xred
         30: bar(255,0,128);//filter Xgreen
         31: bar(255,0,128);//filter xblue}
     end;
 32: bar(255,0,0);//squeezehor
 33: bar(255,0,0);//squeezetop
 34: bar(255,0,0);//squeezebottom
 35: bar(255,0,0);//squeezediamond
 36: bar(255,0,0);//squeezewaste
 37: bar(255,0,0);//squeezeround
 38: bar(255,0,0);//squeezeround2
 39: bar(255,0,0);//splitround
 40: bar(255,0,0);//splitwaste
 41: bar(100,0,0);//shear
 42: begin
       bar(100,0,5);//plasma
       extrabar.min:=1;
       extrabar.max:=100;
       extrabar.position:=10;
       extrabar.Visible:=True; {1..300}
       extrabarLabel.Visible:=True;
     end;
 43..44: begin
      { 44: bar(100,0,0);//julia}
       bar(100,0,0);//mandelbrot
       extrabar.min:=1;
       extrabar.max:=100;
       extrabar.position:=0;
       extrabar.Visible:=True; {1..100}
       extrabarLabel.Visible:=True;
       end;
 45: bar(127,5,19);//triangles
 46: bar(100,3,3);//ripple tooth
 47: bar(100,3,3);//ripple triangle
 48: bar(100,3,3);//ripple random
 49: bar(100,3,3);//texturize tile
 50: bar(100,3,3);//texturize overlap
 51: bar(100,1,1);//map
 52: bar(100,0,0);//blend;
 53: bar(255,0,1);//solarize
 54: bar(255,1,1);//posterize
 55: bar(100,0,1);//Spray
 56: bar(100,0,1);//Darkness
 57: bar(100,0,1);//FoldRight
 58: bar(255,0,1);//KeepBlue
 59: bar(255,0,1);//Green
 60: bar(255,0,1);//Red
 61: bar(100,0,1);//ShakeDown
 end;
end;

procedure TAffectsForm.EBarChange(Sender: TObject);
var
  index:integer;
  TargetIn, Target:TBitmap;
  xr,yr:extended;
  x0,y0,x1,y1:extended;
begin
If Processing then exit;
Processing:=True;
if ETree.selected=nil then exit;
index:=ETree.selected.ImageIndex ;
if index<0 then exit;
          Target := TBitmap.Create;
          Target.PixelFormat := MyPixelFormat;
          Target.Width := TongsForm.Image1.Picture.Width;
          Target.Height := TongsForm.Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
case index of
0:Begin
    Contrast(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
1:Begin
    Saturation(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
2:Begin
    Lightness(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
3:Begin
    GaussianBlur(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
4:Begin
    SplitBlur(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
5:Begin
    AddColorNoise(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
6:Begin
    AddMonoNoise(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
7:Begin
    Smooth(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
8:Begin
    MakeSeamlessClip(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
9:Begin
    Mosaic(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
10:Begin
    Twist(Target,
    PreviewImage.Picture.Bitmap, Ebar.Position);
    Target.Free;
  end;
11:Begin
{    FishEye(Target,
    PreviewImage.Picture.Bitmap, (Ebar.Position/100));
    Target.Free;}
  end;
{ procedure Wave(var clip: tbitmap;
 amount, inference, style: integer);}
12:Begin
    Wave(Target, Ebar.Position,0,0);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
13:Begin
    Wave(Target, Ebar.Position,0,1);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
14:Begin
    Wave(Target, Ebar.Position,extrabar.Position,2);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
15:Begin
          TargetIn := TBitmap.Create;
          TargetIn.PixelFormat := MyPixelFormat;
          TargetIn.Width := TongsForm.Image1.Picture.Width;
          TargetIn.Height := TongsForm.Image1.Picture.Height;
          TargetIn.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
    SmoothRotate(TargetIn,Target,
    (PreviewImage.Picture.Bitmap.width div 2),
    (PreviewImage.Picture.Bitmap.height div 2),
    Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
    TargetIn.Free;
  end;
16:Begin  {splitlight ;}
    splitlight(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
17..24:
  Begin
          TargetIn := TBitmap.Create;
          TargetIn.PixelFormat := MyPixelFormat;
          TargetIn.Width := TongsForm.Image1.Picture.Width;
          TargetIn.Height := TongsForm.Image1.Picture.Height;
          TargetIn.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
    case Index of
    17:marble(TargetIn,Target,extrabar.Position,   Ebar.Position);
    18:marble2(TargetIn,Target,extrabar.Position,   Ebar.Position);
    19:marble3(TargetIn,Target,extrabar.Position,   Ebar.Position);
    20:marble4(TargetIn,Target,extrabar.Position,   Ebar.Position);
    21:marble5(TargetIn,Target,extrabar.Position,   Ebar.Position);
    22:marble6(TargetIn,Target,extrabar.Position,   Ebar.Position);
    23:marble7(TargetIn,Target,extrabar.Position,   Ebar.Position);
    24:marble8(TargetIn,Target,extrabar.Position,   Ebar.Position);
    end;{case 2}
    PreviewImage.Picture.Graphic := Target;
    TargetIn.Free;
    Target.Free;
  end;
25:Begin  {Emboss ;}
    Emboss(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
26:Begin  {filterred ;}
    filterred(Target,cybar.position, cxbar.position );
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
27:Begin  {filtergreen ;}
    filtergreen(Target,cybar.position, cxbar.position );
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
28:Begin  {filterblue ;}
    filterblue(Target,cybar.position, cxbar.position );
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
29:Begin  {filterxred ;}
    filterxred(Target,cybar.position, cxbar.position );
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
30:Begin  {filterxgreen ;}
    filterxgreen(Target,cybar.position, cxbar.position );
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
31:Begin  {filterxblue ;}
    filterxblue(Target,cybar.position, cxbar.position );
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
32..41:  {32..38:squeezehor, 39+40:splitround }
  Begin
          TargetIn := TBitmap.Create;
          TargetIn.PixelFormat := MyPixelFormat;
          TargetIn.Width := TongsForm.Image1.Picture.Width;
          TargetIn.Height := TongsForm.Image1.Picture.Height;
          TargetIn.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
    case Index of
    32:squeezehor(TargetIn,Target,Ebar.Position,mbHor);
    33:squeezehor(TargetIn,Target,Ebar.Position,mbTop);
    34:squeezehor(TargetIn,Target,Ebar.Position,mbBottom);
    35:squeezehor(TargetIn,Target,Ebar.Position,mbDiamond);
    36:squeezehor(TargetIn,Target,Ebar.Position,mbWaste);
    37:squeezehor(TargetIn,Target,Ebar.Position,mbRound);
    38:squeezehor(TargetIn,Target,Ebar.Position,mbround2);

    39:splitround(TargetIn,Target,Ebar.Position,mbsplitround);
    40:splitround(TargetIn,Target,Ebar.Position,mbsplitwaste);
    41:Shake(TargetIn,Target,Ebar.Position);
    end;{case 2}
    PreviewImage.Picture.Graphic := Target;
    TargetIn.Free;
    Target.Free;
  end;

42:Begin
{procedure Plasma(src1, src2, dst: Tbitmap;
 scale,turbulence: extended);}
          TargetIn := TBitmap.Create;
          TargetIn.PixelFormat := MyPixelFormat;
          TargetIn.Width := TongsForm.Image1.Picture.Width;
          TargetIn.Height := TongsForm.Image1.Picture.Height;
          TargetIn.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
    Plasma(TargetIn,Target,PreviewImage.Picture.Bitmap,
           Ebar.Position,extrabar.Position);
    TargetIn.Free;
    Target.Free;
    end;
43..44:
   Begin
  xr:=Ebar.position*0.028;
  yr:=ExtraBar.Position*0.009 ;
  x0:=-2.25+xr;
  x1:=0.75;
  y0:=-1.5+yr;
  y1:=1.5;
  {FX.DrawMandelJulia(clip,x0,y0,x1,y1,16,mandel);}
   {43:PainterF.DrawMandelJulia(true);
    44:PainterF.DrawMandelJulia(false);}
  If index=43 then
        DrawMandelJulia(Target,x0,y0,x1,y1,16,true)
  else  DrawMandelJulia(Target,x0,y0,x1,y1,16,false);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
45:Begin
    Triangles(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
46:Begin
    rippleTooth(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
47:Begin
    rippleTriangle(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
48:Begin
    rippleRandom(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
49:Begin
    texturizeTile(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
50:Begin
    texturizeOverlap(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
51:Begin
    HeightMap(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
52..54:Begin
          TargetIn := TBitmap.Create;
          TargetIn.PixelFormat := MyPixelFormat;
          TargetIn.Width := TongsForm.Image1.Picture.Width;
          TargetIn.Height := TongsForm.Image1.Picture.Height;
          TargetIn.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
    case Index of
    52:{Requires 2 to Blend...}
        Blend(TargetIn,Target,PreviewImage.Picture.Bitmap,
           (Ebar.Position/100));
    53:begin
        Solorize(TargetIn,Target,Ebar.Position);
        PreviewImage.Picture.Graphic := Target;
        end;
    54:begin
        posterize(TargetIn,Target,Ebar.Position);
        PreviewImage.Picture.Graphic := Target;
        end;
    end;{case}
    TargetIn.Free;
    Target.Free;
    end;
55:Begin
    Spray(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
56:Begin
    Darkness(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
57:Begin
          TargetIn := TBitmap.Create;
          TargetIn.PixelFormat := MyPixelFormat;
          TargetIn.Width := TongsForm.Image1.Picture.Width;
          TargetIn.Height := TongsForm.Image1.Picture.Height;
          TargetIn.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
    FoldRight(TargetIn,Target,PreviewImage.Picture.Bitmap,
           Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    TargetIn.Free;
    Target.Free;
  end;
58:Begin
    KeepBlue(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
59:Begin
    KeepGreen(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
60:Begin
    KeepRed(Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
61:Begin
          TargetIn := TBitmap.Create;
          TargetIn.PixelFormat := MyPixelFormat;
          TargetIn.Width := TongsForm.Image1.Picture.Width;
          TargetIn.Height := TongsForm.Image1.Picture.Height;
          TargetIn.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
    ShakeDown(TargetIn, Target, Ebar.Position);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
    TargetIn.Free;
  end;
{ 55: bar(100,0,1);//Spray
 56: bar(100,0,1);//Darkness
 57: bar(100,0,1);//FoldRight
 58: bar(255,0,1);//KeepBlue
 59: bar(255,0,1);//Green
 60: bar(255,0,1);//Red
 61: bar(100,0,1);//ShakeDown}
 end;
Processing:=False;
End;

procedure TAffectsForm.bar(max,min,pos:integer);
begin
 Ebar.Max :=max;
 Ebar.Min :=min;
 Ebar.Position :=pos;
end;

procedure TAffectsForm.SmoreApplyClick(Sender: TObject);
begin
If Processing then exit;
  TongsForm.Image1.Picture.Graphic:=
      PreviewImage.Picture.Graphic;
  TongsForm.SetFormCaption;      
end;
//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.FlippantApplyClick(Sender: TObject);
begin
If Processing then exit;
  TongsForm.Image1.Picture.Graphic:=
      PreviewImage.Picture.Graphic;
  TongsForm.SetFormCaption;
end;

procedure TAffectsForm.FlippantPreviewClick(Sender: TObject);
var index:integer;
 {TargetIn,} Target:TBitmap;
begin
If Processing then exit;
Processing:=True;
index:=FlippantChoicesRG.ItemIndex;
if index<0 then exit;
          Target := TBitmap.Create;
          Target.PixelFormat := MyPixelFormat;
          Target.Width := TongsForm.Image1.Picture.Width;
          Target.Height := TongsForm.Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
case index of
0:Begin
    FlipRight(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
1:Begin
    FlipDown(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
2:Begin
    TurnRight(Target,PreviewImage.Picture.Bitmap);
    Target.Free;
  end;
3:Begin   {?}
    Turn(Target,PreviewImage.Picture.Bitmap);
    Target.Free;
  end;
4:Begin
    MirrorRight(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
5:Begin
    MirrorDown(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
6:Begin
    Invert(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
7:Begin
    GrayScale(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
8:Begin
    ShadowDownLeft(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
9:Begin
    ShadowDownRight(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
10:Begin
    ShadowUpLeft(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
11:Begin
    ShadowUpRight(Target);
    PreviewImage.Picture.Graphic := Target;
    Target.Free;
  end;
12:Begin
    QuartoOpaque(Target,PreviewImage.Picture.Bitmap);
    Target.Free;
  end;
13:Begin
    SemiOpaque(Target,PreviewImage.Picture.Bitmap);
    Target.Free;
  end;
End;{Case}
Processing:=False;
end;
//-----------------------------------------------------
//-----------------------------------------------------



//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.AirShapeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if ((ssAlt in Shift)and(ssLeft in Shift)) then { make sure button is down }
  begin
     ColorDialog1.Color:=
     PreviewImage.Picture.Bitmap.canvas.brush.Color;
      if ColorDialog1.Execute
      then
      begin
      PreviewImage.Picture.Bitmap.canvas.brush.Color :=
           ColorDialog1.Color;
      AirShape.brush.Color := ColorDialog1.Color;
      end;
  end else
  if ((ssShift in Shift)and(ssLeft in Shift)) then { make sure button is down }
  begin
     ColorDialog1.Color:=
     PreviewImage.Picture.Bitmap.canvas.Pen.Color;
      if ColorDialog1.Execute
      then begin
      PreviewImage.Picture.Bitmap.canvas.Pen.Color :=
      ColorDialog1.Color;
      AirShape.Pen.Color := ColorDialog1.Color;
      end;
  end else
    if ssLeft in Shift then { make sure button is down }
  begin
     ColorDialog1.Color:=jvAirBrush.Color;
      if ColorDialog1.Execute
      then
      begin
      jvAirBrush.Color := ColorDialog1.Color;
      ACPanel.Color := ColorDialog1.Color;
      end;
  end;
end;
{Do it both - either way}
procedure TAffectsForm.ACPanelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if ((ssAlt in Shift)and(ssLeft in Shift)) then { make sure button is down }
  begin
     ColorDialog1.Color:=
     PreviewImage.Picture.Bitmap.canvas.brush.Color;
      if ColorDialog1.Execute
      then
      begin
      PreviewImage.Picture.Bitmap.canvas.brush.Color :=
           ColorDialog1.Color;
      AirShape.brush.Color := ColorDialog1.Color;
      end;
  end else
  if ((ssShift in Shift)and(ssLeft in Shift)) then { make sure button is down }
  begin
     ColorDialog1.Color:=
     PreviewImage.Picture.Bitmap.canvas.Pen.Color;
      if ColorDialog1.Execute
      then begin
      PreviewImage.Picture.Bitmap.canvas.Pen.Color :=
      ColorDialog1.Color;
      AirShape.Pen.Color := ColorDialog1.Color;
      end;
  end else
    if ssLeft in Shift then { make sure button is down }
  begin
     ColorDialog1.Color:=jvAirBrush.Color;
      if ColorDialog1.Execute
      then
      begin
      jvAirBrush.Color := ColorDialog1.Color;
      ACPanel.Color := ColorDialog1.Color;
      end;
  end;
end;

procedure TAffectsForm.AirTenUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  jvAirBrush.Intensity:=newValue;
end;

procedure TAffectsForm.AirSizeUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  jvAirBrush.Size:=newValue;
end;

procedure TAffectsForm.StarsUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
   Stars:=newValue;
end;

procedure TAffectsForm.StarPointsUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
   StarPoints:=newValue;
end;

procedure TAffectsForm.BlocksUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
   Blocks:=newValue;
end;

procedure TAffectsForm.SpiralsUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
   Spirals:=newValue;
end;

procedure TAffectsForm.cbopwClick(Sender: TObject);
var i:integer;
begin
  i:=cbopw.itemindex;
  if i=-1 then exit;
  if i=0 then
   PreviewImage.Picture.Bitmap.canvas.pen.style:=psclear
  else
  begin
   PreviewImage.Picture.Bitmap.canvas.pen.style:=pssolid;
   PreviewImage.Picture.Bitmap.canvas.pen.width:=strtoint(cbopw.items[i]);
  end;
end;

procedure TAffectsForm.cboShapesClick(Sender: TObject);
begin
  if cboshapes.itemindex<>-1 then
    myShape :=cboshapes.items[cboshapes.itemindex];
    AffectsForm.Caption:=myShape;
end;

procedure TAffectsForm.selectShape(Ashape:string);
var index:integer;
begin
  index:=cboshapes.Items.IndexOf (Ashape);
  if index<>-1 then
    cboshapes.ItemIndex :=index;
  myShape :=Ashape;
  AffectsForm.Caption:=myShape;
end;
//-----------------------------------------------------
//-----------------------------------------------------

//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.mypaintESC(x,y:integer;shift:tshiftstate);
begin
if myshape='polygon' then
  begin
  if freepolycount>2 then
    PreviewImage.Picture.Bitmap.canvas.Polygon (slice(freepoly,freepolycount));
  freepolycount:=0;
  mydraw:=false;
  end;
if myshape='polyline' then
  begin
  freepolycount:=0;
  mydraw:=false;
  end;
if myshape='polybezier' then
  begin
  bezierfix1:=false;
  bezierfix2:=false;
  myorigin:=point(x,y);
  myprevpoint:=myorigin;
  if ssalt in shift then mydraw:=false;
  end;
  PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
  TargetPoint:=point(x,y);
end;
//-----------------------------------------------------
//-----------------------------------------------------

//-----------------------------------------------------
//-----------------------------------------------------
procedure TAffectsForm.PreviewImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{var drw:string;}
begin
If WandingOn then exit;
If Processing then exit;
Processing:=True;
  wavepen:=PreviewImage.Picture.Bitmap.canvas.pen.color;
  wavebrush:=PreviewImage.Picture.Bitmap.canvas.brush.color;
  if button=mbright then
  begin
    mypaintESC(x,y,shift);
    exit;
  end;
if ((ssctrl in shift) and (ssshift in shift)) then
  begin
  x:=targetpoint.x;
  y:=targetpoint.y;
  mouse.CursorPos :=clienttoscreen(point(x,y));
  end;
PreviewImage.Picture.Bitmap.canvas.MoveTo (x,y);
myorigin:=point(x,y);
myprevpoint:=myorigin;
myslinedir:='none';
mydraw:=true;
mypen:=PreviewImage.Picture.Bitmap.canvas.Pen.Mode;
  if (myshape='Z_rangemove')or (myshape='Z_rangesmear')then
  begin
    myclipcm:=cmSrcInvert;
    setclip(clwhite);
    copyclip;
    with PreviewImage.Picture.Bitmap.canvas do
    begin
       copymode:=cmSrcInvert;
       draw(x,y,myClip);
    end;
  end;
if myshape='Pd_brightness' then clipall;
if myshape='Pd_contrast' then clipall;
if myshape='P_darker' then clipall;
if myshape='Pd_fisheye'  then clipall;
if myshape='Pd_fisheyefix' then clipall;
if myshape='P_gray' then clipall;
if myshape='P_lighter' then clipall;
if myshape='mbBottom' then clipall;
if myshape='mbDiamond' then clipall;
if myshape='mbHor' then clipall;
if myshape='mbHorBox' then clipall;
if myshape='mbHorOval' then clipall;
if myshape='mbRound' then clipall;
if myshape='mbRound2' then clipall;
if myshape='mbSplitRound' then clipall;
if myshape='mbSplitWaste' then clipall;
if myshape='mbTop' then clipall;
if myshape='mbVerBox' then clipall;
if myshape='mbVerOval' then clipall;
if myshape='mbWaste' then clipall;
if myshape='Pd_rimple' then clipall;
if myshape='P_rollmix' then clipall;
if myshape='Pd_rotate'  then clipall;
if myshape='Pd_saturation' then clipall;
if myshape='P_smooth' then clipall;
if myshape='Pd_twist' then clipall;
if myshape='zoombrush' then initplasma;
if myshape='zoomkeepbrush' then initplasma;

  if myshape='Pd_gradient' then
  begin
    PreviewImage.picture.bitmap.PixelFormat :=MyPixelFormat;
  end;
  if myshape='P_mix' then begin
    with PreviewImage.Picture.Bitmap.canvas do begin
     if ssalt in shift then
       PreviewImage.picture.bitmap.Canvas.pen.color:=mixcolors(pixels[x,y-pen.width],pixels[x,y+pen.width])
       else
       PreviewImage.picture.bitmap.Canvas.pen.color:=mixcolors(pixels[x-pen.width,y],pixels[x+pen.width,y]);
     end;
    end;
  if myshape='Lm_sym' then
    setsyms(x,y);
  if myshape='chord3' then
    myshape:='Lf_chord';
  if myshape='pie3' then
    myshape:='Lf_pie';
  if myshape='arc3' then
    myshape:='L_arc';
  if myshape='bezier3' then
    myshape:='L_bezier';
  if myshape='skewrect2' then
    myshape:='L_skewrect';
  if myshape='triangle2' then
    myshape:='L_triangle';
  if myshape='cube2' then
    myshape:='L_cube';
  if (myshape='Z_snapshot')  then
    begin
    myoldbrushstyle:=PreviewImage.Picture.Bitmap.canvas.brush.style;
    PreviewImage.Picture.Bitmap.canvas.brush.style:= bsclear;
    myoldpenwidth:=PreviewImage.Picture.Bitmap.canvas.Pen.width;
    PreviewImage.Picture.Bitmap.canvas.Pen.Width:=1;
    end;
  if (myshape='bezier1') then
    with PreviewImage.Picture.Bitmap.canvas do
    begin
    pen.mode:=pmnotxor;
    polybezier(mybezier);
    mybezier[1]:=point(x,y);
    polybezier(mybezier);
    end;
  if (myshape='bezier2') then
    with PreviewImage.Picture.Bitmap.canvas do
    begin
    pen.mode:=pmnotxor;
    polybezier(mybezier);
    mybezier[2]:=point(x,y);
    polybezier(mybezier);
    end;
{oops Readonly, must set itself... ?
if myshape='airbrush' then jvAirBrush.Air:=True else
   jvAirBrush.Air:=False;}
PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
Processing:=False;
end;

//-----------------------------------------------------
//-----------------------------------------------------

procedure TAffectsForm.PreviewImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var xp,yp,i,j,x1,y1,x2,y2,h,w,pw,movex,movey:integer;
    myrect:trect;
    color1,color2:tcolor;
    r1,g1,b1,r2,b2,g2:byte;
    dx,dy,angle:extended;

    function rr:integer;
    begin
    result:=round(sqrt(sqr(x-myorigin.x)+sqr(y-myorigin.y)));
    if result<10 then result:=10;
    end;

    procedure moveorigin;
    begin
    myorigin.x:=myorigin.x+movex;
    myorigin.y:=myorigin.y+movey;
    end;
begin
If WandingOn then exit;
If Processing then exit;
Processing:=True;  { Processing:=False;}
decoX:=x;decoY:=y;
movex:=x-myprevpoint.x;
movey:=y-myprevpoint.y;
// test for scripting
if ((ssctrl in shift) and (ssalt in shift)) then exit;
mypen:=PreviewImage.Picture.Bitmap.canvas.pen.mode;
h:=abs(y-myorigin.y);
{w:=abs(x-myorigin.x);}
if mydraw then begin
 if (myshape='Z_rangemove')or (myshape='Z_rangesmear') then
 begin
     with PreviewImage.picture.bitmap.Canvas do
     begin
       copymode:=cmSrcInvert;
       if myshape='Z_rangemove' then
        draw(myprevpoint.x,myprevpoint.y,myclip);
       draw(x,y,myclip);
       myprevpoint:=point(x,y);
       end;
     end;
if myshape='airbrush' then
  if jvAirBrush.Air then
    jvAirBrush.Draw (PreviewImage.picture.bitmap.Canvas,x,y);

if (myshape='zoombrush') or (myshape='zoomkeepbrush') then
  begin
  w:=PreviewImage.Picture.Bitmap.canvas.pen.width;
  if w<5 then w:=50;
  drawplasma(x,y,w);
  end;
if myshape='Pd_fisheye' then
  begin
  w:=canvas.pen.width;
  if w<5 then w:=50;
  draweffectbrush(x,y,w,0.9,lbfisheye);
  end;
if myshape='Pd_fisheyefix' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)/pi*0.5+0.5;
  if angle<0.55 then angle:=0.55;
  if angle>0.99 then angle:=0.99;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,lbfisheye);
  end;
if myshape='Pd_twist' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=abs(arctan2(dy,dx)*25/pi)+1;
  draweffectbrush(myorigin.x,myorigin.y,rr, round(angle),lbtwist);
  end;
if myshape='mbHorOval' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  drawstretchbrush(myorigin.x,myorigin.y,rr,angle,mbHorOval);
  end;
if myshape='mbHorBox' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  drawstretchbrush(myorigin.x,myorigin.y,rr,angle,mbHorBox);
  end;
if myshape='mbVerOval' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  drawstretchbrush(myorigin.x,myorigin.y,rr,angle,mbVerOval);
  end;
if myshape='mbVerBox' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  drawstretchbrush(myorigin.x,myorigin.y,rr,angle,mbVerBox);
  end;
if myshape='mbHor' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,mbHor);
  end;
if myshape='mbTop' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,mbTop);
  end;
if myshape='mbBottom' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,mbBottom);
  end;
if myshape='mbWaste' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,mbWaste);
  end;
if myshape='mbRound' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,mbRound);
  end;
if myshape='mbRound2' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,mbRound2);
  end;
if myshape='mbDiamond' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,mbDiamond);
  end;
if myshape='mbSplitRound' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,mbSplitRound);
  end;
if myshape='mbSplitWaste' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*180/pi;
  draweffectbrush(myorigin.x,myorigin.y,rr,angle,mbSplitWaste);
  end;


if myshape='Pd_rimple' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*10/pi+1;
  draweffectbrush(myorigin.x,myorigin.y,rr, angle,lbrimple);
  end;

if myshape='Pd_rotate' then begin
  if ssalt in shift then moveorigin;
   dx:=x-myorigin.x;
   if dx=0 then dx:=0.01;
   dy:=y-myorigin.y;
   angle:=arctan2(dy,dx)*180/pi;
   draweffectbrush(myorigin.x,myorigin.y,rr, angle,lbrotate);
  end;
if myshape='Pd_brightness' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*100/pi;
  drawlightbrush(myorigin.x,myorigin.y,
    rr, round(angle),lbBrightness);
  end;
if myshape='Pd_contrast' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*100/pi;
  drawlightbrush(myorigin.x,myorigin.y,
   rr, round(angle),lbContrast);
  end;
if myshape='Pd_saturation' then begin
  if ssalt in shift then moveorigin;
  dx:=x-myorigin.x;
  if dx=0 then dx:=0.01;
  dy:=y-myorigin.y;
  angle:=arctan2(dy,dx)*100/pi;
  drawlightbrush(myorigin.x,myorigin.y,
  rr, round(angle),lbContrast);
  end;


if myshape='P_blue' then
  drawcolorcircle(x,y,0);
if myshape='P_green' then
  drawcolorcircle(x,y,1);
if myshape='P_red' then
  drawcolorcircle(x,y,2);
if myshape='P_notblue' then
  drawcolorcircle(x,y,3);
if myshape='P_notgreen' then
  drawcolorcircle(x,y,4);
if myshape='P_notred' then
  drawcolorcircle(x,y,5);
if myshape='P_halfblue' then
  drawcolorcircle(x,y,6);
if myshape='P_halfgreen' then
  drawcolorcircle(x,y,7);
if myshape='P_halfred' then
  drawcolorcircle(x,y,8);
if myshape='P_darker' then
  drawdarkercircle(x,y,9);
if myshape='P_lighter' then
  drawlightercircle(x,y,10);
if myshape='P_gray' then
  drawlightercircle(x,y,11);
if myshape='P_rollmix' then
  drawlightercircle(x,y,12);
if myshape='P_smooth' then
    drawlightercircle(x,y,13);
  if myshape='P_spray'then
   for i:=1 to 10 do begin
     xp:=random(30)-15;
     yp:=random(30)-15;
     PreviewImage.Picture.Bitmap.canvas.Pixels [x+xp,y+yp]:=
     PreviewImage.Picture.Bitmap.canvas.Brush.Color ;
     end;

  if myshape='Pd_gradient' then begin
     with PreviewImage.Picture.Bitmap.canvas do begin
      if ssalt in shift then begin
      color1:=pixels[x,y-pen.width];
      color2:=pixels[x,y+pen.width];
      drawvgradientbrush(color1,color2,y-pen.width,y+pen.width,x);
      drawvgradientbrush(color1,color2,y-pen.width,y+pen.width,x-1);
      drawvgradientbrush(color1,color2,y-pen.width,y+pen.width,x-2);
      end
      else begin
      color1:=pixels[x-pen.width,y];
      color2:=pixels[x+pen.width,y];
      drawgradientbrush(color1,color2,x-pen.width,x+pen.width,y);
      drawgradientbrush(color1,color2,x-pen.width,x+pen.width,y+1);
      drawgradientbrush(color1,color2,x-pen.width,x+pen.width,y+2);
        end;
      end;
     end;

  if myshape='cube1' then
    with PreviewImage.Picture.Bitmap.canvas do begin
      pen.mode:=pmnotxor;
      drawcube;
      myskew[4]:=point(x,y);
      drawcube;
    end;
 if (myshape='Lf_rectangle') or (myshape='L_cube') or (myshape='L_maze')
   or (myshape='interprect')or (myshape='intercolumn') then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     rectangle(myorigin.x,myorigin.y,myprevpoint.x,myprevpoint.y);
     rectangle(myorigin.x,myorigin.y,x,y);
     myprevpoint:=point(x,y);
     end;

 if myshape='Lf_roundrect'then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     roundrect(myorigin.x,myorigin.y,myprevpoint.x,myprevpoint.y,myround,myround);
     roundrect(myorigin.x,myorigin.y,x,y,myround,myround);
     myprevpoint:=point(x,y);
     end;
 if myshape='Fd_blocks' then
   PreviewImage.Picture.Bitmap.canvas.FillRect (pointtoblock(x,y));

 if (myshape='Lf_ellipse') or (myshape='L_globe')or (myshape='intersphere')
   or (myshape='S_multisphere')or (myshape='S_dropletsphere')
   or (myshape='S_wavesphere') or (myshape='S_risingwavesphere')
     or (myshape='Lf_decoval') then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     ellipse(myorigin.x,myorigin.y,myprevpoint.x,myprevpoint.y);
     ellipse(myorigin.x,myorigin.y,x,y);
     myprevpoint:=point(x,y);
     end;
  if (myshape='Lf_chord') or (myshape='Lf_pie') or (myshape='L_arc')then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     ellipse(myorigin.x,myorigin.y,myprevpoint.x,myprevpoint.y);
     ellipse(myorigin.x,myorigin.y,x,y);
     myprevpoint:=point(x,y);
     end;
  if myshape='skewrect1' then
    with PreviewImage.Picture.Bitmap.canvas do begin
      pen.mode:=pmnotxor;
      drawskew;
      myskew[2]:=point(x,y);
      myskew[3].x:=myskew[0].x+(myskew[2].x-myskew[1].x);
      myskew[3].y:=myskew[0].y+(myskew[2].y-myskew[1].y);
      drawskew;
    end;

  if myshape='triangle1' then
    with PreviewImage.Picture.Bitmap.canvas do begin
      pen.mode:=pmnotxor;
      drawtriangle;
      myskew[2]:=point(x,y);
      drawtriangle;
    end;
  if (myshape='polyline') or (myshape='polygon') then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     penpos:=point(myorigin.x,myorigin.y);
     lineto(myprevpoint.x,myprevpoint.y);
     penpos:=point(myorigin.x,myorigin.y);
     lineto(x,y);
     myprevpoint:=point(x,y);
    end;

  if myshape='polybezier' then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     mybezier[0]:=point(myorigin.x,myorigin.y);
     mybezier[3]:=point(myprevpoint.x,myprevpoint.y);
     if not bezierfix1 then begin
       mybezier[1].x:=mybezier[0].x;
       mybezier[1].y:=mybezier[3].y;
       end;
     if not bezierfix2 then begin
       mybezier[2].x:=mybezier[3].x;
       mybezier[2].y:=mybezier[0].y;
       end;
     polybezier(mybezier);
     mybezier[3]:=point(x,y);
     if (ssctrl in shift) then begin
       bezierfix1:=true;
       mybezier[1]:=mybezier[3];
       end;
     if not bezierfix1 then begin
       mybezier[1].x:=mybezier[0].x;
       mybezier[1].y:=mybezier[3].y;
       end;
     if (ssshift in shift) then begin
       bezierfix2:=true;
       mybezier[2]:=mybezier[3];
       end;
     if not bezierfix2 then begin
       mybezier[2].x:=mybezier[3].x;
       mybezier[2].y:=mybezier[0].y;
       end;
     polybezier(mybezier);
     myprevpoint:=point(x,y);
     end;

  if (myshape='L_line') or (myshape='rotatetext') or (myshape='Lx_star')
      or (myshape='Lx_spiral')or (myshape='L_skewrect')or (myshape='L_triangle')
      or (myshape='L_cone')or (myshape='Lx_spiro')or
      (myshape='Lf_decobar') then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     penpos:=point(myorigin.x,myorigin.y);
     lineto(myprevpoint.x,myprevpoint.y);
     penpos:=point(myorigin.x,myorigin.y);
     lineto(x,y);
     myprevpoint:=point(x,y);
     end;
  if (myshape='L_bezier')  then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     mybezier[0]:=point(myorigin.x,myorigin.y);
     mybezier[1]:=mybezier[0];
     mybezier[3]:=point(myprevpoint.x,myprevpoint.y);
     mybezier[2]:=mybezier[3];
     polybezier(mybezier);
     mybezier[3]:=point(x,y);
     mybezier[2]:=mybezier[3];
     polybezier(mybezier);
     myprevpoint:=point(x,y);
     end;
  if (myshape='bezier1')  then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     polybezier(mybezier);
     mybezier[1]:=point(x,y);
     polybezier(mybezier);
     end;
  if (myshape='bezier2') then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     polybezier(mybezier);
     mybezier[2]:=point(x,y);
     polybezier(mybezier);
     end;


  if     (myshape='waveline')
      or (myshape='fastwaveline')
      or (myshape='colorwaveline') then
   with PreviewImage.Picture.Bitmap.canvas do begin
   canvas.lineto(x,y);
   myprevpoint:=point(x,y);
   end;

  if myshape='borderwaveline' then begin
   PreviewImage.Picture.Bitmap.canvas.moveto(myprevpoint.x,myprevpoint.y);
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   PreviewImage.Picture.Bitmap.canvas.MoveTo(width-myprevpoint.x,height-myprevpoint.y);
   PreviewImage.Picture.Bitmap.canvas.lineto(width-x,height-y);
   myprevpoint:=point(x,y);
   end;

  if myshape='decoline' then begin
   with PreviewImage.Picture.Bitmap.canvas do begin
   pw:=pen.width;
   pen.color:=wavepen;
   pen.mode:=pmcopy;
   moveto(myprevpoint.x,myprevpoint.y);
   lineto(x,y);
   pen.width:=pw*2;
   pen.mode:=pmmasknotpen;
   MoveTo(myprevpoint.x,myprevpoint.y);
   lineto(x,y);
   myprevpoint:=point(x,y);
   pen.width:=pw;
   pen.mode:=pmcopy;
   pen.mode:=mypen;
   end;
   end;

  if (myshape='yfreehand')or (myshape='P_mix') then
   with PreviewImage.Picture.Bitmap.canvas do begin
   canvas.lineto(x,y);
   myprevpoint:=point(x,y)
   end;
  if myshape='Z_cloneall'then
   with PreviewImage.Picture.Bitmap.canvas do begin
   x1:=myorigin.x-TargetPoint.x;
   y1:=myorigin.y-Targetpoint.y;
   x2:=x-x1;
   y2:=y-y1;
   copymode:=cmsrccopy;
   i:=pen.width;
   copyrect(rect(x,y,x+i,y+i),canvas,
     rect(x2,y2,x2+i,y2+i));
   end;

  if myshape='Z_clonenottarget' then
   with PreviewImage.Picture.Bitmap.canvas do begin
   x1:=myorigin.x-TargetPoint.x;
   y1:=myorigin.y-Targetpoint.y;
   x2:=x-x1;
   y2:=y-y1;
   i:=pen.width;
   putclip(rect(x2,y2,x2+i,y2+i));
   myclip.transparent:=true;
   myclip.TransparentColor := pixels[Targetpoint.x,Targetpoint.y];
   draw(x,y,myclip);
   myclip.transparent:=false;
   end;

  if (myshape='Z_paste')and (ssshift in shift) then begin
    myrect:=rect(0,0,0,0);
    myrect.left:=x;
    myrect.top:=y;
    myrect.right:=x+mycliprect.right-mycliprect.left;
    myrect.bottom:=y+mycliprect.bottom-mycliprect.Top;
    PreviewImage.Picture.Bitmap.canvas.CopyRect (myrect,
    PreviewImage.Picture.Bitmap.canvas,mycliprect);
    end;


  if myshape='L_sline' then begin
    if myslinedir='none' then
      if abs(x-myorigin.x)>=abs(y-myorigin.y) then
       myslinedir:='h'
       else myslinedir:='v';
    if (myslinedir='h') and (abs(y-myprevpoint.y)>myslinetol) then
       myslinedir:='v';
    if (myslinedir='v') and (abs(x-myprevpoint.x)>myslinetol) then
       myslinedir:='h';
    if myslinedir='h' then begin
       PreviewImage.Picture.Bitmap.canvas.lineto(x,myprevpoint.y);
       myprevpoint.x:=x;
       end;
    if myslinedir='v' then begin
       PreviewImage.Picture.Bitmap.canvas.lineto(myprevpoint.x,y);
       myprevpoint.y:=y;
       end;
  end;
  if myshape='Lm_sym' then drawsyms(x,y);
  if myshape='Lm_vmirror'then begin
   x1:=myprevpoint.x;y1:=myprevpoint.y;
   x2:=width;{y2:=height;}
   PreviewImage.Picture.Bitmap.canvas.PenPos :=point(x2-x1,y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x2-x,y);
   PreviewImage.Picture.Bitmap.canvas.penpos:=point(x1,y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   myprevpoint:=point(x,y)
   end;
  if myshape='Lm_cmirror'then begin
   x1:=myprevpoint.x;y1:=myprevpoint.y;
   x2:=width;y2:=height;
   PreviewImage.Picture.Bitmap.canvas.PenPos :=point(x2-x1,y2-y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x2-x,y2-y);
   PreviewImage.Picture.Bitmap.canvas.penpos:=point(x1,y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   myprevpoint:=point(x,y)
   end;
  if myshape='Lm_mirror4'then begin
   x1:=myprevpoint.x;y1:=myprevpoint.y;
   x2:=width;y2:=height;
   PreviewImage.Picture.Bitmap.canvas.PenPos :=point(x2-x1,y2-y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x2-x,y2-y);
   PreviewImage.Picture.Bitmap.canvas.PenPos :=point(x2-x1,y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x2-x,y);
   PreviewImage.Picture.Bitmap.canvas.PenPos :=point(x1,y2-y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y2-y);
   PreviewImage.Picture.Bitmap.canvas.penpos:=point(x1,y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   myprevpoint:=point(x,y)
   end;
  if myshape='Lm_hmirror'then begin
   x1:=myprevpoint.x;y1:=myprevpoint.y;
{   x2:=width;  }
   y2:=height;
   PreviewImage.Picture.Bitmap.canvas.PenPos :=point(x1,y2-y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y2-y);
   PreviewImage.Picture.Bitmap.canvas.penpos:=point(x1,y1);
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   myprevpoint:=point(x,y)
   end;
  if (myshape='Z_snapshot')
     or (myshape='Fd_bars')or (myshape='Fd_border') then
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     pen.style:=psdot;
     rectangle(myorigin.x,myorigin.y,myprevpoint.x,myprevpoint.y);
     rectangle(myorigin.x,myorigin.y,x,y);
     myprevpoint:=point(x,y);
     pen.style:=pssolid;
     end;
end;
PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
myprevpoint:=point(x,y);
Processing:=False;
end;

//-----------------------------------------------------
//-----------------------------------------------------

procedure TAffectsForm.PreviewImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  mask:tbool2darray;
  TempBitmap:TBitmap;
  ind:integer;
  MyWandRect: TRect;
var myrect:trect;xs,ys,xt,yt,i,tangle:integer;c:tcolor;drw:string;
    apoint:tpoint;bitmap:tbitmap;
    x1,y1,x2,y2:integer;
    dcurve:array[0..3] of tpoint;
    rgn:HRGN;
    r1,g1,b1,r2,g2,b2:byte;
    r,g,b,dr,dg,db:extended;
    Acolor,pcolor:tcolor;
    pw:integer;
begin
If Processing then exit;
If WandingOn then
begin
  if MagicWand2.Checked then
  begin
    screen.cursor:=crhourglass;
    Processing:=True;
    TempBitmap:=TBitmap.Create;
    TempBitmap.Assign(PreviewImage.Picture.Bitmap);
    Maskmagicwand(TempBitmap,x,y,
                  TempBitmap.canvas.pixels[x,y],
                  WandTrackBar.Position/100,{0.3,}
                  mask);
    ShowMagicWandFrame(TempBitmap,mask);
    mask:=nil;
    PreviewImage.Picture.Bitmap.Assign(TempBitmap);
    TempBitmap.Free;
    screen.cursor:=crdefault;
  end else
  if MagicWandCB.Checked then
  begin
    screen.cursor:=crhourglass;
    Processing:=True;
    TempBitmap:=tbitmap.create;
    TempBitmap.assign(PreviewImage.picture.bitmap);
    ind:=WandCoB.itemindex;
    if ind<0 then ind:=0;
    fill(TempBitmap,x,y,WandColorBtn.Font.color,
         TempBitmap.canvas.pixels[x,y],
         WandTrackBar.Position/100,ind,0.1,0.5);
    {procedure fill(var bitmap1:tbitmap;
              a,b:integer;newcolor,oldcolor:tcolor;
              tolerance:Double;fill_type:byte;intens,tras:Double);}
    PreviewImage.picture.bitmap:=TempBitmap;
    TempBitmap.free;
    screen.cursor:=crdefault;
  end else
  if LightWandCB.Checked then
  begin
    screen.cursor:=crhourglass;
    Processing:=True;
    TempBitmap:=tbitmap.create;
     {TempBitmap.assign(PreviewImage.picture.bitmap);}
    If WandSrcRG.ItemIndex=0 then
       TempBitmap.assign(PreviewImage.picture.bitmap)
    else TempBitmap.assign(TongsForm.Image1.picture.bitmap);
    MyWandRect:=Rect(x-5,y-5,x+5,y+5);
    Case WandPainterRG.ItemIndex of
       0: PreviewImage.Canvas.CopyMode := cmBlackness;
       1: PreviewImage.Canvas.CopyMode := cmDstInvert	;
       2: PreviewImage.Canvas.CopyMode := cmMergeCopy	;
       3: PreviewImage.Canvas.CopyMode := cmMergePaint;
       4: PreviewImage.Canvas.CopyMode := cmNotSrcCopy;
       5: PreviewImage.Canvas.CopyMode := cmNotSrcErase;
       6: PreviewImage.Canvas.CopyMode := cmPatCopy	;
       7: PreviewImage.Canvas.CopyMode := cmPatInvert	;
       8: PreviewImage.Canvas.CopyMode := cmPatPaint	;
       9: PreviewImage.Canvas.CopyMode := cmSrcAnd	;
       10: PreviewImage.Canvas.CopyMode := cmSrcCopy	;
       11: PreviewImage.Canvas.CopyMode := cmSrcErase	;
       12: PreviewImage.Canvas.CopyMode := cmSrcInvert	;
       13: PreviewImage.Canvas.CopyMode := cmSrcPaint	;{}
       14: PreviewImage.Canvas.CopyMode := cmWhiteness;
    end;
    SpotLight(TempBitmap,
              WandTrackBar.Position,
              MyWandRect);
    { TempBitmap.TransparentColor:=clBlack; }
    { TempBitmap.TransparentMode := tmAuto;}
    PreviewImage.Canvas.CopyRect(MyWandRect,TempBitmap.Canvas,MyWandRect);
    {PreviewImage.Canvas.BrushCopy(MyWandRect, TempBitmap, MyWandRect, clBlack);}
    {PreviewImage.picture.bitmap:=TempBitmap;}
    PreviewImage.Canvas.CopyMode := cmSrcCopy; { restore the copy mode }
    TempBitmap.free;
    screen.cursor:=crdefault;
  end;
end else
begin
Processing:=True;  { Processing:=False;}
//canvas.pen.color:=wavepen;
//canvas.brush.color:=wavebrush;

if ((ssctrl in shift) and (ssalt in shift)) then exit;
if button=mbright then exit;
mypen:=PreviewImage.Picture.Bitmap.canvas.pen.mode;


if myshape='zoombrush' then
  PreviewImage.Picture.Bitmap.canvas.Draw (0,0,zoomclip);
if myshape='Z_transcopy' then
  begin
  myclipcm:=cmSrcCopy;
  setclip(clwhite);
  copyclip;
  myrect:=rect(x,y,x+myclip.width-1,y+myclip.height-1);
  PreviewImage.Picture.Bitmap.canvas.brushcopy(myrect,myclip,
    rect(0,0,myclip.width,myclip.height),RangeTransColor);
  mydraw:=false;
  end;
if myshape='cube1' then
  begin
  if mypen<>pmnotxor then
    drawcube;
  myshape:='cube2';
  end;

  if myshape='X_texlines'then begin
   drawtexlines(myorigin.x,myorigin.y,x,y);
   end;
  if myshape='X_texovals'then begin
   drawtexovals(myorigin.x,myorigin.y,x,y);
   end;
  if myshape='X_blurovals'then begin
   drawblurovals(myorigin.x,myorigin.y,x,y);
   end;
  if myshape='X_texcurves'then begin
   drawtexcurves(myorigin.x,myorigin.y,x,y);
   end;
  if myshape='X_blurcurves'then begin
   drawblurcurves(myorigin.x,myorigin.y,x,y);
   end;
  if myshape='X_texpoly'then begin
   drawtexpoly(myorigin.x,myorigin.y,x,y);
   end;
  if myshape='X_blurpoly'then begin
   drawblurpoly(myorigin.x,myorigin.y,x,y);
   end;
  if myshape='X_texrects'then begin
   drawtexrects(myorigin.x,myorigin.y,x,y);
   end;
  if myshape='X_blurrects'then begin
   drawblurrects(myorigin.x,myorigin.y,x,y);
   end;
  if myshape='X_blurlines'then begin
   drawblurlines(myorigin.x,myorigin.y,x,y);
   end;


if myshape='L_cube' then begin
  myskew[0]:=myorigin;
  myskew[2]:=point(x,y);
  myskew[4]:=myskew[2];
  myskew[1].x:=myskew[2].x;
  myskew[1].y:=myskew[0].y;
  myskew[3].x:=myskew[0].x;
  myskew[3].y:=myskew[2].y;
  drawcube;
  myshape:='cube1';
  end;

if myshape='interprect' then
  interpRect(myorigin.x,myorigin.y,x,y);

if myshape='intercolumn' then
  drawcolumn(myorigin.x,myorigin.y,x,y);


if myshape='intersphere' then
  if ((myorigin.x<>x)and (myorigin.y<>y))then
  begin
  if ssalt in shift then
  drawsphere(PreviewImage.Picture.Bitmap.canvas.pixels[myorigin.x,myorigin.y],
     PreviewImage.Picture.Bitmap.canvas.pixels[x,y],myorigin.x,myorigin.y,x,y)
   else
  drawsphere(wavepen,wavebrush,myorigin.x,myorigin.y,x,y)
  end;

if myshape='S_multisphere' then
  begin
  PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmnotxor;
  PreviewImage.Picture.Bitmap.canvas.ellipse(myorigin.x,myorigin.y,x,y);
  PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmcopy;
  if ((myorigin.x<>x)and (myorigin.y<>y))then begin
   if ssalt in shift then
   drawmultisphere(PreviewImage.Picture.Bitmap.canvas.pixels[myorigin.x,myorigin.y],
     PreviewImage.Picture.Bitmap.canvas.pixels[x,y],myorigin.x,myorigin.y,x,y)
   else
   drawmultisphere(wavepen,wavebrush,myorigin.x,myorigin.y,x,y)
   end;
  end;
if myshape='S_dropletsphere' then
  begin
  PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmnotxor;
  PreviewImage.Picture.Bitmap.canvas.ellipse(myorigin.x,myorigin.y,x,y);
  PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmcopy;
  if ((myorigin.x<>x)and (myorigin.y<>y))then begin
  if ssalt in shift then
  drawdropletsphere(PreviewImage.Picture.Bitmap.canvas.pixels[myorigin.x,myorigin.y],
     PreviewImage.Picture.Bitmap.canvas.pixels[x,y],myorigin.x,myorigin.y,x,y)
   else
  drawdropletsphere(wavepen,wavebrush,myorigin.x,myorigin.y,x,y)
  end;
  end;

if myshape='S_wavesphere' then
  begin
  PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmnotxor;
  PreviewImage.Picture.Bitmap.canvas.ellipse(myorigin.x,myorigin.y,x,y);
  PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmcopy;
  if ((myorigin.x<>x)and (myorigin.y<>y))then begin
  if ssalt in shift then
  drawwavesphere(PreviewImage.Picture.Bitmap.canvas.pixels[myorigin.x,myorigin.y],
     PreviewImage.Picture.Bitmap.canvas.pixels[x,y],myorigin.x,myorigin.y,x,y)
   else
  drawwavesphere(wavepen,wavebrush,myorigin.x,myorigin.y,x,y)
  end;
  end;

if myshape='S_risingwavesphere' then
  begin
  PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmnotxor;
  PreviewImage.Picture.Bitmap.canvas.ellipse(myorigin.x,myorigin.y,x,y);
  PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmcopy;
  if ((myorigin.x<>x)and (myorigin.y<>y))then begin
  if ssalt in shift then
  drawrisingwavesphere(PreviewImage.Picture.Bitmap.canvas.pixels[myorigin.x,myorigin.y],
     PreviewImage.Picture.Bitmap.canvas.pixels[x,y],myorigin.x,myorigin.y,x,y)
   else
  drawrisingwavesphere(wavepen,wavebrush,myorigin.x,myorigin.y,x,y)
  end;
  end;

if myshape='Lf_rectangle'then
  begin
   if mypen<>pmnotxor then
  PreviewImage.Picture.Bitmap.canvas.rectangle(myorigin.x,myorigin.y,x,y);
  if stars>1 then begin
    xs:=(x- myorigin.x)div 2 div stars;
    ys:=(y- myorigin.y)div 2 div stars;
    for i:=1 to stars-1 do begin
      PreviewImage.Picture.Bitmap.canvas.rectangle(myorigin.x+i*xs,myorigin.y+i*ys,x-i*xs,y-i*ys);
      end;
    end;
  end;

if myshape='L_maze'then
  begin
   if mypen<>pmnotxor then
     PreviewImage.Picture.Bitmap.canvas.rectangle(myorigin.x,myorigin.y,x,y);
   xs:=(x-myorigin.x) div 10;
   ys:=(y-myorigin.y) div 10;
   xt:=myorigin.x;
   yt:=myorigin.y;
   for i:=1 to 10 do begin
     PreviewImage.Picture.Bitmap.canvas.MoveTo (xt+i*xs,y);
     PreviewImage.Picture.Bitmap.canvas.lineto (x,y-i*ys);
     PreviewImage.Picture.Bitmap.canvas.MoveTo (x,y-i*ys);
     PreviewImage.Picture.Bitmap.canvas.lineto (x-i*xs,yt);
     PreviewImage.Picture.Bitmap.canvas.MoveTo (x-i*xs,yt);
     PreviewImage.Picture.Bitmap.canvas.lineto (xt,yt+i*ys);
     PreviewImage.Picture.Bitmap.canvas.MoveTo (xt,yt+i*ys);
     PreviewImage.Picture.Bitmap.canvas.lineto (xt+i*xs,y);
     end;
  end;

if myshape='Lf_roundrect'then
  begin
   if mypen<>pmnotxor then
  PreviewImage.Picture.Bitmap.canvas.roundrect(myorigin.x,myorigin.y,x,y,myround,myround);
  if stars>1 then begin
    xs:=(x- myorigin.x)div 2 div stars;
    ys:=(y- myorigin.y)div 2 div stars;
    for i:=1 to stars-1 do begin
      PreviewImage.Picture.Bitmap.canvas.roundrect(myorigin.x+i*xs,myorigin.y+i*ys,x-i*xs,y-i*ys,myround,myround);
      end;
    end;
  end;

if myshape='Fd_blocks' then
   PreviewImage.Picture.Bitmap.canvas.FillRect (pointtoblock(x,y));


if myshape='Lx_star' then begin
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     penpos:=point(myorigin.x,myorigin.y);
     lineto(myprevpoint.x,myprevpoint.y);
   end;
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
   for i:=1 to stars do begin
     apoint:=reducevector(myorigin,point(x,y),i/stars);
     star(apoint.x,apoint.y);
     end;
   end;

if myshape='Lx_spiral' then begin
   with PreviewImage.Picture.Bitmap.canvas do begin
     pen.mode:=pmnotxor;
     penpos:=point(myorigin.x,myorigin.y);
     lineto(myprevpoint.x,myprevpoint.y);
   end;
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
   apoint:=point(100*x,100*y);
   myorigin.x:=100*myorigin.x;
   myorigin.y:=100*myorigin.y;
   for i:=1 to variant(spirals*36) do begin
     apoint:=rotate(myorigin,apoint,spiraldir*pi/18);
     apoint:=reducevector(myorigin,apoint,spiralfactor);
     PreviewImage.Picture.Bitmap.canvas.lineto(apoint.x div 100,apoint.y div 100);
     end;
   end;


if myshape='Lf_ellipse'then begin
   if mypen<>pmnotxor then
     PreviewImage.Picture.Bitmap.canvas.ellipse(myorigin.x,myorigin.y,x,y);
  if stars>1 then begin
    xs:=(x- myorigin.x)div 2 div stars;
    ys:=(y- myorigin.y)div 2 div stars;
    for i:=1 to stars-1 do begin
      PreviewImage.Picture.Bitmap.canvas.ellipse(myorigin.x+i*xs,myorigin.y+i*ys,x-i*xs,y-i*ys);
      end;
    end;
  end;

if myshape='L_globe'then begin
   if mypen<>pmnotxor then
     PreviewImage.Picture.Bitmap.canvas.ellipse(myorigin.x,myorigin.y,x,y);
   xs:=(x-myorigin.x ) div 20;
   ys:=(y-myorigin.y ) div 20;
   for i:=1 to 10 do begin
     PreviewImage.Picture.Bitmap.canvas.ellipse(myorigin.x+i*xs,myorigin.y,x-i*xs,y);
     PreviewImage.Picture.Bitmap.canvas.ellipse(myorigin.x,myorigin.y+i*ys,x,y-i*ys);
   end;
  end;


if myshape='chord2' then begin
   mychord[7]:=x;
   mychord[8]:=y;
   myshape:='chord3';
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmnotxor;
   PreviewImage.Picture.Bitmap.canvas.ellipse(mychord[1],mychord[2],mychord[3],mychord[4]);
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
   PreviewImage.Picture.Bitmap.canvas.Chord (mychord[1],mychord[2],mychord[3],mychord[4],mychord[5],mychord[6],mychord[7],mychord[8]);
   end else
if myshape='chord1' then begin
   mychord[5]:=x;
   mychord[6]:=y;
   myshape:='chord2';
   end else
if myshape='Lf_chord'then
  begin
  mychord[1]:=myorigin.x;
  mychord[2]:=myorigin.y;
  mychord[3]:=x;
  mychord[4]:=y;
  myshape:='chord1';
  end else
if myshape='arc2' then begin
   mychord[7]:=x;
   mychord[8]:=y;
   myshape:='arc3';
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmnotxor;
   PreviewImage.Picture.Bitmap.canvas.ellipse(mychord[1],mychord[2],mychord[3],mychord[4]);
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
   PreviewImage.Picture.Bitmap.canvas.arc (mychord[1],mychord[2],mychord[3],mychord[4],mychord[5],mychord[6],mychord[7],mychord[8]);
   end else
if myshape='arc1' then begin
   mychord[5]:=x;
   mychord[6]:=y;
   myshape:='arc2';
   end else
if myshape='L_arc'then
  begin
  mychord[1]:=myorigin.x;
  mychord[2]:=myorigin.y;
  mychord[3]:=x;
  mychord[4]:=y;
  myshape:='arc1';
  end;


if myshape='pie2' then begin
   mychord[7]:=x;
   mychord[8]:=y;
   myshape:='pie3';
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmnotxor;
   PreviewImage.Picture.Bitmap.canvas.ellipse(mychord[1],mychord[2],mychord[3],mychord[4]);
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
   PreviewImage.Picture.Bitmap.canvas.pie (mychord[1],mychord[2],mychord[3],mychord[4],mychord[5],mychord[6],mychord[7],mychord[8]);
   end else
if myshape='pie1' then begin
   mychord[5]:=x;
   mychord[6]:=y;
   myshape:='pie2';
   end else
if myshape='Lf_pie'then
  begin
  mychord[1]:=myorigin.x;
  mychord[2]:=myorigin.y;
  mychord[3]:=x;
  mychord[4]:=y;
  myshape:='pie1';
  end;

  if myshape='skewrect1' then begin
   if mypen<>pmnotxor then
    drawskew;
  myshape:='skewrect2';
  end else
if myshape='L_skewrect'then begin
  PreviewImage.Picture.Bitmap.canvas.penpos:=point(myorigin.x,myorigin.y);
   if mypen<>pmnotxor then
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   myskew[0]:=myorigin;
   myskew[1]:=point(x,y);
   myskew[2]:=myskew[1];
   myskew[3]:=myskew[0];
   myshape:='skewrect1';
  end;

  if myshape='triangle1' then begin
   if mypen<>pmnotxor then
    drawtriangle;
  myshape:='triangle2';
  end else
if myshape='L_triangle' then begin
  PreviewImage.Picture.Bitmap.canvas.penpos:=point(myorigin.x,myorigin.y);
   if mypen<>pmnotxor then
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   myskew[0]:=myorigin;
   myskew[1]:=point(x,y);
   myskew[2]:=myskew[1];
   myshape:='triangle1';
  end;


 if myshape='Lf_decobar' then
 begin
   PreviewImage.Picture.Bitmap.PixelFormat :=MyPixelFormat;
   with PreviewImage.Picture.Bitmap.canvas do begin
   pw:=pen.width;
   pcolor:=pen.color;
   Acolor:={colortoRGB}(wavebrush);
   r1:=getred(Acolor);
   r:=r1;
   g1:=getgreen(acolor);
   g:=g1;
   b1:=getblue(acolor);
   b:=b1;
   Acolor:={colortoRGB}(pen.color);
   r2:=getred(Acolor);
   g2:=getgreen(acolor);
   b2:=getblue(acolor);
   dr:=(r1-r2)/(pw/3);
   dg:=(g1-g2)/(pw/3);
   db:=(b1-b2)/(pw/3);
     if pw<30 then
     pen.width:=30;
   for i:=1 to pen.width div 3 do begin
     r:=r-dr;
     g:=g-dg;
     b:=b-db;
     pen.color:=rgb(round(r),round(g),round(b));
     moveto(myorigin.x,myorigin.y);
     lineto(x,y);
     pen.width:=pen.width-2;
     end;
     pen.width:=pw;
     pen.color:=pcolor;
   end;
   end;

 if myshape='Lf_decoval' then begin
   PreviewImage.Picture.Bitmap.PixelFormat :=MyPixelFormat;
   with PreviewImage.Picture.Bitmap.canvas do begin
   pen.mode:=pmnotxor;
   ellipse(myorigin.x,myorigin.y,myprevpoint.x,myprevpoint.y);
   pen.mode:=pmcopy;
   pw:=pen.width;
   brush.style:=bsclear;
   Acolor:={colortoRGB}(wavebrush);
   r1:=getred(Acolor);
   r:=r1;
   g1:=getgreen(acolor);
   g:=g1;
   b1:=getblue(acolor);
   b:=b1;
   Acolor:={colortoRGB}(wavepen);
   r2:=getred(Acolor);
   g2:=getgreen(acolor);
   b2:=getblue(acolor);
   dr:=(r1-r2)/(pw/3);
   dg:=(g1-g2)/(pw/3);
   db:=(b1-b2)/(pw/3);
     if pw<30 then
     pen.width:=30;
   for i:=1 to pen.width div 3 do begin
     pen.width:=pen.width-2;
     r:=r-dr;
     g:=g-dg;
     b:=b-db;
     pen.color:=rgb(round(r),round(g),round(b));
     ellipse(myorigin.x,myorigin.y,x,y);
     end;
     pen.width:=pw;
   end;
   end;

if (myshape='polyline')or(myshape='polygon') then begin
  PreviewImage.Picture.Bitmap.canvas.penpos:=point(myorigin.x,myorigin.y);
  if mypen<>pmnotxor then
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
  if freepolycount=0 then begin
    freepoly[0]:=myorigin;
    inc(freepolycount);
    end
    else begin
    freepoly[freepolycount]:=point(x,y);
    if freepolycount<100 then
     inc(freepolycount);
    end;
  end;

if myshape='L_line'then begin
  PreviewImage.Picture.Bitmap.canvas.penpos:=point(myorigin.x,myorigin.y);
   if mypen<>pmnotxor then begin
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   end;
  end;

if myshape='Lx_spiro' then begin
   PreviewImage.Picture.Bitmap.canvas.penpos:=point(myorigin.x,myorigin.y);
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmnotxor;
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
   drawspiro(myorigin,point(x,y));
  end;

if myshape='L_cone'then begin
   PreviewImage.Picture.Bitmap.canvas.penpos:=point(myorigin.x,myorigin.y);
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=pmnotxor;
   PreviewImage.Picture.Bitmap.canvas.lineto(x,y);
   PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
   xt:=(PreviewImage.Picture.Bitmap.Width -2 * myorigin.x) div 20;
   xs:=(PreviewImage.Picture.Bitmap.Width -2*x) div 20;
   x:=PreviewImage.Picture.Bitmap.width div 2;
   with PreviewImage.Picture.Bitmap.canvas do begin
     for i:=0 to 10 do begin
       moveto(x+i*xt,myorigin.y);
       lineto(x+i*xs,y);
       moveto(x-i*xt,myorigin.y);
       lineto(x-i*xs,y);
       end;
       moveto(x+10*xt,myorigin.y);
       lineto(x-10*xt,myorigin.y);
       moveto(x+10*xs,y);
       lineto(x-10*xs,y);
     end;
  end;

if myshape='polybezier' then begin
  PreviewImage.Picture.Bitmap.canvas.penpos:=point(myorigin.x,myorigin.y);
   if mypen<>pmnotxor then
     begin
     mybezier[0]:=myorigin;
     mybezier[3]:=point(x,y);
     if not bezierfix1 then begin
       mybezier[1].x:=mybezier[0].x;
       mybezier[1].y:=mybezier[3].y;
       end;
     if not bezierfix2 then begin
       mybezier[2].x:=mybezier[3].x;
       mybezier[2].y:=mybezier[0].y;
       end;
     PreviewImage.Picture.Bitmap.canvas.polybezier(mybezier);
     bezierfix1:=false;
     bezierfix2:=false;
     end;
  end;

if myshape='bezier2'then
  begin
  PreviewImage.Picture.Bitmap.canvas.penpos:=point(myorigin.x,myorigin.y);
   if mypen<>pmnotxor then
     begin
     mybezier[2]:=point(x,y);
     PreviewImage.Picture.Bitmap.canvas.polybezier(mybezier);
     end;
  myshape:='bezier3';
  end;

if myshape='bezier1' then myshape:='bezier2';
if myshape='L_bezier'then myshape:='bezier1';
if myshape='bezier3' then myshape:='Lf_bezier';


if myshape='yfloodfill'then
 begin
  if ssalt in shift then
   PreviewImage.Picture.Bitmap.canvas.floodfill(x,y,canvas.pen.color,fsborder)
   else
   PreviewImage.Picture.Bitmap.canvas.floodfill(x,y,canvas.pixels[x,y],fssurface);
  end;

if myshape='Z_snapshot'then
  begin
  with PreviewImage.Picture.Bitmap.canvas do
  begin
    pen.mode:=pmnotxor;
    pen.style:=psdot;
    rectangle(myorigin.x,myorigin.y,x,y);
    pen.style:=pssolid;
  end;
  mycliprect:=rect(myorigin.x,myorigin.y,x,y);
  PreviewImage.Picture.Bitmap.canvas.brush.Style :=myoldbrushstyle;
  PreviewImage.Picture.Bitmap.canvas.Pen.Width:=myoldpenwidth;
  {myshape:='';  }selectshape('L_line');
  end;

if myshape='Fd_bars'then
  begin
  with PreviewImage.Picture.Bitmap.canvas do
  begin
    pen.mode:=pmnotxor;
    pen.style:=psdot;
    rectangle(myorigin.x,myorigin.y,x,y);
    pen.style:=pssolid;
  end;
  drawbars(myorigin.x,myorigin.y,x,y);
  end;

if myshape='Fd_border'then
  begin
  with PreviewImage.Picture.Bitmap.canvas do
  begin
    pen.mode:=pmnotxor;
    pen.style:=psdot;
    rectangle(myorigin.x,myorigin.y,x,y);
    pen.style:=pssolid;
  end;
  drawborders(myorigin.x,myorigin.y,x,y);
  end;


if myshape='Z_paste' then
  begin
  myrect:=rect(0,0,0,0);
  myrect.left:=x;
  myrect.top:=y;
  myrect.right:=x+mycliprect.right-mycliprect.left;
  myrect.bottom:=y+mycliprect.bottom-mycliprect.Top;
  PreviewImage.Picture.Bitmap.canvas.CopyRect (myrect,
      PreviewImage.Picture.Bitmap.canvas,mycliprect);
  end;

if myshape='Z_pastecolor' then
  begin
  myclipcm:=cmsrccopy;
  setclip(clwhite);
  copyclip;
  ExtractColor (myclip,PreviewImage.Picture.Bitmap.canvas.brush.color);
  PreviewImage.Picture.Bitmap.canvas.Draw (x,y,myclip);
  myclip.transparent:=false;
  end;

if myshape='Z_pastecolorx' then
  begin
  myclipcm:=cmsrccopy;
  setclip(clwhite);
  copyclip;
  ExcludeColor (myclip,PreviewImage.Picture.Bitmap.canvas.brush.color);
  PreviewImage.Picture.Bitmap.canvas.Draw (x,y,myclip);
  myclip.transparent:=false;
  end;

if myshape='zoomkeepbrush' then
  begin
  myshape:='yfreehand';
  PreviewImage.Picture.Bitmap.canvas.pen.Width :=2;
  end;

if myshape='Z_paintpick'then begin
  if ssalt in shift then
    PreviewImage.Picture.Bitmap.canvas.brush.color:=mixcolors(
     PreviewImage.Picture.Bitmap.canvas.pixels[x-5,y],
     PreviewImage.Picture.Bitmap.canvas.pixels[x+5,y])
    else
    PreviewImage.Picture.Bitmap.canvas.brush.color:=
    PreviewImage.Picture.Bitmap.canvas.pixels[x,y];
  onColorPicked:=(PreviewImage.Picture.Bitmap.canvas.brush.color);
   {myshape:='';}selectshape('L_line');
  end;

  PreviewImage.Picture.Bitmap.canvas.pen.mode:=mypen;
  if (not ((myshape='polygon') or
       (myshape='polyline') or
       (myshape='polybezier'))) then
  begin
  mydraw:=false;
  end;
end;
Processing:=False;
end;
//-----------------------------------------------------
//-----------------------------------------------------


//-----------------------------------------------------
//-----------------------------------------------------
// start of functions used in Quick Background
function BGProd(inner,outer:Integer):integer;
begin
result:=outer*inner mod ImgDrawFactor;
end;

function BGSum(inner,outer:Integer):integer;
begin
result:=(outer+inner) mod ImgDrawFactor;
end;

function BGSub(inner,outer:Integer):integer;
begin
result:=(outer - inner) mod ImgDrawFactor;
end;

function BGXor(inner,outer:Integer):integer;
begin
result:=(outer xor inner) mod ImgDrawFactor;
end;

function BGAnd(inner,outer:Integer):integer;
begin
result:=(outer and inner) mod ImgDrawFactor;
end;

function BGOutXor(inner,outer:Integer):integer;
begin
result:=outer xor ImgDrawFactor;
end;

function BGInXor(inner,outer:Integer):integer;
begin
result:=inner xor ImgDrawFactor;
end;

function BGOutAnd(inner,outer:Integer):integer;
begin
result:=outer and ImgDrawFactor;
end;

function BGInAnd(inner,outer:Integer):integer;
begin
result:=inner and ImgDrawFactor;
end;

function BGOutMod(inner,outer:Integer):integer;
begin
result:=outer mod ImgDrawFactor;
end;

function BGInMod(inner,outer:Integer):integer;
begin
result:=inner mod ImgDrawFactor;
end;

function BGProdXor(inner,outer:Integer):integer;
begin
result:=(outer*inner) xor ImgDrawFactor;
end;

function BGSumXor(inner,outer:Integer):integer;
begin
result:=(outer+inner) xor ImgDrawFactor;
end;

function BGSubXor(inner,outer:Integer):integer;
begin
result:=(outer-inner) xor ImgDrawFactor;
end;

function BGProdAnd(inner,outer:Integer):integer;
begin
result:=(outer*inner) and ImgDrawFactor;
end;

function BGSumAnd(inner,outer:Integer):integer;
begin
result:=(outer+inner) and ImgDrawFactor;
end;

function BGSubAnd(inner,outer:Integer):integer;
begin
result:=(outer-inner) and ImgDrawFactor;
end;

function BGInner(inner,outer:Integer):integer;
begin
result:=inner;
end;

function BGOuter(inner,outer:Integer):integer;
begin
result:=outer;
end;

function BGOutRed(inner,outer:Integer):integer;
begin
result:=QBDRed * outer;
end;

function BGInRed(inner,outer:Integer):integer;
begin
result:=QBDRed * inner;
end;

function BGOutGreen(inner,outer:Integer):integer;
begin
result:=QBDGreen * outer;
end;

function BGInGreen(inner,outer:Integer):integer;
begin
result:=QBDGreen * inner;
end;

function BGOutBlue(inner,outer:Integer):integer;
begin
result:=QBDBlue * outer;
end;

function BGInBlue(inner,outer:Integer):integer;
begin
result:=QBDBlue * inner;
end;

function BGInModOut(inner,outer:Integer):integer;
begin
if outer<ImgDrawFactor then
  outer:=ImgDrawFactor;
result:=inner mod outer;
end;

function BGOutModIn(inner,outer:Integer):integer;
begin
if inner<ImgDrawFactor then
  inner:=ImgDrawFactor;
result:=outer mod inner;
end;

function BGOutModIn2(inner,outer:Integer):integer;
begin
result:=outer mod (2+inner) mod (2+outer+inner);
end;

function BGModMod(inner,outer:Integer):integer;
begin
result:=(outer mod ImgDrawFactor) * (inner mod ImgDrawFactor);
end;

function BGModModXor(inner,outer:Integer):integer;
begin
result:=(outer mod ImgDrawFactor) xor (inner mod ImgDrawFactor);
end;

function BGMod3(inner,outer:Integer):integer;
begin
result:=(outer mod ImgDrawFactor) mod ((inner mod ImgDrawFactor)+1);
end;

function BGModModSub(inner,outer:Integer):integer;
begin
result:=(outer mod ImgDrawFactor) - (inner mod ImgDrawFactor);
end;

function BGModModAdd(inner,outer:Integer):integer;
begin
result:=(outer mod ImgDrawFactor) + (inner mod ImgDrawFactor);
end;

function BGModModAnd(inner,outer:Integer):integer;
begin
result:=(outer mod ImgDrawFactor) and (inner mod ImgDrawFactor);
end;

function BGModModOr(inner,outer:Integer):integer;
begin
result:=(outer mod ImgDrawFactor) or (inner mod ImgDrawFactor);
end;

function BGXOr3(inner,outer:Integer):integer;
begin
result:=outer xor ImgDrawFactor xor inner;
end;

function BGXOr3Mod(inner,outer:Integer):integer;
begin
result:=(outer xor inner mod ImgDrawFactor) xor (inner mod ImgDrawFactor);
end;

function BGSubXorSum(inner,outer:integer):integer;
begin
result:=(outer-inner) xor (outer+inner);
end;

function BGSubProdSum(inner,outer:integer):integer;
begin
result:=(outer-inner) * (outer+inner);
end;

function BGProdProdSum(inner,outer:integer):integer;
begin
result:=(outer*inner) * (outer+inner);
end;

function BGDrawXor(inner,outer:integer):integer;
begin
result:=(outer-imgDrawFactor) xor (ImgDrawFactor+inner);
end;


// end of functions used in Quick Background
procedure TAffectsForm.setQBFuncs;
begin
QBFuncs[0]:=BGProd;
QBFuncs[1]:=BGSum;
QBFuncs[2]:=BGSub;
QBFuncs[3]:=BGXor;
QBFuncs[4]:=BGAnd;
QBFuncs[5]:=BGOutAnd;
QBFuncs[6]:=BGInAnd;
QBFuncs[7]:=BGOutXor;
QBFuncs[8]:=BGInXor;
QBFuncs[9]:=BGOutMod;
QBFuncs[10]:=BGInMod;
QBFuncs[11]:=BGProdXor;
QBFuncs[12]:=BGSumXor;
QBFuncs[13]:=BGSubXor;
QBFuncs[14]:=BGProdAnd;
QBFuncs[15]:=BGSumAnd;
QBFuncs[16]:=BGSubAnd;
QBFuncs[17]:=BGInner;
QBFuncs[18]:=BGOuter;
QBFuncs[19]:=BGOutRed;
QBFuncs[20]:=BGInRed;
QBFuncs[21]:=BGOutGreen;
QBFuncs[22]:=BGInGreen;
QBFuncs[23]:=BGOutblue;
QBFuncs[24]:=BGInBlue;
QBFuncs[25]:=BGInModOut;
QBFuncs[26]:=BGOutModIn;
QBFuncs[27]:=BGOutModIn2;
QBFuncs[28]:=BGModMod;
QBFuncs[29]:=BGModModXor;
QBFuncs[30]:=BGMod3;
QBFuncs[31]:=BGModModSub;
QBFuncs[32]:=BGModModAdd;
QBFuncs[33]:=BGModModAnd;
QBFuncs[34]:=BGModModOr;
QBFuncs[35]:=BGXOr3;
QBFuncs[36]:=BGXOr3Mod;
QBFuncs[37]:=BGSubXorSum;
QBFuncs[38]:=BGSubProdSum;
QBFuncs[39]:=BGProdProdSum;
QBfuncs[40]:=BGDrawXor;
end;

//-----------------------------------------------------
//   TAffectsForm
//-----------------------------------------------------
procedure TAffectsForm.setlabels;
begin
redradio.caption:= qblist.items[QBRedfn];
greenradio.caption:= qblist.items[QBGreenfn];
blueradio.caption:= qblist.items[QBbluefn];
end;

procedure TAffectsForm.QuickBack;
var
  bmp:tbitmap;
  i,j:integer;
  line:Pbytearray;
{  dest,src:trect;}
begin
  RedBack:=QBFuncs[QBRedfn];
  GreenBack:=QBFuncs[QBGreenfn];
  BlueBack:=QBFuncs[QBBluefn];
  Bmp := TBitMap.create;
  bmp.Assign(TongsForm.Image1.Picture.Bitmap{PreviewImage.Picture.Bitmap});
{  (PainterF.picture.bitmap);}
  bmp.pixelformat:=MyPixelFormat;
  for i:=0 to bmp.height-1 do
  begin
    line:=pbytearray(bmp.scanline[i]);
    for j:=0 to bmp.width-1 do
    begin
      line[j*3]:= QBDRed+RedBack(i,j);
      line[j*3+1]:=QBDGreen+GreenBack(i,j);
      line[j*3+2]:=QBDBlue+BlueBack(i,j);
    end;
  end;
  PreviewImage.Picture.Bitmap.Assign(bmp);
{  PainterF.Preview(bmp);}
  Bmp.free;
end;


procedure TAffectsForm.QBListClick(Sender: TObject);
var index:integer;
begin
index:=QBList.ItemIndex ;
if redradio.checked then
  QBRedfn:=index;
if greenradio.checked then
  QBGreenfn:=index;
if blueradio.checked then
  QBBluefn:=index;
setlabels;
QuickBack;
end;


procedure TAffectsForm.qbpresetsDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var s:string;
    p:integer;
begin
s:=qbpresets.Items [index];
p:=pos('=',s);
s:=copy(s,1,p-1);
qbpresets.Canvas.TextRect (rect,rect.left,rect.top,s);
end;

procedure TAffectsForm.qbpresetsClick(Sender: TObject);
begin
if qbpresets.itemindex>=0 then
  strtoQuickBack(qbpresets.items[qbpresets.itemindex]);
end;


procedure TAffectsForm.AddBackdrop1Click(Sender: TObject);
var s:string;
begin
s:=inputbox('Painter Quick Backdrops','Enter Name:','');
if s='' then exit;
s:=s+'='+inttostr(QBRedfn)+','
   +inttostr(QBGreenfn)+','
   +inttostr(QBBluefn)+','
   +inttostr(QBDRed)+','
   +inttostr(QBDGreen)+','
   +inttostr(QBDBlue)+','
   +inttostr(ImgDrawFactor);
qbpresets.Items.Append (s);
qbpresets.Items.SaveToFile (QBFile);
end;


procedure TAffectsForm.DeleteBackdrop1Click(Sender: TObject);
begin
if qbpresets.itemindex>=0 then begin
  qbpresets.Items.Delete (qbpresets.itemindex);
  qbpresets.Items.SaveToFile (QBFile);
  end;
end;

procedure TAffectsForm.trkredChange(Sender: TObject);
begin
QBDRed:=trkRed.position;
  QuickBack;
end;

procedure TAffectsForm.trkgreenChange(Sender: TObject);
begin
QBDGreen:=trkGreen.position;
  QuickBack;
end;

procedure TAffectsForm.trkblueChange(Sender: TObject);
begin
QBDBlue:=trkBlue.position;
  QuickBack;
end;

procedure TAffectsForm.trkfactorChange(Sender: TObject);
begin
ImgDrawFactor:=trkFactor.position;
  QuickBack;
end;

procedure TAffectsForm.UpdateBackdrop1Click(Sender: TObject);
var s:string;
    p:integer;
begin
if not(qbpresets.ItemIndex>=0) then begin
  showmessage ('No item selected!');
  exit;
  end;
s:=qbpresets.items[qbpresets.itemindex];
p:=pos('=',s);
s:=copy(s,1,p-1);
s:=inputbox('Painter Quick Backdrops','Enter Name:',s);
if s='' then exit;
s:=s+'='+inttostr(QBRedfn)+','
   +inttostr(QBGreenfn)+','
   +inttostr(QBBluefn)+','
   +inttostr(QBDRed)+','
   +inttostr(QBDGreen)+','
   +inttostr(QBDBlue)+','
   +inttostr(ImgDrawFactor);
qbpresets.Items[qbpresets.itemindex]:=s;
qbpresets.Items.SaveToFile (QBFile);
end;

function TAffectsForm.strtoquickback(s: string): boolean;
var p:integer;
    Alist:tstringlist;
begin
  result:=false;
  p:=pos('=',s);
  if p=0 then exit;
  s:=copy(s,p+1,length(s));
  Alist:=tstringlist.create;
  try
  Alist.commatext:=s;
  QBRedfn:=strtoint(Alist[0]);
  QBGreenfn:=strtoint(Alist[1]);
  QBBluefn:=strtoint(Alist[2]);
  QBDRed:=strtoint(Alist[3]);
  trkRed.position:=QBDRed;
  QBDGreen:=strtoint(Alist[4]);
  trkGreen.position:=QBDGreen;
  QBDBlue:=strtoint(Alist[5]);
  trkBlue.position:=QBDBlue;
  ImgDrawFactor:=strtoint(Alist[6]);
  trkFactor.Position :=ImgDrawFactor;
  setlabels;
  QuickBack;
  result:=true;
  except
  showmessage('Error in Presets');
  result:=false;
  end;
  Alist.free;
end;


procedure TAffectsForm.redradioClick(Sender: TObject);
begin
QBList.ItemIndex :=QBRedfn;
end;

procedure TAffectsForm.greenradioClick(Sender: TObject);
begin
QBList.ItemIndex :=QBGreenfn;
end;

procedure TAffectsForm.blueradioClick(Sender: TObject);
begin
QBList.ItemIndex :=QBBluefn;
end;

{procedure TAffectsForm.setDrawImage(aDrawImage: TjandrawImage);
begin
  PainterF:=aDrawImage;
end;}
{  art.clipall;
  art.FX.AntiAlias(art.clip);
  art.canvas.Draw (0,0,art.clip);
}



end.

