program Tongs;

uses
  RecyclerMM in 'RecyclerMM.pas',
  Forms,
  TongsFrm in 'TongsFrm.pas' {TongsForm},
  TongGlobals in 'TongGlobals.pas',
  AllSplash in '..\common\AllSplash.pas' {SplashScreen},
  rAbout in 'rAbout.pas' {AboutTongs},
  rResize in 'rResize.pas' {ResizeForm},
  rRotate in 'rRotate.pas' {RotateForm},
  rMagniForm in 'rMagniForm.pas' {MagniForm},
  SatelliteImportFrm in 'SatelliteImportFrm.pas' {SatelliteImportForm},
  DTwainTable in '..\common\DTwain\DTwainTable.pas',
  DTSCFrm in '..\common\DTwain\DTSCFrm.pas' {DTSendCommandForm},
  DTwainFrm in '..\common\DTwain\DTwainFrm.pas' {DTwainForm},
  gratex in 'gratex.pas' {graTTB},
  graImageRGB in 'graImageRGB.pas' {ImageRGBForm},
  gPSize in 'gPSize.pas' {PrintersizeForm},
  gOMark in 'gOMark.pas' {ObjectMarkForm},
  gXAnnoLO in 'gXAnnoLO.pas' {LabelObjectsForm},
  gVCScreen in 'gVCScreen.pas' {ViewCursorScreen},
  rRegFrm in 'rRegFrm.pas' {RegistrationForm},
  graSysInfo in 'graSysInfo.pas' {SystemInfoForm},
  Properties in 'Properties.pas' {PropertyDialog},
  rOptionsForm in 'rOptionsForm.pas' {OptionsForm},
  AffectsFrm in 'AffectsFrm.pas' {AffectsForm},
  ProgressMessageFrm in 'ProgressMessageFrm.pas' {ProgressMessageForm},
  PngInfoFrm in 'PngInfoFrm.pas' {PngInfoForm},
  InfoJpgFrm in 'InfoJpgFrm.pas' {JpgInfo},
  JPEGFrm in 'JPEGFrm.pas' {JPEGForm},
  rOverViewFrm in 'rOverViewFrm.pas' {OverViewForm},
  Uedge in 'Uedge.pas' {ImageSpecials},
  ImageTypeConverterFrm in 'ImageTypeConverterFrm.pas' {ImageTypeConverterForm},
  AJCsvDbFrm in 'AJCsvDbFrm.pas' {GCsvDbForm},
  PicView in 'PicView.pas' {PicViewBitmap},
  DevILFrm in 'DevILFrm.pas' {DDevILForm},
  DevILInfoFrm in 'DevILInfoFrm.pas' {DevILInfoDlg},
  DevILAboutFrm in 'DevILAboutFrm.pas' {DevILAboutForm},
  DevILDialogFrm in 'DevILDialogFrm.pas' {DevILDialogForm},
  OpenIL in 'OpenIL.pas',
  OpenILU in 'openilu.pas',
  OpenILUT in 'OpenILUT.pas',
  ScreenBMPJPG in 'ScreenBMPJPG.pas' {FormConvert},
  ImageCorrelateFrm in 'ImageCorrelateFrm.pas' {ImageCorrelateForm},
  AVIMorphFrm in 'AVIMorphFrm.pas' {AVIMorphForm},
  a_vfw in 'a_vfw.pas',
  a_iunk in 'a_iunk.pas',
  a_layer in 'a_layer.pas',
  a_loader in 'a_loader.pas' {AviFrmMain},
  a_prev in 'a_prev.pas' {AviFrmPrev},
  NelsonMorpherFrm in 'NelsonMorpherFrm.pas' {NelsonMorpherForm},
  NelsonOutputFrm in 'NelsonOutputFrm.pas' {NelsonOutputForm},
  Nelson2DGeometry in 'Nelson2DGeometry.pas',
  NelsonCorrespondenceFrm in 'NelsonCorrespondenceFrm.pas' {NelsonCorrespondenceForm},
  AJPaintFrm in 'AJPaintFrm.pas' {GPaintForm},
  TPrefrm in 'TPrefrm.pas' {TPreForm},
  Srchfrm in 'Srchfrm.pas' {SrchForm},
  ShowFileinfo in 'ShowFileinfo.pas',
  szAdler in 'szAdler.pas',
  szScanThread in 'szScanThread.pas',
  szRecycle in 'szRecycle.pas',
  szDupDlg in 'szDupDlg.pas' {szDupForm},
  szMain in 'szMain.pas' {szMainForm},
  efgScreenPrint in 'efgScreenPrint.pas' {efgPrintForm},
  GListFrm in 'GListFrm.pas' {GListForm},
  GBfrm in 'GBfrm.pas' {GBForm},
  ZipFrm in 'ZipFrm.pas' {ZipForm},
  DBAFrm in 'DBAFrm.PAS' {DBAForm},
  Preprint in 'Preprint.pas' {PrePrintForm},
  GTreefrm in 'GTreefrm.pas' {TreeForm},
  PicAbout in 'PicAbout.pas' {PicAboutBox},
  DbSessionFrm in 'DbSessionFrm.pas' {DbSessionForm},
  DbAdrViewFrm in 'DbAdrViewFrm.pas' {DbAdrViewForm},
  DbAdrPrnAllForm in 'DbAdrPrnAllForm.pas' {DbAdrPrnAllFrm},
  DbAdrLblForm in 'DbAdrLblForm.pas' {DbAdrLblFrm},
  DbAdrImgLblForm in 'DbAdrImgLblForm.pas' {DbAdrImgLblFrm},
  DbPrintDataImageForm in 'DbPrintDataImageForm.pas' {DbPrintDataImageFrm},
  DbBigAdrImgLblForm in 'DbBigAdrImgLblForm.pas' {DbBigAdrImgLblFrm},
  DbPrintImagesFrm in 'DbPrintImagesFrm.pas' {DbPrintImagesForm},
  DbPrintDataWOImageForm in 'DbPrintDataWOImageForm.pas' {DbPrintDataWOImageFrm},
  DbNoteFrm in 'DbNoteFrm.pas' {DbNoteForm},
  DbImporterFrm in 'DbImporterFrm.pas' {DatabaseImporterForm},
  GSizerFrm in 'GSizerFrm.pas' {GSizetteForm},
  TongDatabaseFrm in 'TongDatabaseFrm.pas' {TongDatabaseForm},
  TongPeopleDbFrm in 'TongPeopleDbFrm.pas' {TongPeopleDbForm},
  TongImageDbFrm in 'TongImageDbFrm.pas' {TongImageDbForm},
  DbSecretFrm in 'DbSecretFrm.pas' {SecretDbForm},
  DbSecretFrmPawword in 'DbSecretFrmPawword.pas' {PasswordDlg},
  TongPanVizFrm in 'TongPanVizFrm.pas' {TongPanVizForm},
  graImageDotRGB in 'graImageDotRGB.pas' {TongImageDotRGBForm},
  t3de1 in 't3de1.pas' {t3de1Form},
  t3de in 't3de.pas' {t3dForm},
  DbAdrPrnForm in 'DbAdrPrnForm.pas' {DbAdrPrnFrm};

{$R *.RES}
{$R ZipMsgUS.res}

begin
  Application.Initialize;
  Application.Title := 'Tongs GRIP ICE';
  Application.CreateForm(TTongsForm, TongsForm);
  Application.CreateForm(TMagniForm, MagniForm);
  Application.CreateForm(TDTSendCommandForm, DTSendCommandForm);
  Application.CreateForm(TDTwainForm, DTwainForm);
  Application.CreateForm(TViewCursorScreen, ViewCursorScreen);
  Application.CreateForm(TAffectsForm, AffectsForm);
  Application.CreateForm(TOverViewForm, OverViewForm);
  Application.CreateForm(TImageSpecials, ImageSpecials);
  Application.CreateForm(TImageTypeConverterForm, ImageTypeConverterForm);
  Application.CreateForm(TGCsvDbForm, GCsvDbForm);
  Application.CreateForm(TPicViewBitmap, PicViewBitmap);
  Application.CreateForm(TDDevILForm, DDevILForm);
  Application.CreateForm(TDevILAboutForm, DevILAboutForm);
  Application.CreateForm(TDevILDialogForm, DevILDialogForm);
  Application.CreateForm(TDevILInfoDlg, DevILInfoDlg);
  Application.CreateForm(TAVIMorphForm, AVIMorphForm);
  Application.CreateForm(TAviFrmMain, AviFrmMain);
  Application.CreateForm(TAviFrmPrev, AviFrmPrev);
  Application.CreateForm(TNelsonMorpherForm, NelsonMorpherForm);
  Application.CreateForm(TNelsonOutputForm, NelsonOutputForm);
  Application.CreateForm(TNelsonCorrespondenceForm, NelsonCorrespondenceForm);
  Application.CreateForm(TTPreForm, TPreForm);
  Application.CreateForm(TszDupForm, szDupForm);
  Application.CreateForm(TszMainForm, szMainForm);
  Application.CreateForm(TSrchForm, SrchForm);
  Application.CreateForm(TefgPrintForm, efgPrintForm);
  Application.CreateForm(TGListForm, GListForm);
  Application.CreateForm(TGBForm, GBForm);
  Application.CreateForm(TDBAForm, DBAForm);
  Application.CreateForm(TTreeForm, TreeForm);
  Application.CreateForm(TPicAboutBox, PicAboutBox);
  Application.CreateForm(TDbSessionForm, DbSessionForm);
  Application.CreateForm(TDbAdrViewForm, DbAdrViewForm);
  Application.CreateForm(TDbAdrPrnAllFrm, DbAdrPrnAllFrm);
  Application.CreateForm(TDbAdrLblFrm, DbAdrLblFrm);
  Application.CreateForm(TDbAdrImgLblFrm, DbAdrImgLblFrm);
  Application.CreateForm(TDbPrintDataImageFrm, DbPrintDataImageFrm);
  Application.CreateForm(TDbBigAdrImgLblFrm, DbBigAdrImgLblFrm);
  Application.CreateForm(TDbPrintImagesForm, DbPrintImagesForm);
  Application.CreateForm(TDbPrintDataWOImageFrm, DbPrintDataWOImageFrm);
  Application.CreateForm(TZipForm, ZipForm);
  Application.CreateForm(TDbNoteForm, DbNoteForm);
  Application.CreateForm(TDatabaseImporterForm, DatabaseImporterForm);
  Application.CreateForm(TGSizetteForm, GSizetteForm);
  Application.CreateForm(TTongDatabaseForm, TongDatabaseForm);
  Application.CreateForm(TSecretDbForm, SecretDbForm);
  Application.CreateForm(TTongPeopleDbForm, TongPeopleDbForm);
  Application.CreateForm(TTongImageDbForm, TongImageDbForm);
  Application.CreateForm(TTongPanVizForm, TongPanVizForm);
  Application.CreateForm(TDbAdrPrnFrm, DbAdrPrnFrm);
  Application.Run;
end.
