unit rResize;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ToolWin;

type
  TResizeForm = class(TForm)
    Height: TEdit;
    Width: TEdit;
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Label1: TLabel; {Width}
    Label2: TLabel;
    AspectCB: TCheckBox;
    procedure HelpBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ResizeForm: TResizeForm;

implementation


{$R *.DFM}
uses  TongGlobals;

procedure TResizeForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(255);
end;

procedure TResizeForm.FormCreate(Sender: TObject);
begin
  left := ResizeFormX;
  top := ResizeFormY;
end;

procedure TResizeForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  ResizeFormX := ResizeForm.left;
  ResizeFormY := ResizeForm.top;
end;

end.
