unit DevILDialogFrm;

interface

uses Windows, SysUtils, Classes, Graphics,
  Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TDevILDialogForm = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    DialogLabel: TLabel;
    DialogEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DevILDialogForm: TDevILDialogForm;

implementation

uses TongGlobals, DevILFrm;

{$R *.DFM}

procedure TDevILDialogForm.FormCreate(Sender: TObject);
begin
  top := DevILDialogFormY;
  left := DevILDialogFormX;
end;

procedure TDevILDialogForm.FormShow(Sender: TObject);
begin
  DialogLabel.Caption:=DDevILForm.FilterParamString;
  DialogEdit.Text:=FloattoStr(DDevILForm.FilterParamFloat);
end;

procedure TDevILDialogForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DevILDialogFormY := DevILDialogForm.top;
  DevILDialogFormX := DevILDialogForm.left;
  DDevILForm.FilterParamFloat:=  strtofloat(DialogEdit.Text);
  DDevILForm.FilterParamResult:= (ModalResult=mrOk);
end;

end.
