unit GListFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  JPEG, PNGImage, JPEGFrm, GraphicEx,
  FileCtrl, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls;

type
  TGListForm = class(TForm)
    ListBox1: TListBox;
    Panel1: TPanel;
    SOSMAPBtn: TSpeedButton;
    VoiceBtn: TSpeedButton;
    TracerBtn: TSpeedButton;
    GripIceBtn: TSpeedButton;
    DTMBtn: TSpeedButton;
    Fractal3DBtn: TSpeedButton;
    LifeBtn: TSpeedButton;
    ILHBtn: TSpeedButton;
    VRGISBtn: TSpeedButton;
    OpenListBtn: TSpeedButton;
    DeleteIt: TSpeedButton;
    MainMenu1: TMainMenu;
    Openasavedlist1: TMenuItem;
    SFO1: TMenuItem;
    SaveList1: TMenuItem;
    Convert1: TMenuItem;
    Sendto1: TMenuItem;
    Delete1: TMenuItem;
    Copyto1: TMenuItem;
    Moveto1: TMenuItem;
    SaveListBtn: TSpeedButton;
    ViewItBtn: TSpeedButton;
    VRGIS1: TMenuItem;
    ILH1: TMenuItem;
    Life1: TMenuItem;
    Fractal3D1: TMenuItem;
    DTM1: TMenuItem;
    GRIPICE1: TMenuItem;
    Tracer1: TMenuItem;
    Voice1: TMenuItem;
    SOSMAP1: TMenuItem;
    File1: TMenuItem;
    N1: TMenuItem;
    View1: TMenuItem;
    ConverterPanel: TPanel;
    FilterBox: TComboBox;
    WidthEdit: TEdit;
    WidthUpDown: TUpDown;
    HeightEdit: TEdit;
    HeightUpDown: TUpDown;
    ColorRezRG: TRadioGroup;
    FileTypeRG: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    SaveConvertedBtn: TSpeedButton;
    ActivateConverterBtn: TSpeedButton;
    Helpbtn: TSpeedButton;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    About1: TMenuItem;
    SaveAllConvertedBtn: TSpeedButton;
    DistortCB: TCheckBox;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Image1: TImage;
    Resetform1: TMenuItem;
    NoNameBtn: TSpeedButton;
    NoName1: TMenuItem;
    Database1: TMenuItem;
    N2: TMenuItem;
    Print1: TMenuItem;
    Rename1: TMenuItem;
    RenameAll1: TMenuItem;
    Selectall1: TMenuItem;
    SelectedtoInnerDb1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ILHBtnClick(Sender: TObject);
    procedure VRGISBtnClick(Sender: TObject);
    procedure LifeBtnClick(Sender: TObject);
    procedure Fractal3DBtnClick(Sender: TObject);
    procedure DTMBtnClick(Sender: TObject);
    procedure GripIceBtnClick(Sender: TObject);
    procedure TracerBtnClick(Sender: TObject);
    procedure VoiceBtnClick(Sender: TObject);
    procedure SOSMAPBtnClick(Sender: TObject);
procedure InitList;
    procedure ViewItBtnClick(Sender: TObject);
    procedure SaveListBtnClick(Sender: TObject);
    procedure OpenListBtnClick(Sender: TObject);
    procedure SaveConvertedBtnClick(Sender: TObject);
    procedure DeleteItClick(Sender: TObject);
    procedure Copyto1Click(Sender: TObject);
    procedure Moveto1Click(Sender: TObject);
    procedure HelpbtnClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ActivateConverterBtnClick(Sender: TObject);
procedure ShowConverter(Truth:Boolean);
    procedure SaveAllConvertedBtnClick(Sender: TObject);
procedure ChangeThisFile(IncomingFile:String);
procedure ParamExeThisFile(DoWhat:Integer);
procedure GetMeThisFile;
    procedure Resetform1Click(Sender: TObject);
    procedure NoNameBtnClick(Sender: TObject);
    procedure Database1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure RenameAll1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure SelectedtoInnerDb1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GListForm: TGListForm;
  DoThisFile:String;
  AllIWannaDo:Integer;
implementation

uses
TongGlobals, PicView, DBAFrm, AJCsvDbFrm, Preprint, PicAbout;

{$R *.DFM}

procedure TGListForm.FormCreate(Sender: TObject);
begin
  left := GListFormX;
  top := GListFormY;
end;

procedure TGListForm.FormShow(Sender: TObject);
begin
 ShowConverter(False);

  VRGISBtn.Caption:=
  Copy(ExtractFileName(VRGISPath),
       1,Length(ExtractFileName(VRGISPath))-4);
  ILHBtn.Caption:=
  Copy(ExtractFileName(ILHProgram),
       1,Length(ExtractFileName(ILHProgram))-4);
  LifeBtn.Caption:=
  Copy(ExtractFileName(LifePath),
       1,Length(ExtractFileName(LifePath))-4);
  Fractal3DBtn.Caption:=
  Copy(ExtractFileName(Fractal3DPath),
       1,Length(ExtractFileName(Fractal3DPath))-4);
  DTMBtn.Caption:=
  Copy(ExtractFileName(DTMPath),
       1,Length(ExtractFileName(DTMPath))-4);
  GripIceBtn.Caption:=
  Copy(ExtractFileName(RasterPath),
       1,Length(ExtractFileName(RasterPath))-4);
  TracerBtn.Caption:=
  Copy(ExtractFileName(DigitizerPath),
       1,Length(ExtractFileName(DigitizerPath))-4);
  VoiceBtn.Caption:=
  Copy(ExtractFileName(VoicePath),
       1,Length(ExtractFileName(VoicePath))-4);
  SOSMAPBtn.Caption:=
  Copy(ExtractFileName(SOSMAPPath),
       1,Length(ExtractFileName(SOSMAPPath))-4);
end;

procedure TGListForm.InitList;
var I:Integer;
Begin
  if ResultFileList.Count > 0  then
  begin
      ListBox1.Clear;
      For I := 0 to ResultFileList.Count-1 do
      begin
{        SS:=Copy(Items[I],1,(pos(Items[I],'=')-1));
        S := TransSearchDir + '\' + SS;}
        {Add to Browser List}
        ListBox1.Items.Add(ResultFileList[I]);
      end;
   end;
End;

procedure TGListForm.SaveListBtnClick(Sender: TObject);
var
 S : string;
 I:Integer;
 F: TextFile;
begin
  if ListBox1.Items.Count > 0  then
  begin
  SaveDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
  SaveDialog1.Filename:='graflist.txt';
  if SaveDialog1.Execute then
  begin
    AssignFile(F, SaveDialog1.FileName);
    Rewrite(F);
    with ListBox1 do
    begin
      For I := 0 to ListBox1.Items.Count-1 do
      begin
        S:=Items[I];
        Writeln(F, S);
      end;
       CloseFile(F);
   end;
  end;
  end;
end;


procedure TGListForm.OpenListBtnClick(Sender: TObject);
var
 S : string;
 F: TextFile;
begin
  OpenDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
  OpenDialog1.Filename:='graflist.txt';
  if OpenDialog1.Execute then
  begin
    AssignFile(F, OpenDialog1.FileName);
    Reset(F);
    Repeat
    begin
        Readln(F, S);
        ListBox1.Items.Add(S);
    end;
    until (eof(F));
       CloseFile(F);
  end;
end;

procedure TGListForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If TongsAlreadyGone then
  begin
  GListFormX := GListForm.left;
  GListFormY := GListForm.top;
    Application.ProcessMessages;
    Action := caFree;
  end else Action:=caHide;
end;

procedure TGListForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TGListForm.HelpbtnClick(Sender: TObject);
begin
  Application.HelpContext(7000);
end;

procedure TGListForm.About1Click(Sender: TObject);
begin
  PicAboutBox.Init(10);
  PicAboutBox.ShowModal;
end;

procedure TGListForm.Database1Click(Sender: TObject);
begin
  GetMeThisFile;
  GCsvDbForm.ListBox2.Items.Clear;
  GCsvDbForm.ListBox2.Items.Add(DoThisFile);
  GCsvDbForm.Show;
end;

procedure TGListForm.VRGISBtnClick(Sender: TObject);
begin
{VRGISPath}
GetMeThisFile;
ParamExeThisFile(1);
{DoThisFile}
end;
procedure TGListForm.ILHBtnClick(Sender: TObject);
begin
{ILHProgram}
GetMeThisFile;
ParamExeThisFile(2);
end;
procedure TGListForm.LifeBtnClick(Sender: TObject);
begin
{LifePath}
GetMeThisFile;
ParamExeThisFile(3);
end;
procedure TGListForm.Fractal3DBtnClick(Sender: TObject);
begin
{Fractal3DPath}
GetMeThisFile;
ParamExeThisFile(4);
end;
procedure TGListForm.DTMBtnClick(Sender: TObject);
begin
{DTMPath}
GetMeThisFile;
ParamExeThisFile(5);
end;
procedure TGListForm.GripIceBtnClick(Sender: TObject);
begin
{RasterPath}
GetMeThisFile;
ParamExeThisFile(6);
end;
procedure TGListForm.TracerBtnClick(Sender: TObject);
begin
{DigitizerPath}
GetMeThisFile;
ParamExeThisFile(7);
end;
procedure TGListForm.VoiceBtnClick(Sender: TObject);
begin
{VoicePath}
GetMeThisFile;
ParamExeThisFile(8);
end;

procedure TGListForm.SOSMAPBtnClick(Sender: TObject);
begin
{SOSMAPPath}
GetMeThisFile;
ParamExeThisFile(9);
end;
procedure TGListForm.NoNameBtnClick(Sender: TObject);
begin
{NoNamePath}
GetMeThisFile;
ParamExeThisFile(10);
end;
procedure TGListForm.ParamExeThisFile(DoWhat:Integer);
Begin
{GetMeThisFile  ParamExeThisFile  DoThisFile}
Case DoWhat of
1:ExecuteFile(ExtractFileName(VRGISPath), DoThisFile, ExtractFilePath(VRGISPath), SW_SHOW);
2:ExecuteFile(ExtractFileName(ILHProgram), DoThisFile, ExtractFilePath(ILHProgram), SW_SHOW);
3:ExecuteFile(ExtractFileName(LifePath), DoThisFile, ExtractFilePath(LifePath), SW_SHOW);
4:ExecuteFile(ExtractFileName(Fractal3DPath), DoThisFile, ExtractFilePath(Fractal3DPath), SW_SHOW);
5:ExecuteFile(ExtractFileName(DTMPath), DoThisFile, ExtractFilePath(DTMPath), SW_SHOW);
6:ExecuteFile(ExtractFileName(RasterPath), DoThisFile, ExtractFilePath(RasterPath), SW_SHOW);
7:ExecuteFile(ExtractFileName(DigitizerPath), DoThisFile, ExtractFilePath(DigitizerPath), SW_SHOW);
8:ExecuteFile(ExtractFileName(VoicePath), DoThisFile, ExtractFilePath(VoicePath), SW_SHOW);
9:ExecuteFile(ExtractFileName(SOSMAPPath), DoThisFile, ExtractFilePath(SOSMAPPath), SW_SHOW);
10:ExecuteFile(ExtractFileName(NoNamePath), DoThisFile, ExtractFilePath(SOSMAPPath), SW_SHOW);
end;{case}
{VRGISPath}{ILHProgram}{LifePath}
{Fractal3DPath}{DTMPath}{RasterPath}
{DigitizerPath}{VoicePath}{SOSMAPPath}
{ ExecuteFile('MOWDS.wpd', '', 'F:\mow\data', SW_SHOW);}
End;
(*************************************************************)
(*************************************************************)
procedure TGListForm.ViewItBtnClick(Sender: TObject);
begin
AllIWannaDo:=-1;
GetMeThisFile;
If AllIWannaDo>0 then
begin
    with PicViewBitmap do
    begin
      ViewFileName :=DoThisFile;
      DoLoad(ViewFileName);
      FocusedListBox:= nil;
      Show;
    end;
end;
end;

procedure TGListForm.Print1Click(Sender: TObject);
begin
AllIWannaDo:=-1;
GetMeThisFile;
If AllIWannaDo>0 then
begin
    If FileExists(DoThisFile) then
    begin
    with PicViewBitmap do
    begin
      ViewFileName :=DoThisFile;
      DoLoad(ViewFileName);
      FocusedListBox:= nil;
      Show;
    end;
  PrePrintForm:=TPrePrintForm.Create(Application);
  try
    PrePrintForm.SetupForm(DoThisFile,1);
    PicViewBitmap.Image1.Picture.Graphic:=nil;
    PicViewBitmap.Close;
    PrePrintForm.ShowModal;
  finally
    PrePrintForm.Release;
  end;
    end else Showmessage('File '+DoThisFile+' not there');
  DoThisFile:='';
end;
end;

procedure TGListForm.SaveConvertedBtnClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to (ListBox1.Items.Count - 1) do
  begin
  try
    if ListBox1.Selected[i] then
    begin
      if FileExists(ListBox1.Items.Strings[i]) then
      begin
        DoThisFile:=ListBox1.Items.Strings[i];{GListForm}
        SaveDialog1.InitialDir:=ExtractFilePath(DoThisFile);
        SaveDialog1.Filename:=ExtractFileName(DoThisFile);
        if SaveDialog1.Execute then
           ChangeThisFile(SaveDialog1.Filename);
      end;
    end;
   finally
   { do something here }
   end;
  end;
 ShowConverter(False);
end;

procedure TGListForm.DeleteItClick(Sender: TObject);
begin
{DeleteFile(const FileName: string): Boolean;}
{DoThisFile}GetMeThisFile;
if FileExists(DoThisFile) then
begin
  if (MessageDlg('Do you really want to delete '
               + ExtractFileName(DoThisFile) + '?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
   begin
    If DeleteFile(DoThisFile) then
    ListBox1.Items.Delete(AllIWannaDo);
   end;
end;
end;

procedure TGListForm.Rename1Click(Sender: TObject);
begin
{DeleteFile(const FileName: string): Boolean;}
{DoThisFile}GetMeThisFile;
if FileExists(DoThisFile) then
begin
{  if (MessageDlg('Do you really want to delete '
               + ExtractFileName(DoThisFile) + '?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes) then   }
  SaveDialog1.InitialDir:=ExtractFilePath(DoThisFile);
  if SaveDialog1.Execute then
   begin
{   function RenameFile(const OldName, NewName: string): Boolean;}
    If RenameFile(DoThisFile,SaveDialog1.Filename) then
    ListBox1.Items.Delete(AllIWannaDo);
   end;
end;
end;

procedure TGListForm.Selectall1Click(Sender: TObject);
var
  item: integer;
begin
  for item := 0 to ListBox1.Items.Count-1 do
    ListBox1.Selected[item] := True;
end;

procedure TGListForm.RenameAll1Click(Sender: TObject);
var
  i: Integer;
  CheapShot:String;
begin
  GetMeThisFile;
  SaveDialog1.InitialDir:=ExtractFilePath(DoThisFile);
  if SaveDialog1.Execute then
  begin
  CheapShot:=ExtractFileExt(SaveDialog1.Filename);
  GListForm.Cursor:=crHourGlass;
  Application.ProcessMessages;
  for i := 0 to (ListBox1.Items.Count - 1) do
  begin
  try
    if ListBox1.Selected[i] then
    begin  {SelCount}
      if FileExists(ListBox1.Items.Strings[i]) then
      begin
        DoThisFile:=ListBox1.Items.Strings[i];{GListForm}
         {ChangeThisFile(DoThisFile);}
        RenameFile(DoThisFile,ChangeFileExt(DoThisFile,CheapShot))
      end;
    end;
   finally
   { do something here }
     GListForm.Cursor:=crDefault;
   end;
  end;
  GListForm.Cursor:=crDefault;
end;
end;

procedure TGListForm.Copyto1Click(Sender: TObject);
begin
  GetMeThisFile;
  if FileExists(DoThisFile) then
  begin
    if (MessageDlg('Do you really want to copy '
               + ExtractFileName(DoThisFile) + '?',
        mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
    begin
{      SaveDialog1.InitialDir:=ExtractFilePath(DoThisFile);
      SaveDialog1.Filename:=ExtractFileName(DoThisFile);
      if SaveDialog1.Execute then}
     if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        CopyFile(PChar(DoThisFile),PChar(TransSearchDir+DoThisFile),True{bFailIfExists});
    end;
  end;
end;

procedure TGListForm.Moveto1Click(Sender: TObject);
begin
  GetMeThisFile;
  if FileExists(DoThisFile) then
  begin
    if (MessageDlg('Do you really want to move '
               + ExtractFileName(DoThisFile) + '?',
         mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
    begin
{      SaveDialog1.InitialDir:=ExtractFilePath(DoThisFile);
      SaveDialog1.Filename:=ExtractFileName(DoThisFile);
      if SaveDialog1.Execute then}
     if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
      begin
        MoveFile(PChar(DoThisFile),PChar(TransSearchDir+DoThisFile));
        ListBox1.Items.Delete(AllIWannaDo);
      end;
    end;
  end;
end;



procedure TGListForm.ActivateConverterBtnClick(Sender: TObject);
begin
  ShowConverter(True);
end;
procedure TGListForm.ShowConverter(Truth:Boolean);
Begin
If Truth then
begin
  ListBox1.Align:= alNone;
  ListBox1.Width:= (ListBox1.Width-104);
  ConverterPanel.Align:= alNone;
  If (not ConverterPanel.Visible)then
  GListForm.Width:= (GListForm.Width+104);
  ConverterPanel.Visible:=True;
  ConverterPanel.Align:= alLeft;
  ListBox1.Align:= alClient;
end else
begin
  ListBox1.Align:= alNone;
  ListBox1.Width:= (ListBox1.Width-104);
  ConverterPanel.Visible:=False;
  ConverterPanel.Align:= alNone;
  GListForm.Width:= (GListForm.Width-104);
  {ConverterPanel.Align:= alLeft; }
  ListBox1.Align:= alClient;
end;
end;

procedure TGListForm.Resetform1Click(Sender: TObject);
begin
  ConverterPanel.Visible:=False;
  ConverterPanel.Align:= alNone;
  ListBox1.Align:= alNone;
  ListBox1.Width:= 121;
  GListForm.Width:= (329);
  ListBox1.Align:= alClient;
end;

procedure TGListForm.SaveAllConvertedBtnClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to (ListBox1.Items.Count - 1) do
  begin
  try
    if ListBox1.Selected[i] then
    begin  {SelCount}
      Application.ProcessMessages;
      if FileExists(ListBox1.Items.Strings[i]) then
      begin
        DoThisFile:=ListBox1.Items.Strings[i];{GListForm}
        Application.ProcessMessages;
        ChangeThisFile(DoThisFile);
        Application.ProcessMessages;
      end;
    end;
   finally
   { do something here }
   end;
  end;
 ShowConverter(False);
end;

procedure TGListForm.SelectedtoInnerDb1Click(Sender: TObject);
{$ifdef ImageDB}
var
  i: Integer;
{$endif} // ImageDB
begin
{$ifdef ImageDB}
  ResultFileList.Clear;
  for i := 0 to (ListBox1.Items.Count - 1) do
  begin
  try
    if ListBox1.Selected[i] then
    begin  {SelCount}
      Application.ProcessMessages;
      if FileExists(ListBox1.Items.Strings[i]) then
      begin
        DoThisFile:=ListBox1.Items.Strings[i];{GListForm}
        ResultFileList.Add(DoThisFile);
        Application.ProcessMessages;
      end;
    end;
   finally         { do something here }
     {Activate List with the List}
     DBAForm.BrowseList(ExtractFileName(ExtractFilePath(ListBox1.Items.Strings[1])));
     DBAForm.Show;
   end;
  end;
{$endif} // ImageDB  
end;

procedure TGListForm.GetMeThisFile;
var
  i: Integer;
begin
  for i := 0 to (ListBox1.Items.Count - 1) do
  begin
  try
    if ListBox1.Selected[i] then
    begin
      if FileExists(ListBox1.Items.Strings[i]) then
      begin
        DoThisFile:=ListBox1.Items.Strings[i];{GListForm}
        AllIWannaDo:=i;
        exit;
      end;
    end;
   finally
   { do something here }
   end;
  end;
{ ShowConverter(False);}
end;

procedure TGListForm.ChangeThisFile(IncomingFile:String);
var
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
  Target:TBitmap;
{  PNG: TPNGObject;}
  jp: TJpegImage;
  Resized:Boolean;
  NewX, NewY: Integer;
  TempX:Double;
  OutGoingFile:String;
Begin
    Screen.Cursor := crHourGlass;
  If (  (WidthUpDown.Position<>0{GCImageWidth} )
      or(HeightUpDown.Position<>0{GCImageHeight})) then
    Resized:=True else Resized:=False;
  If ((Resized)
   or(ColorRezRG.ItemIndex>0)
   or(FileTypeRG.ItemIndex>0)) then
  Begin
    If (DoThisFile <> IncomingFile) then
    begin
      OutGoingFile:=IncomingFile;
      IncomingFile:=DoThisFile;
    end else
    begin
      IncomingFile:=DoThisFile;
      OutGoingFile:=DoThisFile;
    end;

    GraphicClass := FileFormatList.GraphicFromContent(IncomingFile);
    if GraphicClass = nil then Image1.Picture.LoadFromFile(IncomingFile)
    else
    begin
        // GraphicFromContent always returns TGraphicExGraphicClass
      Graphic := GraphicClass.Create;
      Graphic.LoadFromFile(IncomingFile);
      Image1.Picture.Graphic := Graphic;
    end;
    if (not(Image1.Picture.Graphic is TBitmap)) then
    begin
          Target := TBitmap.Create;
          Target.PixelFormat := pf24Bit;
          Target.Width := Image1.Picture.Width;
          Target.Height := Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, Image1.Picture.Graphic);
          Image1.Picture.Graphic := Target;
          Target.Free;
    end;
    {DoThisFile IncomingFile}
    {FilterBox  WidthEdit  HeightEdit
     ColorRezRG.ItemIndex   NC  256 24 32
     FileTypeRG.ItemIndex N C  BMP PNG JPG}
     TongImageWidth:=Image1.Picture.Width;
     TongImageHeight:=Image1.Picture.Height;
    If Resized then
    begin
      try
      Target := TBitMap.Create;
      Target.PixelFormat := pf24Bit;
      Image1.Picture.Bitmap.PixelFormat := pf24Bit;
      if WidthUpDown.Position = 0 then NewX := Image1.Picture.Width
                                  else NewX := WidthUpDown.Position;
      if HeightUpDown.Position = 0 then NewY := Image1.Picture.Height
                                   else NewY := HeightUpDown.Position;
      If (not DistortCB.Checked) then
      begin
        TempX:=(NewX/TongImageWidth);
        NewY:=Round(TongImageHeight*TempX);
      end;
      Target.Height:=NewY;
      Target.Width:=NewX;
      { Stretch(
      NewWidth, NewHeight: Cardinal;
       Filter: TResamplingFilter;
       Radius: Single;
       Source, Target: TBitmap);}
      Stretch(NewX, NewY,
              TResamplingFilter(FilterBox.ItemIndex), 0,
              Image1.Picture.Bitmap,
              Target);
      Image1.Picture.Bitmap:=Target;
      Image1.Canvas.Draw(0,0,Image1.Picture.Bitmap);
      finally
      end;
    End;
    Case ColorRezRG.Itemindex of
    0:Image1.Picture.Bitmap.PixelFormat :=  pf24bit;
    1:Image1.Picture.Bitmap.PixelFormat :=  pf4bit;
    2:Image1.Picture.Bitmap.PixelFormat :=  pf24bit;
    3:Image1.Picture.Bitmap.PixelFormat :=  pf32bit;
    end;{case}
    {(pfDevice, pf1bit, pf4bit, pf8bit, pf15bit,
      pf16bit, pf24bit, pf32bit, pfCustom)}

    {FileTypeRG.ItemIndex N C  BMP PNG JPG}
    {DoThisFile IncomingFile}
    Case FileTypeRG.ItemIndex of
    0:Image1.Picture.SaveToFile(ChangeFileExt(OutGoingFile, '.bmp'));
    1:Image1.Picture.SaveToFile(ChangeFileExt(OutGoingFile, '.bmp'));
    2:begin
        {PNG := TPNGObject.Create;
        PNG.Assign(Image1.Picture.Bitmap);
        PNG.SaveToFile(ChangeFileExt(OutGoingFile, '.png'));
        PNG.Free; }
        Image1.Picture.Bitmap.SaveToFile(ChangeFileExt(OutGoingFile, '.png'));
      end;
    3:begin
        jp := TJpegImage.Create;
        try
          with jp do
          begin
            Assign(Image1.Picture.Bitmap);
            if JPEGForm.ShowModal = mrOK then
              jp.SaveToFile(ChangeFileExt(OutGoingFile, '.jpg'));
          end;
        finally
          jp.Free;
        end;
      end;
    End;
  end;{if whatever}
  { ShowConverter(False);}
  Screen.Cursor := crDefault;
End;















end.
