unit InfoTifFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TTifInfo = class(TForm)
    Memo1: TMemo;
    IIHelpBtn: TBitBtn;
    IICloseBtn: TBitBtn;
    FileOpenBtn: TSpeedButton;
    OpenDialog1: TOpenDialog;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure IIHelpBtnClick(Sender: TObject);
    procedure IICloseBtnClick(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TifInfo: TTifInfo;

implementation
uses Globals, GCfrm;
{$R *.DFM}

procedure TTifInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ImageInfoFormX := TifInfo.left;
  ImageInfoFormY := TifInfo.top;
  DoSaver;
end;

procedure TTifInfo.FormCreate(Sender: TObject);
begin
  left := ImageInfoFormX;
  top := ImageInfoFormY;
end;

procedure TTifInfo.IIHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(3000);
end;

procedure TTifInfo.IICloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TTifInfo.FileOpenBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter:='tif graphics|*.tif;*.tiff';
{  'All (*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf'+
    '|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg|JPEG Image File (*.jpeg)|*.jpeg|Bitmaps (*.bmp)|*.bmp|Icons (*.ico)|*.ico|Enhanced Metafiles (*.emf)|*.emf|Metafiles (*.wmf)|*.wmf|Morph List Text|*.mlt';}
  OpenDialog1.InitialDir:=ImagePath;
  OpenDialog1.FileName:=Changefileext(TempName,'.tif' );
  if OpenDialog1.Execute then
  begin
{    Image1.Picture.LoadFromFile(OpenDialog1.FileName);}
 {	WriteTiffToFile( ChangeFileExt(OpenDialog1.FileName, '.TIF'),
             Image1.Picture.Bitmap ); }
  end;
end;

end.
