unit rOptionsForm;
 { TongsForm.Image1.IncrementalDisplay := IncrementalDisplay.Checked; }
{1 Options Form, 1 Error Message File
 Each POF file}
{All Programs in 1 Directory,
   SubDirectories: Filters, Fractal files,Life files, media
     Admin? :Extensions, Palettes.pal, .tpcfg, Server?Info,
Image Databases, Thumbnails, Fractal Images, Pan Images, 
Projects, Maps, 3D DTM .ots Eco Files.eco, Patterns ,
Grip Colors..Eco Colors..Patterns

function SaveBmpToJpegFile (const bitmap: TBitmap;  const filename: string;
                    const quality: integer;  const comment: string): boolean;

}
interface

uses
  Windows, Messages,
  Graphics, Controls, Forms, Dialogs,Classes,
  Sysutils{Filestuff},
  FileCtrl{SelectDirectory},
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TOptionsForm = class(TForm)
    OpenDialog1: TOpenDialog;
    ColorDialog1: TColorDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    RecordReader: TTabSheet;
    ActorEdit: TEdit;
    PanEdit: TEdit;
    HTFEdit: TEdit;
    DXFEdit: TEdit;
    VectorDbEdit: TEdit;
    DemPathEdit: TEdit;
    BaseImagesEdit: TEdit;
    ShapeEdit: TEdit;
    ProjectsEdit: TEdit;
    ProjectsBtn: TSpeedButton;
    ShapeBtn: TSpeedButton;
    BaseImagesBtn: TSpeedButton;
    DLGBtn: TSpeedButton;
    VectorDbBtn: TSpeedButton;
    DXFBtn: TSpeedButton;
    TigerBtn: TSpeedButton;
    SDTSBtn: TSpeedButton;
    DotBtn: TSpeedButton;
    Label3: TLabel;
    Label2: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label25: TLabel;
    Label17: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label49: TLabel;
    Label4: TLabel;
    MessageXEdit: TEdit;
    MessageYEdit: TEdit;
    MessageBtn: TSpeedButton;
    POHelpBtn: TSpeedButton;
    POM_ResetMenuBtn: TSpeedButton;
    CloseBitBtn: TBitBtn;
    SelectionRadiusEdit: TEdit;
    Label7: TLabel;
    SaveDialog1: TSaveDialog;
    OpenPreviewCB: TCheckBox;
    SavePreviewCB: TCheckBox;
    DisplayConvert32CB: TCheckBox;
    TabSheet2: TTabSheet;
    MapGridColorPanel: TPanel;
    MapContoursColorPanel: TPanel;
    MapDataColorPanel: TPanel;
    MapBackColorPanel: TPanel;
    Panel1: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    EditColorLabel: TLabel;
    Label8: TLabel;
    HighlightColorPanel: TPanel;
    BackgroundColorPanel: TPanel;
    EditColorPanel: TPanel;
    EditingColorPanel: TPanel;
    CurrentColorPanel: TPanel;
    Label29: TLabel;
    Panel2: TPanel;
    TestSoundRG: TRadioGroup;
    LoadSoundRG: TRadioGroup;
    BeepOrWavCB: TCheckBox;
    CompletionCB: TCheckBox;
    ErrorsCB: TCheckBox;
    WarningCB: TCheckBox;
    ConfirmationCB: TCheckBox;
    InfoCB: TCheckBox;
    Label1: TLabel;
    TabSheet3: TTabSheet;
    jpgProgressiveDisplay: TCheckBox;
    Label39: TLabel;
    Label38: TLabel;
    JpgQualityTrackBar: TTrackBar;
    Performance: TComboBox;
    ColorSpace: TComboBox;
    PixelFormat: TComboBox;
    Scale: TComboBox;
    Label36: TLabel;
    Label37: TLabel;
    jpgIncrementalDisplay: TCheckBox;
    jpgCommentsEdit: TEdit;
    PrintBigCB: TCheckBox;
    TabSheet4: TTabSheet;
    ILHEdit: TEdit;
    LifeEdit: TEdit;
    Fractal3DEdit: TEdit;
    DTMEdit: TEdit;
    TracerEdit: TEdit;
    VoiceEdit: TEdit;
    GripIceEdit: TEdit;
    SOSMAPEdit: TEdit;
    VRGISEdit: TEdit;
    NoNameEdit: TEdit;
    NoNamePathBtn: TSpeedButton;
    VRGISBtn: TSpeedButton;
    SOSMAPBtn: TSpeedButton;
    GripIceBtn: TSpeedButton;
    VoiceBtn: TSpeedButton;
    TracerBtn: TSpeedButton;
    DTMBtn: TSpeedButton;
    Fractal3DBtn: TSpeedButton;
    LifeBtn: TSpeedButton;
    ILHBtn: TSpeedButton;
    Label12: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    Label9: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    MapBtn: TSpeedButton;
    MapEdit: TEdit;
    TabSheet5: TTabSheet;
    Label21: TLabel;
    ThumbBtn: TSpeedButton;
    ThumbEdit: TEdit;
    Label24: TLabel;
    WidthEdit: TEdit;
    SizeUpDown: TUpDown;
    FillColorBtn: TSpeedButton;
    Label26: TLabel;
    UseThumbnailsCB: TCheckBox;
    Shape1: TShape;
    TabSheet6: TTabSheet;
    ExtensionSetRG: TRadioGroup;
    ExtMemo: TMemo;
    ExtOpen: TSpeedButton;
    ClearExtBtn: TSpeedButton;
    ExtSave: TSpeedButton;
    ExtDefaults: TSpeedButton;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    TabSheet9: TTabSheet;
    TabSheet10: TTabSheet;
    Label27: TLabel;
    TreeBtn: TSpeedButton;
    TreePathEdit: TEdit;
    ZipBtn: TSpeedButton;
    ZipEdit: TEdit;
    Label28: TLabel;
    GraphexFilterBox: TComboBox;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    procedure POHelpBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure POM_ResetMenuBtnClick(Sender: TObject);
    procedure DXFBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CloseBitBtnClick(Sender: TObject);
    procedure Showem;
    procedure ProjectsBtnClick(Sender: TObject);
    procedure TigerBtnClick(Sender: TObject);
    procedure DotBtnClick(Sender: TObject);
    procedure SDTSBtnClick(Sender: TObject);
    procedure DLGBtnClick(Sender: TObject);
    procedure ShapeBtnClick(Sender: TObject);
    procedure VectorDbBtnClick(Sender: TObject);
    procedure BaseImagesBtnClick(Sender: TObject);
    procedure MessageBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BeepOrWavCBClick(Sender: TObject);
    procedure BackgroundColorPanelClick(Sender: TObject);
    procedure HighlightColorPanelClick(Sender: TObject);
    procedure EditColorPanelClick(Sender: TObject);
    procedure EditingColorPanelClick(Sender: TObject);
    procedure SavePreviewCBClick(Sender: TObject);
    procedure OpenPreviewCBClick(Sender: TObject);
    procedure JpgQualityTrackBarChange(Sender: TObject);
    procedure jpgCommentsEditChange(Sender: TObject);
    procedure jpgProgressiveDisplayKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure jpgIncrementalDisplayKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TestSoundRGClick(Sender: TObject);
    procedure LoadSoundRGClick(Sender: TObject);
    procedure ThumbBtnClick(Sender: TObject);
    procedure SizeUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure FillColorBtnClick(Sender: TObject);
    procedure UseThumbnailsCBClick(Sender: TObject);
    procedure ExtOpenClick(Sender: TObject);
    procedure ClearExtBtnClick(Sender: TObject);
    procedure ExtSaveClick(Sender: TObject);
    procedure ExtDefaultsClick(Sender: TObject);
    procedure ILHBtnClick(Sender: TObject);
    procedure LifeBtnClick(Sender: TObject);
    procedure Fractal3DBtnClick(Sender: TObject);
    procedure DTMBtnClick(Sender: TObject);
    procedure TracerBtnClick(Sender: TObject);
    procedure VoiceBtnClick(Sender: TObject);
    procedure GripIceBtnClick(Sender: TObject);
    procedure SOSMAPBtnClick(Sender: TObject);
    procedure VRGISBtnClick(Sender: TObject);
    procedure NoNamePathBtnClick(Sender: TObject);
    procedure MapBtnClick(Sender: TObject);
    procedure TreeBtnClick(Sender: TObject);
    procedure ZipBtnClick(Sender: TObject);
    procedure DisplayConvert32CBClick(Sender: TObject);
    procedure PrintBigCBClick(Sender: TObject);
    procedure MapContoursColorPanelClick(Sender: TObject);
    procedure MapBackColorPanelClick(Sender: TObject);
    procedure MapDataColorPanelClick(Sender: TObject);
    procedure MapGridColorPanelClick(Sender: TObject);
    procedure CurrentColorPanelClick(Sender: TObject);
    procedure GraphexFilterBoxChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionsForm: TOptionsForm;

implementation
{$R *.DFM}
uses TongGlobals, TongsFrm;


procedure TOptionsForm.FormCreate(Sender: TObject);
begin
  top := OptionsformY;
  left := OptionsformX;
  OpenDialog1.InitialDir := ProjectPath;
  SaveDialog1.InitialDir := ProjectPath;
end;

procedure TOptionsForm.FormShow(Sender: TObject);
begin
  Showem;
end;

procedure TOptionsForm.Showem;
var ShowString: string;
begin
{Set all the boxes and edits}
  OpenPreviewCB.Checked := OpenWithPreview;
  SavePreviewCB.Checked := SaveWithPreview;
  DisplayConvert32CB.Checked := Skip32BitNotice;
  EditingColorPanel.Color:=EditingColor;
  BackgroundColorPanel.Color:=BackgroundColor;
  HighlightColorPanel.Color:=HighlightColor;
  EditColorPanel.Color:=EditColor;
  CurrentColorPanel.Color := CurrentColor;
  ErrorsCB.Checked:=ErrorBeepOn;
  WarningCB.Checked:=WarningBeepOn;
  InfoCB.Checked:=InfoBeepOn;
  ConfirmationCB.Checked:=ConfirmBeepOn;
  CompletionCB.Checked:=CompletedBeepOn;
  BeepOrWavCB.Checked:=VoicesON;

  Scale.ItemIndex:=jpgScale;
  PixelFormat.ItemIndex:=jpgPixelFormat;
  ColorSpace.ItemIndex:=jpgColorSpace;
  Performance.ItemIndex:=jpgPerformance;
  JpgQualityTrackBar.Position:=JpgQuality;
  jpgCommentsEdit.Text:=jpgComments;
  {PIntelJpgAvailable,}{Tested..Set on App create.. NOT SET by user}
  jpgProgressiveDisplay.Checked:=jpgProgressiveDisplayOn;
  jpgIncrementalDisplay.Checked:=jpgIncrementalDisplayOn;
  str(MessageX, ShowString);
  MessageXEdit.Text := ShowString;
  str(MessageY, ShowString);
  MessageYEdit.Text := ShowString;
  GraphexFilterBox.ItemIndex:=GraphexFilter;
  Shape1.Brush.Color:=ThumbColor;
    SizeUpDown.Position:=ThumbSize;
   Shape1.Width:=SizeUpDown.Position;
   Shape1.Height:=SizeUpDown.Position;
    ThumbEdit.Text := ThumbPath;
  ProjectsEdit.Text := ProjectPath;
  MapEdit.Text := MapsPath;
  TreePathEdit.Text := TreePath;
  DemPathEdit.Text := DemPath;
  HTFEdit.Text := HTFPath;
  BaseImagesEdit.Text := ImagePath;
  ShapeEdit.Text := ShapePath;
  VectorDbEdit.Text := DbPath;
  ZipEdit.Text := ZipPath;
  PanEdit.Text := PanPath;
  ActorEdit.Text := ActorPath;
  DXFEdit.Text := DXFPath;

  ILHEdit.Text := ILHProgram;
  LifeEdit.Text := LifePath;
  Fractal3DEdit.Text := Fractal3DPath;
  DTMEdit.Text := DTMPath;
  TracerEdit.Text := DigitizerPath;
  VoiceEdit.Text := VoicePath;
  GripIceEdit.Text := RasterPath;
  SOSMAPEdit.Text := SOSMAPPath;
  VRGISEdit.Text := VRGISPath;
  NoNameEdit.Text := NoNamePath;
end;

procedure TOptionsForm.JpgQualityTrackBarChange(Sender: TObject);
begin
  JpgQuality:= JpgQualityTrackBar.Position;
end;
procedure TOptionsForm.jpgCommentsEditChange(Sender: TObject);
begin
  jpgComments:=jpgCommentsEdit.Text;
end;
procedure TOptionsForm.jpgProgressiveDisplayKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  jpgProgressiveDisplayOn:=jpgProgressiveDisplay.Checked;
end;

procedure TOptionsForm.jpgIncrementalDisplayKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  jpgIncrementalDisplayOn:=jpgIncrementalDisplay.Checked;
end;

procedure TOptionsForm.BeepOrWavCBClick(Sender: TObject);
begin
  ErrorBeepOn := ErrorsCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
  VoicesON:=BeepOrWavCB.Checked;
end;
procedure TOptionsForm.POHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(3000);
end;

procedure TOptionsForm.CloseBitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TOptionsForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var code: Integer;
begin
  OptionsformY := OptionsForm.top;
  OptionsformX := OptionsForm.left;
  OpenWithPreview:=OpenPreviewCB.Checked;
  SaveWithPreview:=SavePreviewCB.Checked;
  Skip32BitNotice:=DisplayConvert32CB.Checked;
  ErrorBeepOn := ErrorsCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
  VoicesON:=BeepOrWavCB.Checked;
{Get the Message locations}
  val(MessageXEdit.Text, MessageX, Code);
  val(MessageYEdit.Text, MessageY, Code);
  val(SelectionRadiusEdit.Text, SelectionRadius, Code);
  DoSaver;
end;

procedure TOptionsForm.POM_ResetMenuBtnClick(Sender: TObject);
begin
  ResetDefaults;
  Showem;
end;

procedure TOptionsForm.ProjectsBtnClick(Sender: TObject);
begin
  TransSearchDir:= ProjectPath;
  if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
  begin
    ProjectPath := TransSearchDir;
    ProjectsEdit.Text := ProjectPath;
  end {else DoMessages(1)};
end;

procedure TOptionsForm.MapBtnClick(Sender: TObject);
begin
  TransSearchDir:= MapsPath;
  if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
  begin
    MapsPath := TransSearchDir;
    MapEdit.Text := MapsPath;
  end {else DoMessages(1)};
end;

procedure TOptionsForm.TreeBtnClick(Sender: TObject);
begin
  TransSearchDir:= TreePath;
  if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
  begin
    TreePath := TransSearchDir;
    TreePathEdit.Text := TreePath;
  end {else DoMessages(1)};
end;

procedure TOptionsForm.TigerBtnClick(Sender: TObject);
begin
  TransSearchDir:= HTFPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      HTFPath := TransSearchDir;
      HTFEdit.Text := HTFPath;
  end;{ else DoMessages(4);}
end;

procedure TOptionsForm.DotBtnClick(Sender: TObject);
begin
  TransSearchDir:= ActorPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
    ActorPath := TransSearchDir;
    ActorEdit.Text := ActorPath;
  end; {else DoMessages(3);}
end;

procedure TOptionsForm.SDTSBtnClick(Sender: TObject);
begin
  TransSearchDir:= PanPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      PanPath := TransSearchDir;
      PanEdit.Text := PanPath;
    end{ else DoMessages(10)};
end;

procedure TOptionsForm.DLGBtnClick(Sender: TObject);
begin
  TransSearchDir:= DemPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      DemPath :=TransSearchDir;
      DemPathEdit.Text := DemPath;
  end;{ else DoMessages(9);}
end;

procedure TOptionsForm.DXFBtnClick(Sender: TObject);
begin
  TransSearchDir:= DXFPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      DXFPath := TransSearchDir;
      DXFEdit.Text := DXFPath;
    end {else DoMessages(11)};
end;

procedure TOptionsForm.ShapeBtnClick(Sender: TObject);
begin
  TransSearchDir:= ShapePath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      ShapePath := TransSearchDir;
      ShapeEdit.Text := ShapePath;
    end {else DoMessages(12)};
end;

procedure TOptionsForm.VectorDbBtnClick(Sender: TObject);
begin
  TransSearchDir:= DbPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      DbPath := TransSearchDir;
      VectorDbEdit.Text := DbPath;
    end {else DoMessages(12)};
end;

procedure TOptionsForm.ZipBtnClick(Sender: TObject);
begin
  TransSearchDir:= ZipPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      ZipPath := TransSearchDir;
      ZipEdit.Text := ZipPath;
    end {else DoMessages(12)};
end;

procedure TOptionsForm.BaseImagesBtnClick(Sender: TObject);
begin
  TransSearchDir:= ImagePath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      ImagePath := TransSearchDir;
        BaseImagesEdit.Text := ImagePath;
    end {else DoMessages(13)};
end;

procedure TOptionsForm.MessageBtnClick(Sender: TObject);
begin
 { DoRezInfo(9999);}
end;



procedure TOptionsForm.BackgroundColorPanelClick(Sender: TObject);
begin
   ColorDialog1.Color:= BackgroundColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    BackgroundColorPanel.Color := ColorDialog1.Color;
    BackgroundColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.HighlightColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=HighlightColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    HighlightColorPanel.Color := ColorDialog1.Color;
    HighlightColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.EditColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=EditColor;
  if ColorDialog1.Execute then
  begin
    EditColorPanel.Color := ColorDialog1.Color;
    EditColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.EditingColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:=EditingColor;
  if ColorDialog1.Execute then
  begin
    EditingColorPanel.Color := ColorDialog1.Color;
    EditingColor := ColorDialog1.Color;
  end;
end;




procedure TOptionsForm.SavePreviewCBClick(Sender: TObject);
begin
  SaveWithPreview := SavePreviewCB.Checked;
end;

procedure TOptionsForm.OpenPreviewCBClick(Sender: TObject);
begin
  OpenWithPreview := OpenPreviewCB.Checked;
end;

procedure TOptionsForm.DisplayConvert32CBClick(Sender: TObject);
begin
  Skip32BitNotice := DisplayConvert32CB.Checked;
end;

procedure TOptionsForm.PrintBigCBClick(Sender: TObject);
begin
  PrintBigChecked := PrintBigCB.Checked;
end;





procedure TOptionsForm.TestSoundRGClick(Sender: TObject);
begin
   Case TestSoundRG.ItemIndex of
   0:DoMessages(7498{9998});  {info}
   1:DoMessages(14999);{ mtConfirmation}
   2:DoMessages(24999);{warn}
   3:DoMessages(29996);{error}
   4:DoMessages(31001);{done}
   end;{case}
end;

procedure TOptionsForm.LoadSoundRGClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Wav files (*.wav)|*.wav';
  OpenDialog1.InitialDir := ILHProgram;
  OpenDialog1.Filename:='*.wav';
  if OpenDialog1.execute then
  begin
   Case LoadSoundRG.ItemIndex of
   0:InfoString:= OpenDialog1.filename; {Info}
   1:ConfirmationString:= OpenDialog1.filename;{ Confirmation}
   2:WarnString:= OpenDialog1.filename;{Warn}
   3:ErrorString:= OpenDialog1.filename;{Error}
   4:DoneString:= OpenDialog1.filename;{Done}
   end;{case}
  end;
end;

procedure TOptionsForm.ThumbBtnClick(Sender: TObject);
begin
  TransSearchDir:= ThumbPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
  begin
    ThumbPath := TransSearchDir;
    ThumbEdit.Text := ThumbPath;
  end;
end;

procedure TOptionsForm.SizeUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
If ((Button = btNext) and  (SizeUpDown.Position <287)) then
   begin
   Shape1.Width:=SizeUpDown.Position+1;
   Shape1.Height:=SizeUpDown.Position+1;
   end   else  {287w 190h}
If ((Button = btPrev) and  (SizeUpDown.Position >2)) then
   begin
   Shape1.Width:=SizeUpDown.Position-1;
   Shape1.Height:=SizeUpDown.Position-1;
   end;
end;

procedure TOptionsForm.FillColorBtnClick(Sender: TObject);
begin
  ColorDialog1.Color:=ThumbColor;
  if ColorDialog1.Execute then
      ThumbColor:=ColorDialog1.Color;
  Shape1.Brush.Color:=ThumbColor;
end;

procedure TOptionsForm.UseThumbnailsCBClick(Sender: TObject);
begin
  ThumbnailsUsed:=(not ThumbnailsUsed);
  UseThumbnailsCB.Checked:=ThumbnailsUsed;
end;

procedure TOptionsForm.ExtOpenClick(Sender: TObject);
var
ExtFileName:String;
begin

Case ExtensionSetRG.ItemIndex of
0:ExtFileName:='Grafext.et0';
1:ExtFileName:='Grafext.et1';
2:ExtFileName:='Grafext.et2';
3:ExtFileName:='Grafext.et3';
4:ExtFileName:='Grafext.et4';
5:ExtFileName:='Grafext.et5';
6:ExtFileName:='Grafext.et6';
end;{case}
If FileExists(ProgramPath+ExtFileName) then
  ExtMemo.Lines.LoadFromFile(ProgramPath+ExtFileName)
  else
  begin
  TempMsgName:=ProgramPath+ExtFileName;
  DoMessages(30002);{30002, "Error opening file "}
  end;
end;

procedure TOptionsForm.ClearExtBtnClick(Sender: TObject);
begin
  ExtMemo.Clear;
end;

procedure TOptionsForm.ExtSaveClick(Sender: TObject);
var
ExtFileName:String;
begin
Case ExtensionSetRG.ItemIndex of
0:ExtFileName:='Grafext.et0';
1:ExtFileName:='Grafext.et1';
2:ExtFileName:='Grafext.et2';
3:ExtFileName:='Grafext.et3';
4:ExtFileName:='Grafext.et4';
5:ExtFileName:='Grafext.et5';
6:ExtFileName:='Grafext.et6';
end;{case}
  ExtMemo.Lines.SaveToFile(ProgramPath+ExtFileName)
end;

procedure TOptionsForm.ExtDefaultsClick(Sender: TObject);
Begin
Case ExtensionSetRG.ItemIndex of
0:begin
{ExtMemo}
  ExtMemo.Lines.Add('*.vrm');
  ExtMemo.Lines.Add('*.dlg');
  ExtMemo.Lines.Add('*.shp');
  ExtMemo.Lines.Add('*.shx');
  ExtMemo.Lines.Add('*.sbx');
  ExtMemo.Lines.Add('*.sbx');
  ExtMemo.Lines.Add('*.dxf');
  ExtMemo.Lines.Add('*.3ds');
  {Actors .. other 3D Vector file types}
end;
1:begin
  ExtMemo.Lines.Add('*.raw');
    {.$ifdef PortableNetworkGraphic}
  ExtMemo.Lines.Add('*.png');
    {.$endif}
    // internally register Delphi's "built in" formats,
    //these will not be unregistered on exit and
    // also not registered with TPicture
    //(because they are already or will soon be)
  {ExtMemo.Lines.Add('*.png');}
  ExtMemo.Lines.Add('*.bmp');
  ExtMemo.Lines.Add('*.ico');
  ExtMemo.Lines.Add('*.wmf');
  ExtMemo.Lines.Add('*.emf');
  ExtMemo.Lines.Add('*.jfif');
  ExtMemo.Lines.Add('*.jpg');
  ExtMemo.Lines.Add('*.jpe');
  ExtMemo.Lines.Add('*.jpeg');

   // Dev IL Formats... NOT in Graphex

    // register our own formats
  ExtMemo.Lines.Add('*.rle');
  ExtMemo.Lines.Add('*.dib');


    {.$ifdef TargaGraphic}
  ExtMemo.Lines.Add('*.win');
  ExtMemo.Lines.Add('*.vst');
  ExtMemo.Lines.Add('*.vda');
  ExtMemo.Lines.Add('*.tga');
  ExtMemo.Lines.Add('*.icb');
    {.$endif}

    {.$ifdef TIFFGraphic}
  ExtMemo.Lines.Add('*.tiff');
  ExtMemo.Lines.Add('*.tif');
  ExtMemo.Lines.Add('*.fax');
      {.$ifdef EPSGraphic}
  ExtMemo.Lines.Add('*.eps');
      {.$endif}
    {.$endif}

    {.$ifdef PCXGraphic}
  ExtMemo.Lines.Add('*.pcx');
  ExtMemo.Lines.Add('*.pcc');
  ExtMemo.Lines.Add('*.scr');
    {.$endif}

    {.$ifdef RLAGraphic}
  ExtMemo.Lines.Add('*.rpf');
  ExtMemo.Lines.Add('*.rla');
    {.$endif}

    {.$ifdef SGIGraphic}
  ExtMemo.Lines.Add('*.sgi');
  ExtMemo.Lines.Add('*.rgba');
  ExtMemo.Lines.Add('*.rgb');
  ExtMemo.Lines.Add('*.bw');
    {.$endif}

    {.$ifdef PhotoshopGraphic}
  ExtMemo.Lines.Add('*.psd');
  ExtMemo.Lines.Add('*.pdd');
    {.$endif}

    {.$ifdef PortableMapGraphic}
  ExtMemo.Lines.Add('*.ppm');
  ExtMemo.Lines.Add('*.pgm');
  ExtMemo.Lines.Add('*.pbm');
    {.$endif}

    {.$ifdef AutodeskGraphic}
  ExtMemo.Lines.Add('*.cel');
  ExtMemo.Lines.Add('*.pic');
    {.$endif}

    {.$ifdef PCDGraphic}
  ExtMemo.Lines.Add('*.pcd');
    {.$endif}

    {$ifdef GIFGraphic}
  ExtMemo.Lines.Add('*.gif');
    {$endif}

    {.$ifdef CUTGraphic}
  ExtMemo.Lines.Add('*.cut');
    {.$endif}

    {.$ifdef PaintshopProGraphic}
  ExtMemo.Lines.Add('*.psp');
    {.$endif}
end;
2:begin
  ExtMemo.Lines.Add( '*.htf');
  ExtMemo.Lines.Add( '*.bin');
  ExtMemo.Lines.Add( '*.bit');
  ExtMemo.Lines.Add( '*.bt');
  ExtMemo.Lines.Add( '*.ddf');
  ExtMemo.Lines.Add( '*.dem');
  ExtMemo.Lines.Add( '*.dt0');
  ExtMemo.Lines.Add( '*.dt1');
  ExtMemo.Lines.Add( '*.dt2');
  ExtMemo.Lines.Add( '*.dt3');
  ExtMemo.Lines.Add( '*.dt4');
  ExtMemo.Lines.Add( '*.dt5');
  ExtMemo.Lines.Add( '*.grd');
  ExtMemo.Lines.Add( '*.hgt');
  ExtMemo.Lines.Add( '*.xyz');

end;
3:begin   {Trash}
  ExtMemo.Lines.Add(      '*.tmp');
  ExtMemo.Lines.Add(      '~*.*');
  ExtMemo.Lines.Add(      '*.~*');
  ExtMemo.Lines.Add(      '*.?~?');
  ExtMemo.Lines.Add(      '*.aps');
  ExtMemo.Lines.Add(      '*.bak');
  ExtMemo.Lines.Add(      '*.bk?');
  ExtMemo.Lines.Add(      '*.bsc');
  ExtMemo.Lines.Add(      '*.dmp');
  ExtMemo.Lines.Add(      '*.dsm');
  ExtMemo.Lines.Add(      '*.ilk');
  ExtMemo.Lines.Add(      '*.pch');
  ExtMemo.Lines.Add(      '*.rws');
  ExtMemo.Lines.Add(      '*.sbr');
  ExtMemo.Lines.Add(      'backup*.wbk');
  ExtMemo.Lines.Add(      '*.fts');
  ExtMemo.Lines.Add(      '*.gid');
  ExtMemo.Lines.Add(      '*.$$$');
end;
4:begin  {Words}
  ExtMemo.Lines.Add(      '*.doc');
  ExtMemo.Lines.Add(      '*.txt');
  ExtMemo.Lines.Add(      '*.wpd');
  ExtMemo.Lines.Add(      '*.html');
  ExtMemo.Lines.Add(      '*.htm');
  ExtMemo.Lines.Add(      '*.pdf');
end;
5:begin  {Mine}
  ExtMemo.Lines.Add(      '*.db');
  ExtMemo.Lines.Add(      '*.dbf');
end;
6:begin {Other}
  ExtMemo.Lines.Add(      '*.raw');
  ExtMemo.Lines.Add(      '*.dat');
  ExtMemo.Lines.Add(      '*.bin');
  ExtMemo.Lines.Add(      '*.exe');
  ExtMemo.Lines.Add(      '*.zip');
  ExtMemo.Lines.Add(      '*.hlp');
  ExtMemo.Lines.Add(      '*.chm');
end;
end;
end;

procedure TOptionsForm.ILHBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'ILH Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := ILHProgram;
  OpenDialog1.Filename:='ilh.exe';
  if OpenDialog1.execute then
  begin
    ILHProgram := (OpenDialog1.filename);
    ILHEdit.Text := ILHProgram;
  end;
end;

procedure TOptionsForm.LifeBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Life Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := LifePath;
  OpenDialog1.Filename:='Life.exe';
  if OpenDialog1.execute then
  begin
    LifePath := (OpenDialog1.filename);
    LifeEdit.Text := LifePath;
  end;
end;

procedure TOptionsForm.Fractal3DBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Fractal3D Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := Fractal3DPath;
  OpenDialog1.Filename:='Fractl3D.exe';
  if OpenDialog1.execute then
  begin
    Fractal3DPath := (OpenDialog1.filename);
    Fractal3DEdit.Text := Fractal3DPath;
  end;
end;

procedure TOptionsForm.DTMBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'DTM Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := DTMPath;
  OpenDialog1.Filename:='dtm.exe';
  if OpenDialog1.execute then
  begin
    DTMPath := (OpenDialog1.filename);
    DTMEdit.Text := DTMPath;
  end;
end;

procedure TOptionsForm.TracerBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Tracer Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := DigitizerPath;
  OpenDialog1.Filename:='Tracer.exe';
  if OpenDialog1.execute then
  begin
    DigitizerPath := (OpenDialog1.filename);
    TracerEdit.Text := DigitizerPath;
  end;
end;

procedure TOptionsForm.VoiceBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Voice Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := VoicePath;
  OpenDialog1.Filename:='Voice.exe';
  if OpenDialog1.execute then
  begin
    VoicePath := (OpenDialog1.filename);
    VoiceEdit.Text := VoicePath;
  end;
end;

procedure TOptionsForm.GripIceBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'GripIce Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := RasterPath;
  OpenDialog1.Filename:='grip.exe';
  if OpenDialog1.execute then
  begin
    RasterPath := (OpenDialog1.filename);
    GripIceEdit.Text := RasterPath;
  end;
end;

procedure TOptionsForm.SOSMAPBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'SOSMAP Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := SOSMAPPath;
  OpenDialog1.Filename:='sosmap.exe';
  if OpenDialog1.execute then
  begin
    SOSMAPPath := (OpenDialog1.filename);
    SOSMAPEdit.Text := SOSMAPPath;
  end;
end;

procedure TOptionsForm.VRGISBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'VRGIS Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := VRGISPath;
  OpenDialog1.Filename:='vrgis.exe';
  if OpenDialog1.execute then
  begin
    VRGISPath := (OpenDialog1.filename);
    VRGISEdit.Text := VRGISPath;
  end;
end;

procedure TOptionsForm.NoNamePathBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'NoName Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := NoNamePath;
  OpenDialog1.Filename:='*.exe';
  if OpenDialog1.execute then
  begin
    NoNamePath := (OpenDialog1.filename);
    NoNameEdit.Text := NoNamePath;
  end;
end;









procedure TOptionsForm.MapContoursColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=HighlightColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    MapContoursColorPanel.Color := ColorDialog1.Color;
    MapContoursColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.MapBackColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=MapBackColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    MapBackColorPanel.Color := ColorDialog1.Color;
    MapBacksColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.MapDataColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=MapDataColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    MapDataColorPanel.Color := ColorDialog1.Color;
    MapDatasColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.MapGridColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=MapGridColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    MapGridColorPanel.Color := ColorDialog1.Color;
    MapGridsColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.CurrentColorPanelClick(Sender: TObject);
begin
    ColorDialog1.Color:=CurrentColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    CurrentColorPanel.Color := ColorDialog1.Color;
    CurrentColor := ColorDialog1.Color;
  end;
end;

procedure TOptionsForm.GraphexFilterBoxChange(Sender: TObject);
begin
  GraphexFilter:=  GraphexFilterBox.ItemIndex;
end;

end.
